<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+


/** 
 * Interface to HTML rendable objects
 *
 * Inherit from this class to define the public functions
 * that render in HTML format your class attributes. <p>Remember:
 * this is an "interface" only. You must redifine all functions input  
 * in your children!</p>
 * @package interfaces
 */
 
 include_once(XOOPS_ROOT_PATH."/modules/forum/include/functions.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/Category.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/Forum.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/Post.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/Tools.php");
 include_once(XOOPS_ROOT_PATH."/class/xoopsformloader.php");
 include_once(XOOPS_ROOT_PATH."/class/xoopstree.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/QueriesForum.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/QueriesPost.php");


class RenderPost
{

    var $post;
    var $accessibility = false;

    /**#@+
     * @access public
     */
     
     
    function RenderPost ( $id = null )
    {
        global $R_URI;
        if ( empty ($id))
        {
            $this->setPost ( new Post() );
        }
        else
        {
            $this->setPost($id);
        }
        
        if (ereg("accessibile",$R_URI)!= 0 ) $this->setAccessibility(true);
    }
    
    function setAccessibility( $on_off )
    {
     	$this->accessibility = $on_off;
    }
    
    function setPost ( $post )
    {
        $this->forum = $post;
    }
    
    function getVar ( $varname, $format='S' )
    {
        return $this->forum->getVar($varname, $format);
    }

	

	function postListTitle($title)
    {
   
   		return '<h1 class="post_list_title">'._MD_FORUM_POST_LISTTITLE." ".$title.'</h1>';
	}
	
    function navMenu($fid)
    {
        
        global $_GET,$xoopsUser,$forumConfig;
        $forum = new Forum($fid);
        
        $ret =	 '<div class="forum_navmenu">';
        
        $ret .=	 '<a href="index.php" title="'._MD_FORUM_FORUM_BACKCATEGORY.'" onMouseOver="Prepare(this);" tipo="img">';
        $ret .=	 _MD_FORUM_FORUM_BACKCATEGORY;
        $ret .=	 '</a>'."\n";
        
        if ($forumConfig['track_visits'] && $xoopsUser && !$this->accessibility)
        {
		 $ret .=	 ' | <a href="forum.php?op=visited&amp;fid='.$fid.'" title="'._MD_FORUM_FORUM_SETVISITED.'" onMouseOver="Prepare(this);" tipo="img">';
         $ret .=	 _MD_FORUM_FORUM_SETVISITED;
         $ret .=	 '</a>'."\n";
        }
        
            
        if ( (!$xoopsUser && $forum->getVar('anon_posting')) || $xoopsUser )
        {
            $ret .=  ' | ';
            $ret .=	 '<a href="post.php?op=new&amp;forum_id='.$fid.'"  title="'._MD_FORUM_POST_NEWPOST.'" onMouseOver="Prepare(this);" tipo="img">';
            $ret .=	 _MD_FORUM_POST_NEWPOST;
            $ret .=	 '</a>'."\n";
        }
        
        
        $ret .=  '</div>'."\n";
        
        return $ret;
    }

    function postListByDbResource( $mysqlresource )
    {
        global $db;
        
        $ret = '<div class="post_list">';
        

        // Check if database is empty
		if ( $db->num_rows($mysqlresource) < 1 ) 
		{
            $ret .= '<h2>'. _MD_FORUM_NOPOST .'</h2>'."\n";
        } 
        else 
        {
	   		 //$ret .= '<ul>'."\n";
	   		 while ( $post_data = $db->fetch_array($mysqlresource) ) 
	   		 {
                $post = new Post ( $post_data );
                $this->setPost( $post );
                $ret .= '<div id=\'topic_'.$this->getVar('post_id').'\' ';
				$ret .= ' onmouseover="changeClassName(this.id,\'post_list_'.$this->getVar('post_id').'\',\'post_item_over\',\'post_item_over\')" ';
				$ret .= ' onmouseout="changeClassName(this.id,\'post_list_'.$this->getVar('post_id').'\',\'post_item\',\'post_item_over\')" ';
				$ret .= 'class="post_item">'.$this->postItem().'</div>'."\n";
           	 }
           	 //$ret .= '</ul>'."\n";
    	} 

        $ret .= '</div>'."\n";
        
        return $ret;
    
    }

    function postItem ()
    {
    
      	global $xoopsModule,$xoopsUser,$forumConfig;
      	$ret ="";
      	
      	
		// Top Action Menu
		
		$ret .= $this->postTopActionMenu();
	 	
	 	// Subject
		$ret .= '<div id=\'post_'.$this->getVar('post_id').'\' onclick="changeDisplay(\'post_list_'.$this->getVar('post_id').'\')" ';
		$ret .= ' onmouseover="changeClassName(this.id,\'post_list_'.$this->getVar('post_id').'\',\'post_list_title_block_over\',\'post_list_title_block_over\')" ';
		$ret .= ' onmouseout="changeClassName(this.id,\'post_list_'.$this->getVar('post_id').'\',\'post_list_title_block\',\'post_list_title_block_over\')" ';
		$ret .= ' class="post_list_title_block">';
		$ret .= '<div class="post_item_image">';
		if (($this->getVar('post_icon') != "") && ($this->getVar('post_icon') != "-------------")) 
			$ret.= '<img src="'.XOOPS_URL.'/modules/forum/images/icons/'.$this->getVar('post_icon').'">';
		else
			$ret .= '<img src="images/icons/dummy_post.png">';
		$ret .= '</div>';
	 	$ret .=	'<div class="post_item_subject"><strong>';
		$ret .= _MD_FORUM_POST_SUBJECT."</strong> ";
		$ret .= $this->getVar("subject");

		$ret .= '</div>'."\n";

		$ret .=	'<div class="post_item_date"><strong>';
		$ret .= _MD_FORUM_POST_DATE."</strong> ".formatTimestamp($this->getVar ('post_time'),"m");
	    $lastpost = new Post(QueriesPost::lastPostByRootId($this->getVar ('post_id')));

		$uid = $xoopsUser ? $xoopsUser->uid() : 0;
		$msg_topic=QueriesPost::numOfUnreadPosts ($uid,"topic",$lastpost->getVar("root_id"),$this->getVar('post_id'));


		if($msg_topic['msg_unread']>0){

             $ret .= '<span class="forum_item_last_post_new"> (';
			 $ret .= _MD_FORUM_FORUM_NEW_MSG.' '.$msg_topic['msg_unread'];
			 $ret .= ')</span>';
		}

		$ret .= '</div>';

		$ret .= '</div>';
		
		// Post details block start
				
    	$ret .= '<script type="text/javascript">document.write(\'<div class="post_list_details_block" id="post_list_'.$this->getVar('post_id').'">\')</script>';
	
		$ret .= '<noscript><div class="post_list_details_block" style="display:block;"></noscript>';

		// User info
		$ret .= '<div class="post_item_user_block">';
		
		
        if (!$this->accessibility)
        {
            $uid = $this->getVar("user_id");
            if ( $uid != 0 )
            {
             // Registered user
             $user = new XoopsUser ($uid);
             
             
                $ret .= '<strong class="post_item_user_name">';
                $ret .= '<a href="'.XOOPS_URL.'/userinfo.php?uid='.$user->uid().'"';
                $ret .= '   title="'._MD_FORUM_POST_USERLINK.' '.$user->uname().'" onMouseOver="Prepare(this);" tipo="img">';
            
                $ret .= $user->uname();
                $ret .= '</a>'; 
                $ret .= '</strong>'."\n";
             
//                $ret .= "<br />\n";
//                $ret .= '<div class="post_item_user_img" style="background-image: url(';
//                $ret .= XOOPS_URL.'/images/avatar/'.$user->user_avatar().'); background-repeat:no-repeat;">';
//                $ret .= "&nbsp;";
//                $ret .= '</div>';
                //$ret .= '<img class="post_item_user_img" ';
                //$ret .= '     src="'.XOOPS_URL.'/images/avatar/'.$user->user_avatar().'" alt="'._MD_FORUM_POST_AVATAR_ALT.'" />';
                $ret .= "<br />\n";
                $rank= $user->rank();
                $ret .= '<em class="post_item_user_rank">'.$rank['title'];
                $ret .= '<br /> <img src="'.XOOPS_URL.'/images/ranks/'.$rank['image'].'" ' ;
                $ret .= ' alt="'._MD_FORUM_POST_AVATAR_ALT.'" longdesc="'._MD_FORUM_POST_AVATAR_ALT.'"/>';
                $ret .='</em>';
             //$ret .= '</a>'; 
             
            }
            else
            {
             // Anonymous user
             $ret .= '<strong class="post_item_user_name">';
             $ret .= _MD_FORUM_POST_USER_ANONYMOUS;
             $ret .= '</strong>'."\n";
             $ret .= "<br /><br /><br />\n";
            }
            $ret .= '</div>';
	 	}

		
		// Num of posts
		$numposts = QueriesPost::numOfPostsByRootId($this->getVar ('post_id'));
		$ret .=	'<div class="post_item_numposts"><strong>';
		$ret .= _MD_FORUM_POST_NUMPOSTS."</strong> ".$numposts;
		$ret .= '</div>';
		
		// Num of visits
		$numvisits = QueriesPost::numOfVisitsByRootId($this->getVar ('post_id'));
		$ret .=	'<div class="post_item_numvisits"><strong>';
		$ret .= _MD_FORUM_POST_NUMVISITS."</strong> "; 
		if ($numvisits > 0 && !$this->accessibility)
		{
		 $ret .= '<a href="#post_'.$this->getVar ('post_id').'" title="'._MD_FORUM_VISITS_A_TITLE.'" onMouseOver="Prepare(this);" tipo="img"';
		 $ret .= ' onClick="openWithSelfMain(\'visits_popup.php?post_id='.$this->getVar("post_id").'\' ';
		 $ret .= ',\'list\','.$forumConfig['popup_visit_width'].',';
		 $ret .= $forumConfig['popup_visit_height'].');">';
		 $ret .= $numvisits .' '._MD_FORUM_VISITS_VIEW ;
		 $ret .= '</a>';
		}
		else
		{
		 $ret .= $numvisits;
		}
		 $ret .= '</div>';
		
		// Date last response
		if ($numposts > 0)
		{
		
		  $lastpost = new Post(QueriesPost::lastPostByRootId($this->getVar ('post_id')));
		  $lastpost_time = formatTimestamp($lastpost->getVar('post_time'),"m");
		  $lastpost_user_id = $lastpost->getVar('user_id');
		  
		  if ($lastpost_user_id) 
		  {
		   $lastpost_user = new XoopsUser ($lastpost->getVar('user_id'));
		   $lastpost_user = $lastpost_user->uname();
		  }
		  else
		  {
		   	$lastpost_user = _MD_FORUM_POST_USER_ANONYMOUS;
		  }
		  
/*		  if ( $forumConfig['track_visits'] && $lastpost->isUnread() )
            {
             $ret .= '<div class="post_item_lastdate_new">';
             
            }
            else
            {
*/             $ret .= '<div class="post_item_lastdate">';
             
//            }
		  
		  //$ret .=	'<div class="post_item_lastdate">';
		  $ret .= "<strong>"._MD_FORUM_POST_LASTDATE."</strong> ";
		  $ret .= '<a href="post.php?post_id='.$lastpost->getVar('post_id').'#post_item_'.$lastpost->getVar('post_id').'"';
		  $ret .= '	title="'._MD_FORUM_POST_VISIT." '".$lastpost->getVar('subject')."'".'" onMouseOver="Prepare(this);" tipo="img">';  
		  $ret .= $lastpost_time." (".$lastpost_user.")";
		  $ret .= '</a>';
		  $ret .= '</div>';
		  
		}

		// Action Menu
		
		$ret .= $this->postActionMenu();

		// Post Details block end
		
		$ret .= "</div>";		
		
    	return $ret;
    
    }

    function postNoPidError()
    {
     	if (!$this->accessibility)
           redirect_header('forum.php', 3, _MD_FORUM_POST_NOPIDERROR);	
        else
           redirect_header_acc('forum.php', 3, _MD_FORUM_POST_NOPIDERROR);	
        exit();
    }
    
    function postPidError()
	{
	 	if (!$this->accessibility)
           redirect_header('index.php', 3, _MD_FORUM_POST_NOPIDERROR);
        else
           redirect_header_acc('index.php', 3, _MD_FORUM_POST_NOPIDERROR);
        exit();
	}
	
	function postNoFidError()
	{
		if (!$this->accessibility)
           redirect_header('index.php', 3, _MD_FORUM_POST_NOFIDERROR);
        else
           redirect_header_acc('index.php', 3, _MD_FORUM_POST_NOFIDERROR);
        exit();
	}
	
	function postNoAttachError()
	{
		if (!$this->accessibility)
           redirect_header('index.php', 3, _MD_FORUM_POST_NOATTACHERROR);
        else
           redirect_header_acc('index.php', 3, _MD_FORUM_POST_NOATTACHERROR);
        exit();
	}

	function postFidError()
	{
	 	if (!$this->accessibility)
           redirect_header('index.php', 3, _MD_FORUM_POST_FIDERROR);
        else
           redirect_header_acc('index.php', 3, _MD_FORUM_POST_FIDERROR);
        exit();
	}
	
	function groupAccessError()
	{
	 	if (!$this->accessibility)
           redirect_header('index.php', 3, _MD_FORUM_POST_NOACCESS);
        else
           redirect_header_acc('index.php', 3, _MD_FORUM_POST_NOACCESS);
		exit();
	}
	
	
	function inputForm ()
    {
        global $xoopsUser, $xoopsModule, $db,$_GET,$_POST,$forumConfig;
        $current_start=0;
        if (!empty($_GET['start'])) 
		{
   		 $current_start = intval($_GET['start']);
		}  
		elseif (!empty($_POST['start'])) 
		{
   		 $current_start = intval($_POST['start']);
		}  

        
        if (!$this->accessibility)
        {

            $post_id_hidden     = new XoopsFormHidden("post_id", $this->getVar('post_id'));
            $forum_id_hidden    = new XoopsFormHidden("forum_id", $this->getVar('forum_id'));
            $parent_id_hidden   = new XoopsFormHidden("parent_id", $this->getVar('parent_id'));
            $root_id_hidden   	= new XoopsFormHidden("root_id", $this->getVar('root_id'));
            $subject_text 	    = new XoopsFormText(_MD_FORUM_POST_FORM_SUBJECT, "subject", 26, 255, $this->getVar('subject','N')  );
	        $icon 				= new XoopsFormSelectIcon(_MD_FORUM_POST_FORM_ICON,"post_icon",$this->getVar('post_icon','E'),"","/modules/forum/images/icons/","dummy_post.png");
			$file_box			= new XoopsFormElementTray(_MD_FILEATTACH,"&nbsp;");
					$file_name	= new XoopsFormFile("","file_name",$forumConfig['max_fileattach_size']);
								$file_name->setExtra('size=50');
					$file_perms = new XoopsFormLabel("<br>","<p><b>"._MD_FILEATTACH_SIZE.":</b> ".$forumConfig['max_fileattach_size']." bytes<p>"."<b>"._MD_FILEATTACH_EXT.":</b> ".$forumConfig['fileattach_ext']."<p>");
					$file_box->addElement($file_name);
					$file_box->addElement($file_perms);
            $contents_text      = new XoopsFormDhtmlTextArea(_MD_FORUM_POST_FORM_CONTENT, 'contents', $this->getVar('contents','E'));
            
            // User ID
            $uid = $this->getVar('user_id');
            
            if (empty ($uid))
            {
               if (!$xoopsUser) 
               {
                $uid = 0; // Anonymous
               }
               else
               {
                    $uid = $xoopsUser->uid();
               }
            }
            $user_id		= new XoopsFormHidden("user_id", $uid );
            
            $op_hidden     	= new XoopsFormHidden("op", "validate");
            
            $start_hidden	= new XoopsFormHidden("start", $current_start);
            $submit_button	= new XoopsFormButton("", "submit", _SUBMIT, "submit");
            
            $required = array ("subject");
            
            $reg_form = new XoopsThemeForm(_MD_FORUM_POST_FORM, "forum_post", "post.php");

			$reg_form->setExtra('enctype="multipart/form-data"');
            $reg_form->addElement($post_id_hidden);
            $reg_form->addElement($forum_id_hidden);
            $reg_form->addElement($parent_id_hidden);
            $reg_form->addElement($root_id_hidden);
            $reg_form->addElement($user_id);
            $reg_form->addElement($subject_text);
            $reg_form->addElement($icon);
            $reg_form->addElement($file_box);
            $reg_form->addElement($contents_text);
            $reg_form->addElement($op_hidden);
            $reg_form->addElement($start_hidden);
            $reg_form->addElement($submit_button); 
            
            $reg_form->setRequired($required);
            
            echo $this->navMenuNewPost();
            $reg_form->display();
        }
        else
        {
            $uid = $this->getVar('user_id');
            
            if (empty ($uid))
            {
               if (!$xoopsUser) 
               {
                $uid = 0; // Anonymous
               }
               else
               {
                    $uid = $xoopsUser->uid();
               }
            }
        
            echo '
        	<h4>Invia messaggio</h4>
	        <form name="forum_post" id="forum_post" action="post.php" method="post">
                
                <label>'._MD_FORUM_POST_FORM_SUBJECT.'</label>
                    <input type="text" class="text" name="subject" id="subject" size="26" maxlength="255" accesskey="s" value="'.$this->getVar('subject','E').'" />
                <br />  
                <label>'._MD_FORUM_POST_FORM_CONTENT.'</label>
	            <textarea class="textarea" id="contents" name="contents" cols="52" rows="10" accesskey="c">'.$this->getVar("contents","E").'</textarea>
                <br />
                <input type="hidden" name="op" id="op" value="validate" />
                <input type="hidden" name="user_id" id="op" value="'.$uid.'" />
                <input type="hidden" name="start" id="start" value="'.$current_start.'" />
                <input type="hidden" name="post_id" id="op" value="'.$this->getVar('post_id').'" />
                <input type="hidden" name="forum_id" id="op" value="'.$this->getVar('forum_id').'" />
                <input type="hidden" name="parent_id" id="op" value="'.$this->getVar('parent_id').'" />
                <input type="hidden" name="root_id" id="op" value="'.$this->getVar('root_id').'" />
                <input type="submit" class="button" name="submit" id="submit" value="Invia!" accesskey="o"/>
            </form>';

        
        }
    
    
    } 

     function navMenuNewPost()
    {
        global $_GET;
        
        
        $ret =	 '<div class="post_navmenu">';
        
        if ( !empty($_GET['forum_id']) )
        {
         $forum_id = intval($_GET['forum_id']);
        }
        else
        {
         $forum_id = $this->getVar('forum_id');
        }
        
        
        $ret .=	 '<a href="index.php" title="'._MD_FORUM_POST_BACKMENU.'" onMouseOver="Prepare(this);" tipo="img">';
        $ret .=	 _MD_FORUM_POST_BACKMENU;
        $ret .=	 '</a> | ';
        $ret .=	 '<a href="forum.php?fid='.$forum_id.'" title="'._MD_FORUM_POST_BACKLIST.'" onMouseOver="Prepare(this);" tipo="img">';
        $ret .=	 _MD_FORUM_POST_BACKLIST;
        $ret .=	 '</a>';
        
        $root_id = $this->getVar('root_id');
        
        if (!empty ($root_id) )
        {
         $ret .=	 ' | ';
         $ret .=	 '<a href="post.php?post_id='.$root_id.'" title="'._MD_FORUM_POST_BACKPOST.'" onMouseOver="Prepare(this);" tipo="img">';
         $ret .=	 _MD_FORUM_POST_BACKPOST;
         $ret .=	 '</a>';
		
        
        }
        
        $ret .=  '</div>'."\n";
        
        return $ret;
    }
    
    
    function storeError()
    {
        global $_POST;
        
        if (!$accesibility)
		   redirect_header('post.php?forum_id='.intval($_POST['forum_id']), 3, _MD_FORUM_POST_STORE_ERROR);
		else
		   redirect_header_acc('post.php?forum_id='.intval($_POST['forum_id']), 3, _MD_FORUM_POST_STORE_ERROR);
        
        exit();
    }
    
    function validateErrors ($errors )
    {
        ?> <div class="post_errors">
           <h2> <?php echo _MD_FORUM_POST_ERRORS ; ?> </h2>
            <ul>
                <?php foreach ( $errors as $error ) 
                { ?>
                      <li><?php echo $error ?></li>
                      
          <?php } ?>
          
            </ul>
            </div> <?php
    }

    
    function storeDone($id)
    {
     	if (!empty($_GET['start'])) 
		{
   		 $current_start = intval($_GET['start']);
		}  
		elseif (!empty($_POST['start'])) 
		{
   		 $current_start = intval($_POST['start']);
		}  

                
        $this->accessibility ? redirect_header_acc('post.php?post_id='.$id.'&start='.$current_start, 3, _MD_FORUM_POST_STORED) : redirect_header('post.php?post_id='.$id.'&start='.$current_start, 3, _MD_FORUM_POST_STORED);
        exit();

    }
	
	function groupModeratorError($id)
	{
      $this->accessibility ? redirect_header_acc('post.php?post_id='.$id, 3, _MD_FORUM_POST_MODERATORERROR) : redirect_header('post.php?post_id='.$id, 3, _MD_FORUM_POST_MODERATORERROR);
        exit();	
	}    
    
	function groupModeratorDeleteError($id)
	{
      $this->accessibility ? redirect_header_acc('post.php?post_id='.$id, 3, _MD_FORUM_POST_MODERATORDELETEERROR) : redirect_header('post.php?post_id='.$id, 3, _MD_FORUM_POST_MODERATORDELETEERROR);
        exit();	
	}    
	
	
	function postTree($post_id, $root_id, $items_perpage, $current_start, $action="", $showflat=false)
    {
    global $db, $forumConfig, $xoopsUser;
        
        //enable/disable tree view
        $treeview = Tools::isTreeView() && !$showflat;
        $replay_order_desc = Tools::isOrderDesc();

        $forumConfig['tree_hide_contents'] ? $toggleDisplay = false : $toggleDisplay = true;

		if ($action=='open_all'){ 
			$toggleDisplay = true;
			} else if ($action=='close_all'){ 
			$toggleDisplay = false;
			}
		
		
		
        if (!$this->accessibility) 
        {
        if (!$treeview)
			{
	          $open_tag = '<div class="post_treeitem">'."\n";
    	      $close_tag ="</div>"."\n";
        	  $open_tag_item = '<div class="post_treeitem">'."\n";
		  	  $close_tag_item = "</div>"."\n";
        	} else {
	           $open_tag = '<ul class="post_treeitem">'."\n";
			   $close_tag ="</ul>"."\n";
        	   $open_tag_item = '<li class="post_treeitem">'."\n";
         	   $close_tag_item = "</li>"."\n";
            }
        } else {
	          $open_tag = "<div>"."\n";
    	      $close_tag ="</div>"."\n";
        	  $open_tag_item = "<br />"."\n";
		  	  $close_tag_item = "<br />"."\n";
				
		}
        
        
        $post = new Post($root_id);
		$render = new RenderPost($post);
				
        $tree = new XoopsTree ($db->prefix("forum_posts"),"post_id","root_id");
        
        $ret .= '<div>';
//		$ret = $render->postTreeTitle($post->getVar('subject',"S"));
		
        $ret .= '<div class="post_treeitem_root">'."\n".$render->postTreeItem(true,true)."\n".'</div>'."\n";
//        $ret .= '<div class="post_tree_block">'."\n";
        
        $replay_order_desc ? $order = 'post_time DESC' : $order = 'post_time ASC';
        $arr = $tree->getChildTreeArray($root_id, $order);
        $arr = array_slice($arr,$current_start,$items_perpage);
        $last_prefix_len = 0;
        	   
        $arr_count=0;
		
		foreach ($arr as $item) 
		{
		 
		 $current_prefix_len = strlen( $item ['prefix'] );
		 if ($treeview)
		 if ($current_prefix_len > $last_prefix_len)
		 {
		    for ($i = ($last_prefix_len-$current_prefix_len); $i<0; $i++)
			{
		        $ret .= $open_tag;
		    }
		 }
		 elseif ($current_prefix_len < $last_prefix_len)
		 {
		    for ($i = ($last_prefix_len-$current_prefix_len); $i>0; $i--)
		    {
		        $ret .= $close_tag;
		    }
           
		 }
		  // search for next post
		//  $post->set($arr[$arr_count]);
		  
		  $post->set($item);
		  $render->setPost($post);
          $this->accessibility ? $display_contents = true : $display_contents = Tools::displayContents($post_id, $post->getVar("post_id"));

 		  $uid = $xoopsUser ? $xoopsUser->uid() : 0;

		  if ($_GET['post_id']==$post->getVar("post_id")){
		  	$openPost=true;
		  	if ( $xoopsUser )
			  	QueriesPost::addVisitToPost ($post->getVar("post_id"),$uid);
		  	}
		  else
		  	$openPost=false;

		  if ($action=="open_news" || $action=="open_all"){
			if (!QueriesPost::isVisited($post->getVar("post_id"),$uid)){
			  	if ( $xoopsUser )
					QueriesPost::addVisitToPost($post->getVar("post_id"),$uid);
				$openPost=true;	
				}
		  }	else if ($action=="close_news"){
			if (!QueriesPost::isVisited($post->getVar("post_id"),$uid))
				$openPost=false;	
		  }		
          $ret .= $open_tag_item.$render->postTreeItem($toggleDisplay||$openPost).$close_tag_item;
          
		  $last_prefix_len = $current_prefix_len;
		  
		  $arr_count++;  
		}
		$ret .= $close_tag;
		$ret .= '</div>';
		return $ret;
    
    }
    
    
    function postTreeItem ( $flagDisplay=true ,$isRootPost=false)
    {
    
      	global $xoopsModule,$forumConfig,$xoopsUser,$myts;
        
		$flagDisplay ? $toggleDisplay = "block" : $toggleDisplay = "none";
        $forumConfig['show_avatar_post'] ? $showavatar = true : $showavatar = false;
        if ($this->accessibility) $showavatar = false;

	    $post_uid = $this->getVar("user_id");
	    if ( $post_uid != 0 )
	    {
	    $user = new XoopsUser ($post_uid);
		}
        
	  	$ret ="";

		// Start Title always visible DIV
		$ret .= '<div id=\'post_item_'.$this->getVar('post_id').'\'';
		if (!$isRootPost)
			$ret .= 'onclick="changeDisplay(\'post_treeitem_'.$this->getVar('post_id').'\')" '."\n";
		else
			$ret .= 'style="cursor:default;"';
		$ret .= ' onmouseover="changeClassName(this.id,\'post_treeitem_'.$this->getVar('post_id').'\',\'post_treeitem_title_block_over\',\'post_treeitem_title_block_over\'); changeClassName(\'post_item_'.$this->getVar('parent_id').'\',\'post_treeitem_'.$this->getVar('parent_id').'\',\'post_parentitem_title_block_over\',\'post_parentitem_title_block_over\')" '."\n";
		$ret .= ' onmouseout="changeClassName(this.id,\'post_treeitem_'.$this->getVar('post_id').'\',\'post_treeitem_title_block\',\'post_treeitem_title_block_over\'); changeClassName(\'post_item_'.$this->getVar('parent_id').'\',\'post_treeitem_'.$this->getVar('parent_id').'\',\'post_treeitem_title_block\',\'post_treeitem_title_block_over\')" '."\n";
		if ($flagDisplay)
			$ret .= ' class="post_treeitem_title_block_over" >'."\n";
		else
			$ret .= ' class="post_treeitem_title_block" >'."\n";
		// Start Post Icon DIV
		$ret .= '<div class="post_item_image">'."\n";
		if (($this->getVar('post_icon') != "") && ($this->getVar('post_icon') != "-------------")) 
			$ret.= '<img src="'.XOOPS_URL.'/modules/forum/images/icons/'.$this->getVar('post_icon').'">';
		else
			$ret .= '<img src="images/icons/dummy_post.png">';
		$ret .= '</div>'."\n"; // Close Post Icon DIV

		$icon_new = " <div id='img_".$this->getVar('post_id')."' class=\"post_item_image\"><img src='images/new.png'></div>";

		$uid = $xoopsUser ? $xoopsUser->uid() : 0;

        if (!QueriesPost::isVisited($this->getVar('post_id'),$uid))
           	$ret .= $icon_new;
      	
	 	// Subject
	 	$ret .=	'<div class="post_treeitem_subject" >'."\n";
        

        if (!$this->accessibility)
        {
            $ret .= $this->getVar("subject","S");
	 	}
        else
        {
           $ret .= $this->getVar("subject","S");
           if (QueriesPost::isVisited($this->getVar('post_id'),$uid))
           	$ret .= " : <strong>(new)</strong>";
        }

		$ret .= '</div>'."\n"; // Close Subject DIV
		

        $ret .=	'<div class="post_treeitem_date">'."\n";
		$ret .= '<div class="post_print_id"><strong>'.$this->getVar('post_id').'</strong></div>';
		// Author	
		if ( $this->getVar('user_id') != 0 )
		   {
		   // Registered user
		   $ret .= _MD_FORUM_POST_BY." ";
		   $ret .= '<strong>';
		   $ret .= $user->uname();
		   $ret .= '</strong>'."\n";
		   }
		   else 
		   {
		   // Anonymous user
		   $ret .= ' '._MD_FORUM_POST_BY.' <strong>';
		   $ret .= _MD_FORUM_POST_USER_ANONYMOUS;
		   $ret .= '</strong>'."\n";
		   }

		// Date
		$ret .= _MD_FORUM_POST_DATE." ".formatTimestamp($this->getVar ('post_time'),"m");
	 	    	 	
		if ($this->getVar('parent_id')!=0){
			$ret .= '<div class="post_print_id">==>&nbsp;<strong>'.$this->getVar('parent_id').'</strong>';
			$ret .= '</div>';
		}
			$ret .= '</div>'."\n"; // close Date DIV

		$ret .= '</div>'."\n"; // close post_list_title_block DIV

		// This div contents all data togglable
		// clicking on the title of subject
		// OPEN
		

		$ret .= '<script type="text/javascript">document.write(\'<div style ="display:'.$toggleDisplay.';" class="post_treeitem_details_block" id="post_treeitem_'.$this->getVar('post_id').'">\')</script>'."\n";

		$ret .= '<noscript><div class="post_treeitem_details_block" style="display:block;"></noscript>';
		
		// User info
       
        if ($showavatar)
        {
		    $ret .= '<div id="avatar_'.$this->getVar("post_id").'" class="post_treeitem_user_block">'."\n";
		
		    $post_uid = $this->getVar("user_id");
		    if ( $post_uid != 0 )
		    {
		    // Registered user
		    $user = new XoopsUser ($post_uid);
		
		    $ret .= '<strong class="post_treeitem_user_name">'."\n";
	    
			$this->accessibility ? $ret .= '<a href="'.XOOPS_URL.'/accessibile/kernel/uinfo.php?id='.$user->uid().'"'
		 						 : $ret .= '<a href="'.XOOPS_URL.'/userinfo.php?uid='.$user->uid().'"';
		    $ret .= '   title="'._MD_FORUM_POST_USERLINK.' '.$user->uname().'" onMouseOver="Prepare(this);" tipo="img">';
			   	
		    $ret .= $user->uname();
	        $ret .= "</a>"."\n";
		    $ret .= '</strong>'."\n";
		
		    $ret .= "<br />\n";
		    
		    $this->accessibility ? $ret .= '<a href="'.XOOPS_URL.'/accessibile/kernel/uinfo.php?id='.$user->uid().'"'
		 						 : $ret .= '<a href="'.XOOPS_URL.'/userinfo.php?uid='.$user->uid().'"';
			$ret .= '   title="'._MD_FORUM_POST_USERLINK.' '.$user->uname().'" onMouseOver="Prepare(this);" tipo="img">';
		    $ret .= '<img class="post_treeitem_user_img" ';
		    $ret .= '     src="'.XOOPS_URL.'/images/avatar/'.$user->user_avatar().'" alt="'._MD_FORUM_POST_AVATAR_ALT.'" longdesc="'._MD_FORUM_POST_AVATAR_ALT.'" />';
		    $ret .= "</a>";
		
		    $ret .= "<br />\n";
		    $rank= $user->rank();
		    $ret .= '<em class="post_treeitem_user_rank">'.$rank['title'];
		    $ret .= '<br /> <img src="'.XOOPS_URL.'/images/ranks/'.$rank['image'].'" ' ;
		    $ret .= ' alt="'._MD_FORUM_POST_AVATAR_ALT.'" longdesc="'._MD_FORUM_POST_AVATAR_ALT.'"/>';
		    $ret .='</em>';
		    
		    }
		    else 
		    {
		    // Anonymous user
		    $ret .= '<strong class="post_treeitem_user_name">';
		    $ret .= _MD_FORUM_POST_USER_ANONYMOUS;
		    $ret .= '</strong>'."\n";
		    $ret .= "<br />\n";
		    $ret .= '<img class="post_treeitem_user_img"';
		    $ret .= ' src="'.XOOPS_URL.'/modules/'.$xoopsModule->dirname().'/images/anonymous.gif" alt="'._MD_FORUM_POST_AVATAR_ALT.'" longdesc="'._MD_FORUM_POST_AVATAR_ALT.'"/>';		 
		    }
		
		
		
		
		
				// Num of visits
		$numvisits = QueriesPost::numOfVisitsByRootId($this->getVar ('post_id'));
		$ret .=	'<br><br><div class="post_item_numvisits"><strong>';
		$ret .= _MD_FORUM_POST_NUMVISITS.' '.$numvisits."</strong> "; 
		if ($numvisits > 0 && !$this->accessibility)
		{
		 $ret .= '<a href="#post_item_'.$this->getVar ('post_id').'" title="'._MD_FORUM_VISITS_A_TITLE.'" onMouseOver="Prepare(this);" tipo="img"';
		 $ret .= ' onClick="openWithSelfMain(\'visits_popup.php?post_id='.$this->getVar ('post_id').'\' ';
		 $ret .= ',\'list\','.$forumConfig['popup_visit_width'].',';
		 $ret .= $forumConfig['popup_visit_height'].');">';
		 $ret .= '<br>'._MD_FORUM_VISITS_VIEW ;
		 $ret .= '</a>';
		}
		else
		{
		 $ret .= $numvisits;
		}
		 $ret .= '</div>';
		
 	    $ret .= '</div>'; // Close Avatar DIV
	 	} 	
			
	
		// Contents 
		// Inserita tabella per evitare problema di tags html lasciati aperti dall'utente che inserisce il post
		// con codice html manuale
	 	$ret .=	'<div class="post_treeitem_contents">';
//		 $ret .= '<table width=100%><tr><td>';
		$ret .= $myts->makeTareaData4Show($this->getVar("contents","N"), $forumConfig['allow_html'], $forumConfig['allow_smileys'], $forumConfig['allow_bbcode']);
		
//		$ret .= '</td></tr></table>';
		$ret .= '</div>'."\n";
		
		
		// If not anonymous put the sign

		if ( $user )
		{
		 // Registered user
		 // $user = new XoopsUser ($uid);
		 if ( $user->attachsig() )
		 {
		  $ret .= '<div class="post_treeitem_usersig">';
		  $ret .= $myts->makeTareaData4Show($user->getVar("user_sig", "N"), 1, 1, 1);
		  $ret .= '</div>'."\n";
		 }
		}

		// Attached file
		if ($this->getVar("imagefilename","N")!=""){
		 	$ret .= '<div class="post_item_attachblock">';
//			$ret .= '</td></tr><tr><td><br>';
			$ufilename=$this->getVar("imagefilename","N");
			list($unique,$filename)=split('@-@',$ufilename);
			$file_ext=strtolower(strrev(substr(strrev($filename),0,strpos(strrev($filename),'.'))));

			$image_file=XOOPS_ROOT_PATH."/modules/forum/cache/attach/".$ufilename;
			$file_size=filesize($image_file);

			if (($file_ext=="jpg")||($file_ext=="png")||($file_ext=="gif")){
				list($width, $height, $type, $attr) = getimagesize($image_file);
				$icon_height=intval(110*$height/$width);
				$icon_width=110;
				$width+=20;
				$height+=20;
			} else {
				$icon_height=20;
				$icon_width=20;
				$width=120;
				$height=120;				
			}

			switch ($file_ext){
				case "jpg":
				case "png":
				case "gif":
							$icon_image = "images/image.png";
							$filetype = "img";
							break;
				case "wav":
				case "wma":
				case "mp3":
							$icon_image = "images/music.png";
							$filetype = "file";
							break;
				default:
							$icon_image = "images/compress.png";
							$filetype = "file";
							break;	
			}
//			$ret .= '<div class="post_item_attachdescription"><a href="#post_item_'.$this->getVar ('post_id').'" title="'._MD_SHOW_ATTACH.'" onClick="openWithSelfMain(\''.XOOPS_URL."/modules/forum/cache/attach/".$ufilename.'\',\'open\',\''.$width.'\',\''.$height.'\');" onMouseOver="Prepare(this,\''.$icon_width.'\',\''.$icon_height.'\');" immagine="'.XOOPS_URL."/modules/forum/cache/attach/".$ufilename.'" tipo="'.$filetype.'" size="'._MD_ATTACH_SIZE.$file_size.' bytes" type="'._MD_ATTACH_EXT.$file_ext.'">';
			$ret .= '<div class="post_item_attachdescription"><a href="#post_item_'.$this->getVar ('post_id').'" title="'._MD_SHOW_ATTACH.'" onClick="openWithSelfMain(\''.XOOPS_URL.'/modules/forum/dl_attach_popup.php?ufilename='.$ufilename.'&filename='.$filename.'\',\'open\',\''.$width.'\',\''.$height.'\');" onMouseOver="Prepare(this,\''.$icon_width.'\',\''.$icon_height.'\');" immagine="'.XOOPS_URL."/modules/forum/cache/attach/".$ufilename.'" tipo="'.$filetype.'" size="'._MD_ATTACH_SIZE.$file_size.' bytes" type="'._MD_ATTACH_EXT.$file_ext.'">';
			$ret .= '<img src="'.$icon_image.'">&nbsp;';
			$ret .= _MD_SHOW_ATTACH;
			$ret .= '</a></div>';
			$ret .= '</div>';
		}


		
		// Action Menu
		
		$ret .= $this->postTreeActionMenu();
		
		// This div contents all data togglable
		// clicking on the title of subject
		// CLOSE
		$ret .= "\n </div>\n\n"; // Close POST Block DIV
    	return $ret;
    
    }
    
    
    function postTreeActionMenu ()
    {   
        global $xoopsUser, $_GET,$_POST, $db;
        
        $current_start=0;
        if (!empty($_GET['start'])) 
		{
   		 $current_start = intval($_GET['start']);
		}  
		elseif (!empty($_POST['start'])) 
		{
   		 $current_start = intval($_POST['start']);
		}  
        
    
	    
        $ret = '<div class="post_treeitem_actionmenu">';
        
        // get post user id
        $userid = $this->getVar('user_id');
        
        // get current user id
        $current_userid = 0; // Anonymous
        if ($xoopsUser)
        {
            $current_userid = $xoopsUser->uid();
        }
        
        $forum = new Forum ($this->getVar('forum_id'));
                
		$pid=$this->getVar('post_id');
	
        // 'Replay!' action
        // User can post if:
        // - he is anonymous and the forum is open to anonymus
        // - he is moderator
        // - he has access to forum
        
        if ( $current_userid == 0 && $forum->getVar('anon_posting') 
             || ($xoopsUser && $forum->isModerator( $xoopsUser->groups() ) )
             || ($xoopsUser && $forum->hasAccess  ( $xoopsUser->groups() ) )
            )
        { 
            $ret .= '<a title="'._MD_FORUM_POST_REPLAY.'" ';
            $ret .= 'href="post.php?op=replay&amp;post_id='.$this->getVar('post_id').'&amp;start='.$current_start.'"  onMouseOver="Prepare(this);" tipo="img">';
            $ret .= _MD_FORUM_POST_REPLAY;
            $ret .= '</a>';
            $ret .= " &nbsp; ";
        }
        
        // Modify
        // - he is owner of post
        // - he is moderator
        
        if ( ($xoopsUser && $userid == $current_userid)
             || ($xoopsUser && $forum->isModerator( $xoopsUser->groups() ) )
            )
        { 
            $ret .= '<a title="'._MD_FORUM_POST_MODIFY.'" ';
            $ret .= 'href="post.php?op=modify&amp;post_id='.$this->getVar('post_id').'&amp;start='.$current_start.'"  onMouseOver="Prepare(this);" tipo="img">';
            $ret .= _MD_FORUM_POST_MODIFY;
            $ret .= '</a>';
            $ret .= " &nbsp; ";
        }
        
        // Delete
        // - he is moderator
        if ( ($xoopsUser && $forum->isModerator( $xoopsUser->groups()) ) )
        { 
            $ret .= '<a title="'._MD_FORUM_POST_DELETE.'" ';
            $ret .= 'href="post.php?op=delete&amp;post_id='.$this->getVar('post_id').'&amp;start='.$current_start.'"  onMouseOver="Prepare(this);" tipo="img">';
            $ret .= _MD_FORUM_POST_DELETE;
            $ret .= '</a>';
            $ret .= " &nbsp; ";
        }

		// CHECK IF IS FAVORITE
		$addr=XOOPS_URL.'/modules/forum/post.php?post_id='.$pid.'#post_item_'.$pid;
		$query="SELECT COUNT(*) FROM ".$db->prefix("favorites")." WHERE ((uid = ".$current_userid.") AND (url = '".$addr."'));";
		$result=$db->query($query);
        $favorite = $db->fetch_array($result);
		if (!$favorite[0] && $xoopsUser)
			$ret .= '<a href="javascript:addFavorite(\''.XOOPS_URL.'/modules/forum/post.php?post_id='.$pid.'\',\'post_item_'.$pid.'\',\''.$this->getVar('subject').'\');" title="'._ADDFAVORITE.'"  onMouseOver="Prepare(this);" tipo="img" immagine="'.XOOPS_URL.'/modules/forum/images/star.png"><img src="'.XOOPS_URL.'/modules/forum/images/star.png"><span> &nbsp; '._ADDFAV.' &nbsp; </span></a> &nbsp; ';		
        
        $ret .= '</div>';
        return $ret;
        
    }

function postActionMenu ()
    {   
        global $xoopsUser, $_GET,$_POST;
        
        $current_start=0;
        if (!empty($_GET['start'])) 
		{
   		 $current_start = intval($_GET['start']);
		}  
		elseif (!empty($_POST['start'])) 
		{
   		 $current_start = intval($_POST['start']);
		}  
        
        
        $ret = '<div class="post_treeitem_actionmenu">';
        
        // get post user id
        $userid = $this->getVar('user_id');
        
        // get current user id
        $current_userid = 0; // Anonymous
        if ($xoopsUser)
        {
            $current_userid = $xoopsUser->uid();
        }
        
        $forum = new Forum ($this->getVar('forum_id'));
                
        // Modify
        // - he is owner of post
        // - he is moderator
        
        if ( ($xoopsUser && $uid == $current_userid)
             || ($xoopsUser && $forum->isModerator( $xoopsUser->groups()) )
            )
        { 
            $ret .= '<a title="'._MD_FORUM_POST_MODIFY.'" ';
            $ret .= 'href="post.php?op=modify&amp;post_id='.$this->getVar('post_id').'&amp;start='.$current_start.'" >';
            $ret .= _MD_FORUM_POST_MODIFY;
            $ret .= '</a>';
            $ret .= " &nbsp; ";
        }
        
        // Delete
        // - he is moderator
        if ( ($xoopsUser && $forum->isModerator( $xoopsUser->groups())) )
        { 
            $ret .= '<a title="'._MD_FORUM_POST_DELETE.'" ';
            $ret .= 'href="post.php?op=delete&amp;post_id='.$this->getVar('post_id').'&amp;start='.$current_start.'" >';
            $ret .= _MD_FORUM_POST_DELETE;
            $ret .= '</a>';
            $ret .= " &nbsp; ";
        }
        
        $ret .= '</div>';
        return $ret;
        
    }


function postTopActionMenu ()
    {   
        global $xoopsUser, $_GET,$_POST;
        
        $current_start=0;
        if (!empty($_GET['start'])) 
		{
   		 $current_start = intval($_GET['start']);
		}  
		elseif (!empty($_POST['start'])) 
		{
   		 $current_start = intval($_POST['start']);
		}  
        
        
        $ret = '<div class="post_treeitem_topactionmenu" onmouseover="" onmouseout="" onclick="">';
        // get post user id
        $userid = $this->getVar('user_id');
        
        // get current user id
        $current_userid = 0; // Anonymous
        if ($xoopsUser)
        {
            $current_userid = $xoopsUser->uid();
        }
        
        $forum = new Forum ($this->getVar('forum_id'));
        
        // 'Replay!' action
        // User can post if:
        // - he is anonymous and the forum is open to anonymus
        // - he is moderator
        // - he has access to forum
        
/*        if ( (!$xoopsUser && $forum->getVar(anon_posting))
              || ($xoopsUser && $forum->isModerator( $xoopsUser->groups() ))
              || ($xoopsUser && $forum->hasAccess  ( $xoopsUser->groups() )) )
        { 
*/            $ret .= '<a title="'._MD_FORUM_POST_VISIT.'" ';
            $ret .= 'href="post.php?post_id='.$this->getVar('post_id').'&amp;start='.$current_start.'" >';
            $ret .= _MD_FORUM_POST_VISIT;
            $ret .= '</a>';
            $ret .= " &nbsp; ";
//        }
                
        $ret .= '</div>';
        return $ret;
        
    }



    function navTreeMenu($fid,$post_id)
    {
        
        global $_GET, $xoopsUser,$db;

		$forum= new Forum($fid);
		$category=new Category($forum->getVar('cid'));
		$post=new Post($post_id);
		$post_root= ($post->getVar('root_id') !=0 ) ? new Post($post->getVar('root_id')) : $post;
		
        $ret =	 '<div class="post_block_title">';
        $ret .=	 '<div class="post_navmenu">';
        
        $ret .=	 '<a href="index.php" title="'._MD_FORUM_POST_BACKCATEGORY.' : '.$category->getVar('title').'" onMouseOver="Prepare(this);" tipo="img" >';
        $ret .=	 $category->getVar('title');
        $ret .=	 '</a>'."\n";
        $ret .=  ' : ';
        $ret .=	 '<a href="forum.php?fid='.$fid.'"  title="'._MD_FORUM_POST_BACKFORUM.' : '.$forum->getVar('title').'" onMouseOver="Prepare(this);" tipo="img">';
        $ret .=	 $forum->getVar('title');
        $ret .=	 '</a>'."\n";


        $ret .=  '</div>';
        
        $ret .=  '<h1 class="post_tree_title">'._MD_FORUM_POST_TREETITLE." - ".$post_root->getVar('subject').'</h1>';

        $ret .=  '<div class="post_treeitem_actionmenu">';
        
		// TOGGLE OPEN/CLOSE ALL POST IN PAGE
		if (!empty($_GET['action']) && $_GET['action']=='open_all'){
	        $ret .=	 '<a href="post.php?post_id='.$post_id.'&action=close_all&end='.intval($_GET['end']).'&start='.intval($_GET['start']).'" title="'._MD_FORUM_POST_CLOSEALL.'" onMouseOver="Prepare(this);" tipo="img">';
    	    $ret .=	 _MD_FORUM_POST_CLOSEALL;
        	$ret .=	 '</a>'."\n";
        } else {
	        $ret .=	 '<a href="post.php?post_id='.$post_id.'&action=open_all&end='.intval($_GET['end']).'&start='.intval($_GET['start']).'" title="'._MD_FORUM_POST_OPENALL.'" onMouseOver="Prepare(this);" tipo="img">';
    	    $ret .=	 _MD_FORUM_POST_OPENALL;
        	$ret .=	 '</a>'."\n";			
		}
        $ret .=  ' &nbsp; ';

		// TOGGLE OPEN/CLOSE NEW POST IN PAGE
		if (!empty($_GET['action']) && $_GET['action']=='open_news'){
        	$ret .=	 '<a href="post.php?post_id='.$post_id.'&action=close_news&end='.intval($_GET['end']).'&start='.intval($_GET['start']).'"  title="'._MD_FORUM_POST_CLOSENEWS.'" onMouseOver="Prepare(this);" tipo="img">';
	        $ret .=	 _MD_FORUM_POST_CLOSENEWS;
    	    $ret .=	 '</a>'."\n";
        } else {
        	$ret .=	 '<a href="post.php?post_id='.$post_id.'&action=open_news&end='.intval($_GET['end']).'&start='.intval($_GET['start']).'"  title="'._MD_FORUM_POST_OPENNEWS.'" onMouseOver="Prepare(this);" tipo="img">';
	        $ret .=	 _MD_FORUM_POST_OPENNEWS;
    	    $ret .=	 '</a>'."\n";
		}
        $ret .=  ' &nbsp; ';

		// TOGGLE ONE/MULTI PAGE VIEW
		if (empty($_GET['end']) || $_GET['end']!='-1'){
	        $ret .=	 '<a href="post.php?post_id='.$post_id.'&end=-1&action='.$_GET['action'].'"  title="'._MD_FORUM_POST_SHOWALL.'" onMouseOver="Prepare(this);" tipo="img">';
    	    $ret .=	 _MD_FORUM_POST_SHOWALL;
        	$ret .=	 '</a>'."\n";
        } else {
	        $ret .=	 '<a href="post.php?post_id='.$post_id.'&end=0&action='.$_GET['action'].'"  title="'._MD_FORUM_POST_SHOWPAGE.'" onMouseOver="Prepare(this);" tipo="img">';
    	    $ret .=	 _MD_FORUM_POST_SHOWPAGE;
        	$ret .=	 '</a>'."\n";
		}
        $ret .=  ' &nbsp; ';

		// NEW TOPIC
		$forum = new Forum($fid);
        if ( (!$xoopsUser && $forum->getVar('anon_posting')) || $xoopsUser )
        {

	        $ret .=	 '<a href="post.php?op=new&forum_id='.$fid.'" title="'._MD_FORUM_POST_NEWTOPIC.'" onMouseOver="Prepare(this);" tipo="img" immagine="'.XOOPS_URL.'/modules/forum/images/page_add.png">';
    	    $ret .=	 '&nbsp;<img src="'.XOOPS_URL.'/modules/forum/images/page_add.png">&nbsp;';
        	$ret .=	 '<span> &nbsp; '._MD_FORUM_POST_NEWTOPIC1.' &nbsp; </span></a>'."\n";
		}
       	$ret .=  ' &nbsp; ';

		// PRINT THREAD
		$ret .= '<a href="#" title="'._MD_FORUM_POST_PRINTTHREAD.'" onMouseOver="Prepare(this);" tipo="img" immagine="'.XOOPS_URL.'/modules/forum/images/printer.png"';
		$ret .= ' onClick="openPrintPage(\'print_popup.php?post_id='.$post->getVar('post_id').'&action=open_all\');">';
		$ret .=	 '&nbsp;<img src="'.XOOPS_URL.'/modules/forum/images/printer.png">&nbsp;';
		$ret .= '<span> &nbsp; '._MD_FORUM_POST_PRINTTHREAD1.' &nbsp; </span></a>'."\n";
       	$ret .=  ' &nbsp; ';

		// TOGGLE MAIL NOTIFIER
if ($xoopsUser){
		    $sql = "SELECT count(*) FROM ".$db->prefix("forum_topics_mail")." WHERE (topic_id = ".$post_root->getVar('post_id').") AND (user_id = ".$xoopsUser->uid().");";
		    $result = $db->query($sql);
			$res= $db->fetch_array($result);

$js='<script type="text/javascript">
<!--
function user_notify(addr,root_id,action) {
 	win_par="'.XOOPS_URL.'/modules/forum/include/user_notify.php?op=" 
							+ action + "&root_id=" +root_id + "&url=" +addr;
	window.location.replace(win_par);
}
//-->
</script>
';

		if ($res[0]==0){
			$ret .= $js.'<a href="javascript:user_notify(\''.XOOPS_URL.'/modules/forum/post.php?post_id='.$post_id.'\',\''.$post_root->getVar('post_id').'\',\'add\');" title="'._ADDUSERNOTIFY.'"  onMouseOver="Prepare(this);" tipo="img" immagine="'.XOOPS_URL.'/modules/forum/images/email_add.png">&nbsp;<img src="'.XOOPS_URL.'/modules/forum/images/email_add.png">&nbsp;<span> &nbsp; '._ADDUSERNOTIFY1.' &nbsp; </span></a>';
			} else {
			$ret .= $js.'<a href="javascript:user_notify(\''.XOOPS_URL.'/modules/forum/post.php?post_id='.$post_id.'\',\''.$post_root->getVar('post_id').'\',\'del\');" title="'._DELUSERNOTIFY.'"  onMouseOver="Prepare(this);" tipo="img" immagine="'.XOOPS_URL.'/modules/forum/images/email_delete.png">&nbsp;<img src="'.XOOPS_URL.'/modules/forum/images/email_delete.png">&nbsp;<span> &nbsp; '._DELUSERNOTIFY1.' &nbsp; </span></a>';
			}
       	$ret .=  ' &nbsp; ';
		}

                
   $ret .=  '</div>'."\n";
   $ret .=  '</div>'."\n";
       
   return $ret;
}

	function postDeleteConfirm()
	{
        if (!$this->accessibility)
        {
            echo '<h1>'._MD_FORUM_POST_CONFRIMDELETE. " '" .$this->getVar('subject')."'</h1>\n";
            $name_label 		= new XoopsFormLabel (_MD_FORUM_POST_CONFRIMDELETE_LABELYES);
            $fid_hidden    = new XoopsFormHidden("post_id", $this->getVar('post_id'));
            $op_hidden     = new XoopsFormHidden("op", "okdelete");
            $submit_button = new XoopsFormButton("", "submit", _YES  , "submit");
            
            $reg_form = new XoopsSimpleForm("", "forum_post_deleteconfirm", "post.php");
            $reg_form->addElement($name_label);
            $reg_form->addElement($fid_hidden);
            $reg_form->addElement($op_hidden);
            $reg_form->addElement($submit_button);
            $reg_form->display();
        
            $name_label 	= new XoopsFormLabel (_MD_FORUM_POST_CONFRIMDELETE_LABELNO);
            $op_hidden     = new XoopsFormHidden("op", "");
            $cid_hidden    = new XoopsFormHidden("post_id", $this->getVar('post_id'));
            $submit_button = new XoopsFormButton("", "submit", _NO , "submit");
            
            $reg_form = new XoopsSimpleForm("", "forum_post_deletecancel", "post.php");
            $reg_form->addElement($name_label);
            $reg_form->addElement($op_hidden);
            $reg_form->addElement($cid_hidden);
            $reg_form->addElement($submit_button);
            $reg_form->display();
        }
        else
        {
            echo '<h1>'._MD_FORUM_POST_CONFRIMDELETE. " '" .$this->getVar('subject')."'</h1>\n";
             
             
            echo "<p>"._MD_FORUM_POST_CONFRIMDELETE_LABELYES;
            
            echo ' <a href="post.php?op=okdelete&amp;post_id='.$this->getVar('post_id').'" title="'._YES.' (ALT + y)" accesskey="y">'._YES.'</a>';
            
            echo '. '._MD_FORUM_POST_CONFRIMDELETE_LABELNO;
            
            echo ' <a href="post.php?post_id='.$this->getVar('post_id').'" title="'._YES.' (ALT + y)" accesskey="n">'._NO.'</a>';
            
            echo "</p>";
        }
	}
	
	function postDeleted()
	{
	 	if ($this->getVar('root_id') == 0)
	 	{
		 $this->accessibility ? redirect_header_acc("./forum.php?fid=".$this->getVar('forum_id'), 3, _MD_FORUM_POST_DELETED) : redirect_header("./forum.php?fid=".$this->getVar('forum_id'), 3, _MD_FORUM_POST_DELETED);
		}
		else
		{
		 $this->accessibility ? redirect_header_acc("./post.php?post_id=".$this->getVar('root_id'), 3, _MD_FORUM_POST_DELETED) : redirect_header("./post.php?post_id=".$this->getVar('root_id'), 3, _MD_FORUM_POST_DELETED);
		}
		exit();
	}
		
	function postDeleteError()
	{
		$this->accessibility ? redirect_header_acc("./forum.php?fid=".$this->getVar('forum_id'), 3, _MD_FORUM_POST_DELETEERROR) : redirect_header("./forum.php?fid=".$this->getVar('forum_id'), 3, _MD_FORUM_POST_DELETEERROR);
		exit();
	}
	
	function postTreeTitle($title)
    {
   
   		return '<h1 class="post_tree_title">'._MD_FORUM_POST_TREETITLE." - ".$title.'</h1>';
	}
	
	
	function visitItem ($user_id,$visit_time)
	{
	 $user = new XoopsUser ($user_id);
		 
	 $this->accessibility ? $ret  = '<a target="_blank" href="'.XOOPS_URL.'/accessibile/kernel/uinfo.php?id='.$user->uid().'"'
	 					  : $ret  = '<a target="_blank" href="'.XOOPS_URL.'/userinfo.php?uid='.$user->uid().'"';
	 $ret .= '   title="'._MD_FORUM_POST_USERLINK.' '.$user->uname().'">';
	 $ret .= '<strong class="post_treeitem_user_name">';
	 $ret .= $user->uname();
	 $ret .= '</strong></a>';
	 $ret .= ' - '.formatTimestamp($visit_time,"m");
	 $ret .= "\n";
	
	 return $ret;
	}
	
	function visitsGroupAccessError()
	{
	   echo '<h1>'._MD_FORUM_POST_NOACCESS.'</h1>';
	   echo '<p>';
	   echo '<a title="'._MD_FORUM_VISITS_CLOSE.'" href="#" onclick="window.close()">';
	   echo _MD_FORUM_VISITS_CLOSE;
	   echo '</a>';
	   echo '</p>';
	   exit();
	}
	
	function visitsPostPidError()
	{
	   echo '<h1>'._MD_FORUM_POST_NOPIDERROR.'</h1>';
	   echo '<p>';
	   echo '<a title="'._MD_FORUM_VISITS_CLOSE.'" href="#" onclick="window.close()">';
	   echo _MD_FORUM_VISITS_CLOSE;
	   echo '</a>';
	   echo '</p>';
	   exit();
	}
	
	function visitsConfirmDelete($pid)
	{
	   echo '<h1>'._MD_FORUM_POST_VISITS_CONFIRMDELETE_TITLE.'</h1>';
	   echo '<p>';
	   echo '<a title="'._MD_FORUM_POST_VISITS_CONFIRMDELETE.'" onMouseOver="Prepare(this);" tipo="img" href="visits_popup.php?op=delete&amp;post_id='.$pid.'">';
	   echo _MD_FORUM_POST_VISITS_CONFIRMDELETE;
	   echo '</a>';
	   echo '</p>';
	   echo '<p>';
	   echo '<a title="'._MD_FORUM_POST_VISITS_CONFIRMDELETE_BACK.'" onMouseOver="Prepare(this);" tipo="img" href="visits_popup.php?post_id='.$pid.'">';
	   echo _MD_FORUM_POST_VISITS_CONFIRMDELETE_BACK;
	   echo '</a>';
	   echo '</p>';
	   echo '<p>';
	   echo '<a title="'._MD_FORUM_VISITS_CLOSE.'" onMouseOver="Prepare(this);" tipo="img" href="#" onclick="window.close()">';
	   echo _MD_FORUM_VISITS_CLOSE;
	   echo '</a>';
	   echo '</p>';
	   exit();
	}
}

?>