<?php
// $Id: xml-rss.php,v 1.1 2003/08/31 12:14:43 half-dead Exp $
// ------------------------------------------------------------------------- //
//               E-Xoops: Content Management for the Masses                  //
//                       < http://www.e-xoops.com >                          //
// ------------------------------------------------------------------------- //
// Original Author: Half-Dead
// Author Website : http://www.e-xoops.com
// License Type   : Proprietary: See /manual/LICENSES/E-Xoops.txt
// ------------------------------------------------------------------------- //

if (!defined("EXOOPS_XML_RSS_INCLUDED")) {
	define("EXOOPS_XML_RSS_INCLUDED", 1);

//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
* @link{http://my.netscape.com/publish/formats/rss-spec-0.91.html}
*/
class xml_rss {

	var $buffer;
	var $count;

	var $channel_title;
	var $channel_link;
	var $channel_description;

	var $image_title;
	var $image_url;
	var $image_link;
	var $image_description;
	var $image_height;
	var $image_width;

	var $max_items;
	var $max_item_description;

	var $rss_file;

		function xml_rss($rss_file) {
		global $meta;

			$this->rss_file			= $rss_file;
			$this->channel_title		= $meta['title'];
			$this->channel_link		= XOOPS_URL . "/";
			$this->channel_description	= $meta['description'];
			$this->image_title		= $meta['title'];
			$this->image_url			= XOOPS_URL . "/images/button.gif";
			$this->image_link			= XOOPS_URL . "/";
			$this->image_description	= $meta['slogan'];
			$this->image_height		=  31;
			$this->image_width		=  88;
			$this->max_items			=  10;
			$this->max_item_description	= 200;
		}

//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function save() {

$content  = '<?xml version="1.0" encoding="'._CHARSET.'"?>';
$content .= "\n<rss version='2.0'>\n";
$content .= "<channel>\n";
$content .= "<title>".$this->cleanup($this->channel_title)."</title>\n";
$content .= "<link>".$this->channel_link."</link>\n";
$content .= "<description>".$this->cleanup($this->channel_description)."</description>\n";
$content .= "<image>\n";
$content .= "<title>".$this->cleanup($this->image_title)."</title>\n";
$content .= "<url>".$this->image_url."</url>\n";
$content .= "<link>".$this->image_link."</link>\n";
$content .= "<description>".$this->cleanup($this->image_description)."</description>\n";
$content .= "<width>".$this->image_width."</width>\n";
$content .= "<height>".$this->image_height."</height>\n";
$content .= "</image>\n";
$content .= $this->buffer;
$content .= "</channel>\n";
$content .= "</rss>";

if ( $fp = @fopen($this->rss_file, "w") ) {
	fwrite($fp, $content);
	fclose($fp);
	} else {
		return false;
	}

return true;
}

//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function build($title, $link, $desc='', $date='', $attach='', $path='', $author='', $category='') {

if ($this->count < $this->max_items) {

	if ( !empty($desc) ) {
	$description = $this->cleanup($desc, $this->max_item_description);
	}

	$this->buffer .= "<item>\n";
	$this->buffer .= "<title>".$this->cleanup($title)."</title>\n";
	$this->buffer .= "<link>".$link."</link>\n";

	if ( !empty($desc) ) {
		$this->buffer .= "<description>".$description."...</description>\n";
		}

	if (!empty($date) ) {
		$this->buffer .= "<pubDate>".$date."</pubDate>\n";
		}

	if (!empty($author) ) {
		$this->buffer .= "<author>".$author."</author>\n";
		}

	if (!empty($category) ) {
		$this->buffer .= "<category>".$category."</category>\n";
		}

	if (!empty($attach) ) {
	 	$attach_ext= strrev(substr(strrev($attach),0,strpos(strrev($attach),'.')));
	 	switch (strtolower($attach_ext)){
			case 'jpg':
					$attach_type='image/jpeg';
					break;
			case 'gif':
					$attach_type='image/gif';
					break;
			case 'tif':
			case 'tiff':
					$attach_type='image/tiff';
					break;
			case 'png':
					$attach_type='image/png';
					break;
			case 'zip':
					$attach_type='application/zip';
					break;
			case '7z':
					$attach_type='application/x-7z-compressed';
					break;
			case 'tar':
					$attach_type='application/x-tar';
					break;
			case 'gz':
					$attach_type='application/x-gzip';
					break;
			case 'bz2':
					$attach_type='application/x-bzip';
					break;
			case 'mp3':
					$attach_type='audio/mpeg';
					break;
			case 'wma':
					$attach_type='audio/x-ms-wma';
					break;
			case 'wav':
					$attach_type='audio/x-wav';
					break;
			default:
					$attach_type='multipart/mixed';
					break;
		}
		
		$attach_size=filesize(XOOPS_ROOT_PATH.$path.$attach);		
		
		$this->buffer .= "<enclosure url='".XOOPS_URL.$path.$attach."' length='".$attach_size."' type='".$attach_type."' />\n";
		}


	$this->buffer .= "</item>\n";

	$this->count++;
	}
}

//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function cleanup($text, $trim=100) {
global $myts;

	$clean = stripslashes($text);
	$clean = $myts->sanitizeForDisplay($clean,1,1,1);
//	$clean = strip_tags($clean);
	$clean = substr($clean, 0, $trim);
//	$clean = htmlspecialchars($clean, ENT_QUOTES);
return "<![CDATA[".$clean."]]>";
}

//---------------------------------------------------------------------------------------//
} // END XMLRSS

//---------------------------------------------------------------------------------------//
}
?>
