<?php
// $Id: xmlnews-parser.php,v 1.1 2003/11/11 12:14:40 Redpitt Exp $
// ------------------------------------------------------------------------- //
//               E-Xoops: Content Management for the Masses                  //
//                       < http://www.e-xoops.com >                          //
// ------------------------------------------------------------------------- //
// Original Author: Redpitt (Pietro Lascari)
// Author Website : http://www.redpitt.it
// Licence Type   : GPL: See /manual/LICENSES/GPL.txt
// ------------------------------------------------------------------------- //

/* This module reads the last news from the xml file of the E-Xoops news module
   and displays them into your site.

   Simply use the following directive to include E-Xoops news into your site:

	include(<path>"/module.news-xmlparser.php");

   <path> is the server location where you've placed this file.
*/

class XoopsParsedNews {
	var $title = array();
	var $link = array();
	var $description = array();

	function get_item($news) {
		foreach ($news as $k=>$v) {
			array_push($this->$k,$v);
		}
	}

	function render() {
		$newscount = 0;
		for ($i=0;$i<count($this->title);$i++) {
			echo '<a href="'.$this->link[$i].'">'.$this->title[$i].'</a><br />'.$this->description[$i].'<br /><br />';
			$newscount++;
		}

		if ($newscount == 0) {
			echo 'There are no news to display!';
		}
	}
}

function parse_file($xmlfile) {
	$xml = implode("",file($xmlfile));
	$parser = xml_parser_create(); 
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0); 
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1); 
	xml_parse_into_struct($parser,$xml,$values,$tags); 
	xml_parser_free($parser); 

	foreach ($tags as $key=>$val) { 
		if ($key == "item") { 
			$totnews = $val; 
			for ($i=0; $i < count($totnews); $i+=2) { 
				$offset = $totnews[$i] + 1; 
				$len = $totnews[$i + 1] - $offset; 
				parse_item(array_slice($values, $offset, $len));
			 } 
		} else { continue; } 
	} 
} 

function parse_item($item_values) { 
	for ($i=0; $i < count($item_values); $i++) {
		$news[$item_values[$i]["tag"]] = $item_values[$i]["value"]; 
		$mynews = new XoopsParsedNews(); 
		$mynews->get_item($news);
	}

	$mynews->render();
}

include("config.php");
parse_file(PARSE_URL."/modules/news/cache/news.xml");
?>