<?php
/* LINK BUILDER v. 1.0 FOR E-XOOPPORT */
// +----------------------------------------------------------------------+
// | E-XOOPPORT 2.0                                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: Redpitt <redpitt@e-xoopport.it>                             |
// +----------------------------------------------------------------------+
//

// Collecting variables...
!empty($_REQUEST['target']) ? $target = $_REQUEST['target'] : $target = '';
!empty($_REQUEST['op']) ? $op = $_REQUEST['op'] : $op = '';
!empty($_REQUEST['mdir']) ? $mdir = $_REQUEST['mdir'] : $mdir = '';
!empty($_REQUEST['protocol']) ? $protocol = $_REQUEST['protocol'] : $protocol = '';
!empty($_REQUEST['extlink']) ? $extlink = $_REQUEST['extlink'] : $extlink = '';
!empty($_REQUEST['titlelink']) ? $titlelink = $_REQUEST['titlelink'] : $titlelink = '';
!empty($_REQUEST['element']) ? $element = $_REQUEST['element'] : $element = '';
// Do some verifies before proceeding...

if ( empty($target) ) { die(); }
if ( $op == 'internal_lb' && $mdir == '' ) { $op = ''; }
if ( $op == 'external_lb' && empty($extlink) ) { $op = ''; }
if ( $op == 'internal_lb2' && empty($element) ) { $op = ''; }
// Add double slashes to protocol, if any...
if ( $protocol != 'mailto' ) {
	$protocol.= '://';
} else {
	$protocol.= ':';
}

empty($titlelink) ? $titlelink = 'Link' : $titlelink = $titlelink;

// Used to get the list of modules with link building capabilities
function get_linkbuilder_modules() {
	$lbmods = array();
	$modules = XoopsModule::getInstalledModules(true);
	foreach ( $modules as $module ) {
		$mdir = $module->dirname();
		if ( @file_exists(XOOPS_ROOT_PATH."/modules/".$mdir."/include/linkbuilder.inc.php") ) {
			$lbmods[] = $mdir;
		}
	}
	
	return $lbmods;
}

// Used to get the element name for each link builder module
function get_element_name($moduledir) {
	@include(XOOPS_ROOT_PATH."/modules/".$moduledir."/include/linkbuilder.inc.php");
	return $linkbuilder[$moduledir]['element_name'];
}

// Executes the function in order to process link building of a module
function process_module($moduledir) {
	@include(XOOPS_ROOT_PATH."/modules/".$moduledir."/include/linkbuilder.inc.php");
	$func = $moduledir."_buildlinks";
	if ( @function_exists($func) ) {
		$result = $func();
	} else {
		return false;
	}
	
	return $result;
}

function print_form_internal() {
?>
<table border="0" align="center" width="85%" cellpadding="4" cellspacing="1">
<tr>
	<td><label for="mdir"><?php echo _LINKELEMENTTYPE; ?></label></td>
</tr>
<tr>
	<td><select name="mdir" id="mdir" class="select">
	<option value="moduleslist" selected><?php echo _LB_MODULESLIST; ?></option>
	<option value="userslist"><?php echo _LB_USERSLIST; ?></option>
<?php
	$mods = get_linkbuilder_modules();
	if ( @is_array($mods) || count($mods) > 0 ) {
		foreach ( $mods as $mod ) {
			$elename = @get_element_name($mod);
			if ( $elename ) {
		?>
			<option value="<?php echo $mod; ?>"><?php echo $elename; ?></option>
		<?php
			}
		}
	} ?>
</select></td>
</tr></table>
<?php
}

?>
<p align="center">&nbsp;</p>
<p align="center"><big><b><?php echo _INSERTLINK; ?></b></big></p>
<?php

switch ( $op ) {

	// Finally... insert an internal module link...
	case "internal_lb2":
?>
<script language="JavaScript" type="text/javascript">
<!--
	window.opener.xoopsInsertStuff('<?php echo $target; ?>', '[url=<?php echo $element; ?>]<?php echo $titlelink; ?>[/url]');
	window.close();
//-->
</script>
<?php	
	break;
	
	// Process an elaboration on a module element...
	case "internal_lb":
		if ( $mdir == 'moduleslist' ) {
			$mname = _LB_MODULESLIST;
			$allnks[] = array(XOOPS_URL, _LB_HOMEPAGE);
			$xms = XoopsModule::getHasMainModulesList(false);
			if ( $xms && is_array($xms) && count($xms) > 0 ) {
				foreach ( $xms as $xmkey => $xmval ) {
					$xm_mod = new XoopsModule($xmkey);
					if ( $xm_mod && $xm_mod->isactive() ) {
						if ( !$xoopsUser ) {
							$usergroups = XoopsGroup::getByType('Anonymous');
						} else {
							$usergroups = $xoopsUser->groups();
						}
												
						if ( XoopsGroup::checkRight('module', $xm_mod->mid(), $usergroups) ) {
							$allnks[] = array(XOOPS_URL."/modules/".$xm_mod->dirname()."/", $xmval);
						}
					}
				}
			}
		} elseif ( $mdir == 'userslist' ) {
			$mname = _LB_USERSLIST;
			$allusers = $db->query("select uid, uname from ".$db->prefix("users")." order by uname asc");
			while ( $urow = $db->fetch_row($allusers) ) {
				$allnks[] = array(XOOPS_URL."/userinfo.php?uid=".$urow[0]."", $urow[1]);
			}
		} else {
			$xm = XoopsModule::getByDirname($mdir);
			if ( $xm ) { $mname = $xm->name(); }
			$allnks = process_module($mdir);		
		}
?>
<table border="0" cellpadding="4" cellspacing="1" width="85%" align="center">
<tr>
<td align="left" width="100%"><em><?php echo sprintf(_LINKYOUREINSERTING, $mname); ?></em>
<?php
		if ( @is_array($allnks) && count($allnks) > 0 ) {
?>
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post" name="lb_complete">
<input type="hidden" name="op" value="internal_lb2" />
<input type="hidden" name="titlelink" value="<?php echo $titlelink; ?>" />
<fieldset id="selectelement" title="<?php echo _LINKSELECTITEM; ?>">
<label for="element"><strong><?php echo _LINKSELECTITEM; ?></strong></label><br />
<select name="element" id="element" class="select">
<?php
	foreach ( $allnks as $link ) {
?>
<option value="<?php echo $link[0]; ?>"><?php echo $link[1]; ?></option>
<?php
	}
?>
</select><br /><br />
<div align="center"><input type="submit" name="subele" value="<?php echo _GO; ?>" /></div>
</fieldset>
</form>
<?php
		} else {
?>
<br /><br /><div align="center"><?php echo sprintf(_LINKNOELEMENTS, $mname); ?></div>
<?php
		}
?>
</td></tr></table>
<?php
	break;
	
	// Simply insert the provided link...
	case "external_lb":
		if ( $protocol == 'mailto:' ) {
			$lnk = '[email]'.$extlink.'[/email]';
		} else {
			$extlink = $protocol.$extlink;	
			$lnk = '[url='.$extlink.']'.$titlelink.'[/url]';
		}
?>
<script language="JavaScript" type="text/javascript">
<!--
	window.opener.xoopsInsertStuff('<?php echo $target; ?>', '<?php echo $lnk; ?>');
	window.close();
//-->
</script>
<?php
	break;
	
	// Paginate the initial form...
	default:
	?>
<table align="center" width="90%" cellpadding="0" cellspacing="0">
<tr>
<td align="left" width="100%"><em><?php echo _LINKTYPECHOICE; ?></em>
	<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" name="linkbuilderform" id="linkbuilderform" method="post">
	<fieldset id="lb_title" title="<?php echo _LINKTITLE; ?>">
	<label for="titlelink"><strong><?php echo _LINKTITLE; ?></strong></label><br />
	<input type="text" class="text" maxlength="100" size="30" name="titlelink" id="titlelink" />
	</fieldset>
	<br />
	<fieldset id="lb_choice_internal" title="<?php echo _INTERNALLINK; ?>">
	<input type="radio" name="op" id="opint" value="internal_lb" class="radio" checked /> <label for="opint"><strong><?php echo _INTERNALLINK; ?></strong></label><br /><br />
	<?php print_form_internal(); ?>
	</fieldset>
	<br />
	<fieldset id="lb_choice_external" title="<?php echo _EXTERNALLINK; ?>">
	<input type="radio" name="op" id="opext" value="external_lb" class="radio" /> <label for="opext"><strong><?php echo _EXTERNALLINK; ?></strong></label><br /><br />
	<table border="0" align="center" width="85%" cellpadding="4" cellspacing="1">
	<tr>
		<td><label for="protocol"><?php echo _LINKPROTOCOL; ?></label></td>
		<td><label for="extlink"><?php echo _LINKTYPEURL; ?></label></td>
	</tr>
	<tr>
		<td><select name="protocol" id="protocol" class="select">
		<option selected value="http">http://</option>
		<option value="https">https://</option>
		<option value="mailto">mailto:</option>
		<option value="ftp">ftp://</option>
		</select></td>
		
		<td><input type="text" class="text" maxlength="255" size="50" name="extlink" id="extlink" /></td>
	</tr>
	</table>
	</fieldset>
	<p align="center"><input type="submit" name="lbsubmit" value="<?php echo _GO; ?>" class="button" /></p>
	</form>
</td>
</tr>
</table>
	<?php
	break;
}
?>