CREATE TABLE chat_archive (
	arkid int(3) NOT NULL auto_increment,
	arkname varchar(50) NOT NULL,
	arkfile varchar(25) NOT NULL,
	arkcomment text NOT NULL,
	arktime int(10) NOT NULL,
	arkgroups text NOT NULL,
	PRIMARY KEY (arkid)
) TYPE=MyISAM;

CREATE TABLE chat_banned (
	bid int(3) NOT NULL auto_increment,
	user int(5) NOT NULL,
	until int(10) NOT NULL,
	PRIMARY KEY (bid)
) TYPE=MyISAM;

CREATE TABLE chat_messages (
	mid int(5) NOT NULL auto_increment,
	chatroom int(2) NOT NULL,
	message text NOT NULL,
	poster varchar(25) NOT NULL,
	post_time int(10) NOT NULL,
	poster_ip varchar(15) NOT NULL,
	PRIMARY KEY (mid)
) TYPE=MyISAM;

CREATE TABLE chat_rooms (
	roomid int(2) NOT NULL auto_increment,
	name varchar(25) NOT NULL,
	type tinyint(1) NOT NULL,
	usersgroup text NOT NULL,
	PRIMARY KEY (roomid)
) TYPE=MyISAM;

CREATE TABLE chat_wol (
	wolid int(8) NOT NULL auto_increment,
	uid int(5) NOT NULL,
	uname varchar(25) NOT NULL,
	room int(2) NOT NULL,
	ip varchar(15) NOT NULL,
	PRIMARY KEY (wolid)
) TYPE=MyISAM;

CREATE TABLE chat_requests (
	fromuid INT( 10 ) UNSIGNED NOT NULL,
	touid INT( 10 ) UNSIGNED NOT NULL,
	time INT( 10 ) UNSIGNED NOT NULL
) TYPE=MyISAM;

CREATE TABLE chat_preferences (
  `userid` int(8) NOT NULL,
  `chat_color` varchar(6) default 'auto',
  `bold` tinyint(1) NOT NULL default '0',
  `italic` tinyint(1) NOT NULL default '0',
  `underline` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`userid`)
) TYPE=MyISAM;

INSERT INTO chat_rooms (name, type, usersgroup) VALUES ('Default Room', 1, '');
