<?php
/* CONTENTS MODULE FOR E-XOOPPORT */
// +----------------------------------------------------------------------+
// | E-XOOPPORT 2.0                                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: Redpitt <redpitt@e-xoopport.it>                             |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+

if ( !defined("EX_PAGECLASS_INCLUDED") ) {
	define("EX_PAGECLASS_INCLUDED", 1);
	
	class PageClass {
		var $pageid;
		var $filename;
		var $title;
		var $groups;
		
		function PageClass($id=0) {
			$this->UnsetVariables();
			if ( !empty($id) ) {
				if ( $this->LoadPage($id) ) {
					return true;
				} else {
					return false;
				}
			} else {
				return true;
			}
		}
		
		function LoadPage($id) {
			global $db;
			
			if ( $this->PageExists($id) ) {
				$result = $db->query("select * from ".$db->prefix("contents_pages")." where pageid = ".$id."");
				list($id, $file, $title, $groups) = $db->fetch_row($result);
				$this->setVariables($id, $file, $title, $groups);
			} 
			
			return false;
		}
		
		function SavePage($id=NULL, $filename, $title, $groups) {
			global $db;
			
			if ( $id == NULL ) {
				if ( $db->query("insert into ".$db->prefix("contents_pages")." values ('', '".$filename."', '".$title."', '".implode("|", $groups)."')") ) {
					return true;
				}
			} else {
				if ( $db->query("update ".$db->prefix("contents_pages")." set filename = '".$filename."', pagetitle = '".$title."', groups = '".implode("|", $groups)."' where pageid = ".$id."") ) {
					return true;
				}
			}
			
			return false;
		}
		
		function DeletePage($id) {
			global $db;
			
			$db->query("delete from ".$db->prefix("contents_pages")." where pageid = ".$id."");
			return true;
		}
		
		function DeleteFile($filename) {
			@unlink(XOOPS_ROOT_PATH."/modules/contents/cache/pages/".$filename);
			return true;
		}
		
		function WriteFile($filename, $contents, $generatename=1) {
			if ( $generatename == 1 ) {
				$fname = '';
				for ($fn=0; $fn < 25; $fn++) {
					$fname .= "".rand(0,9)."";
				}
				$filename = $fname."-".$filename;
			}

			if ( $fh = @fopen(XOOPS_ROOT_PATH."/modules/contents/cache/pages/".$filename, 'w') ) {
				if ( @fwrite($fh, $contents) != -1 ) {
					@fclose($fh);
					return $filename;
				} else {
					@fclose($fh);
					return false;
				}
			}
			
			return false;
		}
		
		function PageExists($id) {
			global $db;
			
			$result = $db->query("select count(*) from ".$db->prefix("contents_pages")." where pageid = ".$id."");
			if ( $result && $db->num_rows($result) > 0 ) {
				return true;
			}
			
			return false;
		}
		
		function setVariables($id, $file, $title, $groups) {
			$this->pageid = intval($id);
			$this->filename = $file;
			$this->title = stripslashes($title);
			$this->groups = $groups;
		}
		
		function UnsetVariables() {
			unset($this->pageid);
			unset($this->filename);
			unset($this->title);
			unset($this->groups);
		}
		
		function GetPageId() {
			if ( !empty($this->pageid) ) {
				return $this->pageid;
			}
			
			return false;
		}
		
		function GetPageFile() {
			if ( !empty($this->filename) ) {
				return $this->filename;
			}
			
			return false;
		}

		function GetPageTitle() {
			if ( !empty($this->title) ) {
				return $this->title;
			}
			
			return false;
		}
		
		function GetPageGroups() {
			if ( !empty($this->groups) ) {
				if ( $this->groups == "all" ) {
					return "all";
				} else {
					$arr = explode("|", $this->groups);
					return $arr;
				}
			}
			
			return false;
		}
		
		function isAccessible($groups) {
			$gs = $this->GetPageGroups();
			if ( $gs == 'all' ) {
				return true;
			} elseif ( is_array($gs) && count($gs) > 0 ) {
				foreach ( $groups as $myg ) {
					if ( in_array($myg, $gs) ) {
						return true;
					}
				}					
			} else {
				return false;
			}
		}
		
		function GetContents() {
			if ( !empty($this->filename) ) {
				if ( file_exists(XOOPS_ROOT_PATH."/modules/contents/cache/pages/".$this->filename) ) {
					return @file_get_contents(XOOPS_ROOT_PATH."/modules/contents/cache/pages/".$this->filename);
				}
			}
			
			return false;
		}
		
		function CountPages() {
			global $db;
			
			$result = $db->query("select count(*) from ".$db->prefix("contents_pages")."");
			list($n) =  $db->fetch_row($result);
			return $n;
		}
		
		function GetAllPagesAsObject() {
			global $db;
			
			$ret = array();
			
			$result = $db->query("select pageid from ".$db->prefix("contents_pages")." order by pagetitle asc");
			if ( $db->num_rows($result) > 0 ) {
				while ( $pagerow = $db->fetch_row($result) ) {
					$ret[] = new PageClass(intval($pagerow[0]));
				}
			} else {
				return false;
			}
			
			return $ret;
		}
	
	} // END OF CLASS
}
?>
