<?php
/*
+----------------------+
| E-XOOPPORT LIVE CHAT |
+----------------------+
An AJAX based chat for E-Xoopport
*/

include_once("header.php");
include_once("no-cache.php");
include_once("include/functions.php");

garbageCollections();

if(!isset($_GET['roomid'])) {
	
	redirect_header(XOOPS_URL."/index.php",5,_LCHAT_NOROOMSEL);
	exit();
	
} else {
	
	$roomid = (int) $_GET['roomid'];
	$uid = $xoopsUser->getVar("uid");
	
	$roomQuery = $db->query("SELECT type, usergroups FROM ".$db->prefix("lchat_rooms")." WHERE roomid = $roomid;");
	$room = $db->fetch_array($roomQuery);
	
	if ($room['type'] == 'reserved' && !userCanEnter($room['usergroups'])) {
		
		redirect_header(XOOPS_URL,5,_LCHAT_NOROOMPERM);
		exit();
		
	}
	
	// Verify if user is banned
	$banResult = $db->query("SELECT bid FROM ".$db->prefix("lchat_banned")." WHERE roomid = $roomid AND uid = $uid AND type = 'ban';");
	if ($db->num_rows($banResult) > 0 ) {
		redirect_header(XOOPS_URL,5,_LCHAT_ROOMBANNED);
		exit();
	}
	
	$is_admin = 0;
	if($xoopsUser->isAdmin($xoopsModule->mid())) {
		
		$is_admin = 1;
		
	}
	
	// User Login
	// $query = $db->query("INSERT INTO ".$db->prefix("lchat_users")." VALUES ($uid, NULL, ".time().", $is_admin);");
	
	// Get user preferences
	$result = $db->query("SELECT * FROM ".$db->prefix("lchat_preferences"). " WHERE uid = $uid;");
	
	if ($db->num_rows($result) > 0) {
		
		$row = $db->fetch_array($result);
		$messageColor = $row['message_color'];
		$backgroundColor = $row['background_color'];
		$ubold = (bool) $row['bold'];
		$uitalic = (bool) $row['italic'];
		$uunderline = (bool) $row['underline'];
		
		$mstyle = '';
		if ($ucolor != 'auto') { $mstyle .= "color: #$ucolor; "; }
		if ($ubold) { $mstyle .= "font-weight: bold; "; }
		if ($uitalic) { $mstyle .= "font-style: italic; "; }
		if ($uunderline) { $mstyle .= "text-decoration: underline; "; }
		
		if ($mstyle != '') {
			
			$mstyle_code = "style=\"$mstyle\" ";
			
		}
		
	} else {
		
		$messageColor = 'auto';
		$ubold = false;
		$uitalic = false;
		$uunderline = false;
		$mstyle_code = "";
		
		// Select a random color for the user
		$colorarray = array("00", "33", "66", "99", "CC", "FF");
		
		$colorR = $colorarray[rand(0, count($colorarray) - 1)];
		$colorG = $colorarray[rand(0, count($colorarray) - 1)];
		$colorB = $colorarray[rand(0, count($colorarray) - 1)];
		
		$backgroundColor = $colorR . $colorG . $colorB;
		
		$textColor = findTextColor($backgroundColor);
		
		$db->query("INSERT INTO ".$db->prefix("lchat_preferences")." SET uid = $uid, message_color = '$messageColor',
					background_color = '$backgroundColor', text_color = '$textColor', bold = 0, italic = 0, underline = 0;");
		
	}
	
	// Get chat configuration
	$results = $db->query("SELECT * FROM ".$db->prefix("lchat_config").";");
	
	$config = $db->fetch_array($results);
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
 
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="it">
	<head>
	
		<title><?php echo $meta['title'];?> -- Chat</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<link href="<?php echo XOOPS_URL; ?>/include/style.css" rel="stylesheet" type="text/css" />
		<link href="<?php echo XOOPS_URL; ?>/modules/<?php echo $xoopsModule->dirname(); ?>/style/style.css" rel="stylesheet" type="text/css" />
		<style type='text/css' media='all'>
			<!--
				@import url(<?php echo XOOPS_URL; ?>/themes/<?php echo getTheme(); ?>/style/style.css);
				@import url(<?php echo XOOPS_URL; ?>/themes/<?php echo getTheme(); ?>/style/style.css.<?php echo $xoopsModule->dirname(); ?>);
			-->
		</style>
		<script type="text/javascript">
			var startRoomId = <?php echo $roomid; ?>;
			var uid = <?php echo $uid; ?>;
			var uname = '<?php echo $xoopsUser->uname(); ?>';
			var is_admin = <?php echo ( (bool)$is_admin ) ? "true":"false"; ?>;
			var __interval = <?php echo $config['msg_interval'] ?>;
			var antiFloodTime = <?php echo $config['flood_time'] ?>;
			var XOOPS_URL = '<?php echo XOOPS_URL; ?>';
			var XOOPS_THEME = '<?php echo getTheme(); ?>';
			
			// Language variables
			var _CANCEL = '<?php echo _CANCEL; ?>';
			var _LCHAT_USERS = '<?php echo _LCHAT_USERS; ?>';
			var _LCHAT_LOADING  = '<?php echo _LCHAT_LOADING; ?>';
			var _LCHAT_SAVEC_TITLE = '<?php echo _LCHAT_SAVEC_TITLE; ?>';
			var _LCHAT_PRIVATE_TITLE = '<?php echo _LCHAT_PRIVATE_TITLE; ?>';
			var _LCHAT_SHOW_USERS = '<?php echo _LCHAT_SHOW_USERS; ?>';
			var _LCHAT_KICKUSER_REASON = '<?php echo _LCHAT_KICKUSER_REASON; ?>';
			var _LCHAT_BANUSER_REASON = '<?php echo _LCHAT_BANUSER_REASON; ?>';
			var _LCHAT_NOIGNOREPRESENT = '<?php echo _LCHAT_NOIGNOREPRESENT; ?>';
		</script>
		<script src="javascript/chat_loader.js" type="text/javascript"></script>
		
	</head>
	
	<body>
		
		<div id="loading">
			<div>
				<img src="images/loading.gif" alt="Loading" /><br />
				<?php echo _LCHAT_LOADING; ?>
			</div>
		</div>
		
		<div id="cover">&nbsp;</div>
		
		<div class="fakeWin" id="alertWindow">
			<h1><?php echo _LCHAT_WARNING; ?><span>X</span></h1>
			<div>
				<div>&nbsp;</div>
				<input type="button" class="button" value="<?php echo _OK; ?>" />
			</div>
		</div>
		
		<div class="fakeWin" id="roomsWindow">
			<h1><?php echo _LCHAT_ROOMS_LIST; ?><span>X</span></h1>
			<div class="listContainer"></div>
		</div>
		
		<div class="fakeWin" id="ignoresWindow">
			<h1><?php echo _LCHAT_IGNORELIST; ?><span>X</span></h1>
			<div class="listContainer"></div>
		</div>
		
		<div class="fakeWin" id="invitesWindow">
			<h1><?php echo _LCHAT_INVITE; ?><span>X</span></h1>
			<div>
				<form id="inviteForm" action="invite_user.php" method="get">
					<label for="uInviteId"><?php echo _LCHAT_USERSELECT; ?>:</label><br />
					<select id="uInviteId" name="uid">
					</select><br /><br />
					<input type="submit" value="<?php echo _LCHAT_INVITESUB; ?>" />
				</form>
			</div>
		</div>
		
		<div class="fakeWin" id="colorWindow">
			<h1><?php echo _LCHAT_PERSONAL_COLOR; ?><span>X</span></h1>
			<div>
				<form id="colorForm" action="set_color.php" method="get">
					<label for="pColor"><?php echo _LCHAT_PERSONAL_COLOR_DESC; ?></label><br /><br />
					<select name="color" id="pColor">
						<?php echo(createColorsOptions($backgroundColor)); ?>
					</select>
					<input type="submit" value="<?php echo _SAVE ?>" />
				</form>
			</div>
		</div>
		
		<?php if ( (bool) $is_admin ) { ?>
		<div class="fakeWin" id="kickWindow">
			<h1><?php echo _LCHAT_KICKUSER; ?><span>X</span></h1>
			<div>
				<form id="kickForm" action="kick_user.php" method="post">
					<input type="hidden" name="uid" value="" />
					<input type="hidden" name="roomid" value="" />
					<label for="kickReason">Label_text</label><br /><br />
					<input type="text" style="width: 350px;" maxlength="255" name="reason" id="kickReason" /><br /><br />
					<input type="submit" value="<?php echo _LCHAT_KICK; ?>" />
					<input type="button" value="<?php echo _CANCEL ?>" id="cancelKick" />
				</form>
			</div>
		</div>
		<div class="fakeWin" id="banWindow">
			<h1><?php echo _LCHAT_BANUSER; ?><span>X</span></h1>
			<div>
				<form id="banForm" action="ban_user.php" method="post">
					<input type="hidden" name="uid" value="" />
					<input type="hidden" name="roomid" value="" />
					<label for="banReason">label_text</label><br /><br />
					<input type="text" style="width: 350px;" maxlength="255" name="reason" id="kickReason" /><br /><br />
					<?php echo _LCHAT_BANUSERUNTIL; ?><br /><br />
					<select name="day">
						<?php
						for ($i = 1; $i <= 31; $i++) {
							echo('<option value="'.$i.'" />'.$i.'</option>');
						}
						?>
					</select>
					/
					<select name="month">
						<?php
						for ($i = 1; $i <= 12; $i++) {
							echo('<option value="'.$i.'" />'.$i.'</option>');
						}
						?>
					</select>
					/
					<select name="year">
						<?php
						$thisYear = date("Y", time());
						for ($i = $thisYear; $i <= ($thisYear + 4); $i++) {
							echo('<option value="'.$i.'" />'.$i.'</option>');
						}
						?>
					</select>
					
					<select name="hours">
						<?php
						for ($i = 0; $i <= 23; $i++) {
							echo('<option value="'.$i.'" />'.$i.'</option>');
						}
						?>
					</select>
					:
					<select name="minutes">
						<?php
						for ($i = 0; $i <= 59; $i++) {
							$m = ($i < 10) ? "0".$i : $i;
							echo('<option value="'.$i.'" />'.$m.'</option>');
						}
						?>
					</select><br /><br />
					<input type="submit" value="<?php echo _LCHAT_BAN; ?>" />
					<input type="button" value="<?php echo _CANCEL ?>" id="cancelBan" />
				</form>
			</div>
		</div>
		<?php } ?>
				
		</div>
		
		<div id="contextMenu">
			<a href="javascript: void(0);" id="viewProfile"><?php echo _LCHAT_VIEWPROFILE; ?></a>
			<a href="javascript: void(0);" id="openPrivate"><?php echo _LCHAT_OPENPRIVATE; ?></a>
			<a href="javascript: void(0);" id="sayToUser"><?php echo _LCHAT_SAYTO; ?></a>
			<a href="javascript: void(0);" id="ignoreUser"><?php echo _LCHAT_IGNORE; ?></a>
			<?php if ( (bool) $is_admin ) { ?>
			<a href="javascript: void(0);" id="kickUser"><?php echo _LCHAT_KICKUSER; ?></a>
			<a href="javascript: void(0);" id="banUser"><?php echo _LCHAT_BANUSER; ?></a>
			<?php } ?>
		</div>
		
		<div id="chat">
		
			<div id="tabs">
				<ul id="tabs_ul">
				</ul>
			</div>
			
			<div id="tabScroller">
				<a id="tabScrollLeft" href="javascript:void(0)" onclick="tabScrollLeft()"><span></span>&laquo;</a>
				<a id="tabScrollRight" href="javascript:void(0)" onclick="tabScrollRight()"><span></span>&raquo;</a>
			</div>
			
			<div id="rooms">
			</div>
			
			<div id="bottom">
				
				<form action="send_message.php" method="post" id="sendform">
					<input type="hidden" name="roomtype" value="room" />
					<div id="messagefield">
						<input type="hidden" name="uid" value="<?php echo $uid;?>" />
						<input type="hidden" name="roomid" value="0" />
						<label for="message"><?php echo _LCHAT_MESSAGE; ?>: </label>
						<input type="text" name="message" id="message" <?php echo $mstyle_code; ?>/>
						<input type="submit" value="<?php echo _LCHAT_SUBMIT; ?>" /><br />
					</div>
					<div id="optionfield">
						<ul>
							<li>
								<a href="javascript:togglePanel('smilies')" class="openPanel"><?php echo _SMILIES; ?></a>
								<div id="smiliesPanel" class="panel">
<?php

$results = $db->query("SELECT code, smile_url, emotion FROM ".$db->prefix("smiles").";");

$rows = $db->num_rows($results);

while($row = $db->fetch_array($results)) {
	
	echo("\t\t\t\t\t\t\t\t\t<a href=\"javascript:insertSmile('{$row['code']}')\"><img src=\"".XOOPS_URL."/images/smilies/{$row['smile_url']}\" alt=\"{$row['emotion']}\" /></a> \n");
	
}

?>
								</div>
							</li>
							<li>
								<a href="javascript:togglePanel('font')" class="openPanel"><?php echo _LCHAT_FONT; ?></a>
								<div id="fontPanel" class="panel">
									<strong><?php echo(_LCHAT_FONTSET); ?></strong><br /><br />
<?php

echo("\t\t\t\t\t\t\t\t\t<label for=\"color\">"._LCHAT_COLOR."</label>:\n");
echo("\t\t\t\t\t\t\t\t\t<select name=\"color\" id=\"color\">\n");
echo("\t\t\t\t\t\t\t\t\t\t<option value=\"auto\">"._LCHAT_AUTO."</option>\n");

$options = createColorsOptions($messageColor);

echo($options);

echo("\t\t\t\t\t\t\t\t\t</select><br />\n");

echo("\t\t\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"bold\" id=\"bold\" value=\"bold\"");
if ($ubold) {
	echo (" checked=\"checked\"");
}
echo (" />\n");
echo ("\t\t\t\t\t\t\t\t\t<strong><label for=\"bold\">"._LCHAT_BOLD."</label></strong><br />\n");

echo("\t\t\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"italic\" id=\"italic\" value=\"italic\"");
if ($uitalic) {
	echo (" checked=\"checked\"");
}
echo (" />\n");
echo ("\t\t\t\t\t\t\t\t\t<label for=\"italic\" style=\"font-style: italic\">"._LCHAT_ITALIC."</label><br />\n");

echo("\t\t\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"underline\" id=\"underline\" value=\"underline\"");
if ($uunderline) {
	echo (" checked=\"checked\"");
}
echo (" />\n");
echo ("\t\t\t\t\t\t\t\t\t<label for=\"underline\" style=\"text-decoration: underline\">"._LCHAT_UNDERLINED."</label><br />\n");

?>

								</div>
							</li>
							<li>
								<a href="javascript:void(0)" onclick="toggleWindow('rooms')" class="openPanel"><?php echo _LCHAT_ROOMS; ?></a>
							</li>
							<li>
								<a href="javascript:togglePanel('option')" class="openPanel"><?php echo _LCHAT_OPTIONS; ?></a>
								<div id="optionPanel" class="panel">
									<a href="javascript:void(0)" onclick="toggleWindow('color')"><?php echo _LCHAT_PERSONAL_COLOR; ?></a>
									<a href="javascript:saveConversation()"><?php echo _LCHAT_SAVEC; ?></a>
									<a href="javascript:void(0)" onclick="toggleWindow('invites')"><?php echo _LCHAT_INVITE; ?></a>
									<a href="javascript:void(0)" onclick="toggleWindow('ignores')"><?php echo _LCHAT_IGNORELIST; ?></a>
									<div><input type="checkbox" id="activeSound" /> <label for="activeSound"><?php echo _LCHAT_ACTIVESOUND; ?></label></div>
								</div>
							</li>
						</ul>
					</div>
				</form>
				
			</div>
			
		</div>

	</body>

</html>
<?php }

?>