<?php

/*
+----------------------+
| E-XOOPPORT LIVE CHAT |
+----------------------+
An AJAX based chat for E-Xoopport
*/

include_once("header.php");
include_once("no-cache.php");
include("include/functions.php");

function convertMessages($messages) {
	global $db, $myts;
	
	$rows = $db->num_rows($messages);
	
	if ($rows > 0) {
		
		$last_msg_id = 0;
		$i = 1;
		$response = "";
		
		while($row = $db->fetch_array($messages)) {
			
			$roomid = $row['roomid'];
			$roomtype = $row['roomtype'];
			$nick = $row['uname'];
			$style = $row['style'];
			$time = date("H:i:s", $row['mtime']);
			$sysmsg = $row['sysmsg'];
			$bgColor = '#' . $row['background_color'];
			$textColor = '#' . $row['text_color'];
			
			$message = msgReplace($row['message'], $sysmsg, $nick);
			
			$message = str_replace("'", "&#39;", $message);
			
			$response .= " { 'roomid' : $roomid, 'roomtype' : '$roomtype', 'nick' : '$nick', 'text' : '$message', 'style' : '$style', 'time' : '$time', 'sysmsg' : $sysmsg, 'bgColor' : '$bgColor', 'textColor' : '$textColor' }";
			
			$last_msg_id = $row['id'];
			
			if ($i != $rows) {
				
				$response .= ", ";
				
			}
			
			$i++;
			
		}
		
	}
	
	return array($response, $last_msg_id);
	
}

$uid = $xoopsUser->getVar("uid");

$roomMessages = $db->query("SELECT e.uname, m.id, m.roomid, m.roomtype, m.message, m.style, m.mtime, m.sysmsg, p.background_color, p.text_color
FROM ".$db->prefix("lchat_messages")." AS m
INNER JOIN ".$db->prefix("users")." AS e ON e.uid = m.uid 
INNER JOIN ".$db->prefix("lchat_users")." AS u ON u.uid = $uid AND m.id > u.last_msg_id
INNER JOIN ".$db->prefix("lchat_connected")." AS c ON c.roomid = m.roomid AND c.uid = u.uid
INNER JOIN ".$db->prefix("lchat_preferences")." AS p ON p.uid = m.uid
WHERE m.roomtype = 'room';");

$privateMessages = $db->query("SELECT e.uname, m.id, m.roomid, m.roomtype, m.message, m.style, m.mtime, m.sysmsg, pr.background_color, pr.text_color
FROM ".$db->prefix("lchat_messages")." AS m
INNER JOIN ".$db->prefix("users")." AS e ON e.uid = m.uid 
INNER JOIN ".$db->prefix("lchat_users")." AS u ON u.uid = $uid AND m.id > u.last_msg_id
INNER JOIN ".$db->prefix("lchat_privates")." AS p ON p.pid = m.roomid AND (p.fromUid = u.uid OR p.toUid = u.uid)
INNER JOIN ".$db->prefix("lchat_preferences")." AS pr ON pr.uid = m.uid
WHERE m.roomtype = 'private';");

list($room_response, $room_last_msg_id) = convertMessages($roomMessages);

list($private_response, $private_last_msg_id) = convertMessages($privateMessages);
	
$output = "[ ";

$output .= (strlen($room_response) > 0) ? $room_response : "";

$output .= (strlen($room_response) > 0 && strlen($private_response) > 0) ? "," : "";

$output .= (strlen($private_response) > 0) ? $private_response : "";

$output .= " ];";

$bannedResults = $db->query("SELECT b.bid, b.type, b.reason, b.roomid, b.uid, b.until, r.name FROM ".$db->prefix("lchat_banned")." AS b
				INNER JOIN ".$db->prefix("lchat_rooms")." AS r ON r.roomid = b.roomid
				WHERE b.uid = $uid AND b.displayed = 0;");

if ($db->num_rows($bannedResults) > 0) {
	
	while ($row = $db->fetch_array($bannedResults)) {
		
		if ($row['type'] == 'kick')
			$error_message = sprintf(_LCHAT_YOUKICKED, $row['name'], $row['reason']);
		else
			$error_message = sprintf(_LCHAT_YOUBANNED, $row['name'], $row['reason'], date('j/n/Y - H:i', $row['until']));
			
		$output .= ' var error = "'.$error_message.'"; var action = "rooms['.$row['roomid'].'].close(true)";';
		
		if ($row['type'] == 'kick') {
			$db->query("DELETE FROM ".$db->prefix("lchat_banned")." WHERE bid = {$row['bid']};");
		} else {
			$db->query("UPDATE ".$db->prefix("lchat_banned")." SET displayed = 1 WHERE bid = {$row['bid']};");
		}
		
	}
	
}

if (strlen($room_response) > 0 || strlen($private_response) > 0) {
	$last_msg_id = ($room_last_msg_id > $private_last_msg_id) ? $room_last_msg_id : $private_last_msg_id;
	$query = $db->query("UPDATE ".$db->prefix("lchat_users")." SET last_msg_id = $last_msg_id WHERE uid = $uid;");
}

$query = $db->query("UPDATE ".$db->prefix("lchat_users")." SET last_action = ".time()." WHERE uid = $uid;");

echo($output);

// Logout old users
garbageCollections();

?>