<?php

/*
+----------------------+
| E-XOOPPORT LIVE CHAT |
+----------------------+
An AJAX based chat for E-Xoopport
*/

/** insertLogoutMessages()
  * insert logout message in each private conversation where user was logged
  * @param MYSQL OBJECT
  * @param STRING user name
  * @param INT user id
  */
function insertLogoutMessages($results, $uname, $uid) {
	global $db;
	
	while ($row = $db->fetch_array($results)) {
		
		$roomid = $row['pid'];
		// $message = sprintf(_LCHAT_USER_LOGOUT, "[b]".$uname."[/b]");
		$message = 'LOGOUT';
		
		$query = $db->query("INSERT INTO ".$db->prefix("lchat_messages")." (roomid, roomtype, uid, message, style, mtime, sysmsg) VALUES ($roomid, 'private', $uid, '$message', 'userExit', ".time().", 1);")
		or die("[true, '"._LCHAT_LOGOUT_ERR."'];");
		
		// If both users are logged out, delete db entry
		
		$countQuery = $db->query("SELECT COUNT(*) AS users FROM ".$db->prefix("lchat_users")." WHERE uid = {$row['fromUid']} OR uid = {$row['toUid']};")
		or die("[true, '"._LCHAT_LOGOUT_ERR."'];");
		
		$countRow = $db->fetch_array($countQuery);
		
		if ($countRow['users'] < 2) {
			
			$db->query("DELETE FROM ".$db->prefix("lchat_privates")." WHERE pid = {$row['pid']};");
			
		}
		
	}
	
}

/** logout()
  * run logout commands
  */
function logout($uname, $uid) {
	global $db;
	
	// Select all rooms
	// $roomsQuery = $db->query("SELECT roomid FROM ".$db->prefix("lchat_connected")." WHERE uid = $uid;")
	// or die("[true, '"._LCHAT_LOGOUT_ERR."'];");
	// $message = sprintf(_LCHAT_USER_LOGOUT, "[b]".$uname."[/b]");
	$message = 'LOGOUT';
	
	insertInAllRooms($uid, $message, "userExit");

	// Select all private conversations of the user
	$privatesQuery = $db->query("SELECT pid, fromUid, toUid FROM ".$db->prefix("lchat_privates")." WHERE fromUid = $uid OR toUid = $uid;")
	or die("[true, '"._LCHAT_LOGOUT_ERR."'];");

	// Insert a message in each room
	// insertLogoutMessages($roomsQuery, 'room', $uname, $uid);
	insertLogoutMessages($privatesQuery, $uname, $uid);
	
	$query = $db->query("DELETE FROM ".$db->prefix("lchat_users")." WHERE uid = $uid;") or die("[true, '"._LCHAT_LOGOUT_ERR."'];");
	
	$query = $db->query("DELETE FROM ".$db->prefix("lchat_connected")." WHERE uid = $uid;") or die("[true, '"._LCHAT_LOGOUT_ERR."'];");
	
}

/** garbageCollections()
  * Logout disconnected users
  */
function garbageCollections() {
	global $db;
	
	$configQuery = $db->query("SELECT * FROM ".$db->prefix("lchat_config").";");
	
	$config = $db->fetch_array($configQuery);
	
	$time = time() - $config['logout_time'];
	
	$results = $db->query("SELECT u.uid, e.uname FROM ".$db->prefix("lchat_users")." as u INNER JOIN ".$db->prefix("users")." AS e ON u.uid = e.uid WHERE u.last_action < $time;");
	
	if($db->num_rows($results) > 0) {
		
		while ($row = $db->fetch_array($results)) {
			
			$uname = $row['uname'];
			$uid = $row['uid'];
			
			logout($uname, $uid);
			
		}
		
	}
	
	// DELETE EXPIRED BAN
	$db->query("DELETE FROM ".$db->prefix("lchat_banned")." WHERE until < ".time().";");
	
	// DELETE OLD MESSAGES
	if ($config['delete_msg_after'] > 0) {
		
		$newTime = time() - $config['delete_msg_after'];
		$db->query("DELETE FROM ".$db->prefix("lchat_messages")." WHERE m.mtime < $newTime;");
		
	}
	
}

/** say if a user can or can't enter in a room
  * @param array room user groups
  * @return true if user can enter, or false
  */
function userCanEnter($groups) {
	global $xoopsUser;
	
	$roomGroups = explode('|', $groups);
	$userGroups = $xoopsUser->groups();
	$canEnter = false;
	
	foreach ($userGroups as $group) {
		
		if (in_array($group, $roomGroups)) {
			
			$canEnter = true;
			break;
			
		}
		
	}
	
	return $canEnter;
	
}

/** returns an XHTML code, representing chat rooms list
  * @param array userGroups
  * @return string xhtml code
  */
function roomsList() {
	global $db, $uid;
	
	echo('<ul>');
	$results = $db->query("SELECT r.roomid, r.name, r.topic, r.type, r.usergroups, COUNT(c.roomid) AS users
	FROM ".$db->prefix('lchat_rooms')." AS r
	LEFT JOIN ".$db->prefix('lchat_connected')." AS c ON r.roomid = c.roomid
	GROUP BY r.roomid;");
	
	while ($row = $db->fetch_array($results)) {
		
		if ($row['type'] == 'normal' || userCanEnter($row['usergroups'])) {
			
			$roomOutput = '<li>';
			
			if ($row['type'] == 'reserved')
				$roomOutput .= '<img src="images/reserved.png" /> ';
				
			$roomOutput .= '<a href="javascript:void(0)" onclick="openRoom('.$row['roomid'].')"><strong>'.$row['name'].'</strong></a> ('.$row['users'].')';
			
			if ($row['users'] > 0) {
				
				$roomOutput .= ' <a href="javascript:void(0)" class="showUsers" onclick="showRoomUsers('.$row['roomid'].')">('._LCHAT_SHOW_USERS.')</a>';
				
				$usersResults = $db->query("SELECT u.uid, u.uname FROM ".$db->prefix("users")." AS u
					INNER JOIN ".$db->prefix("lchat_connected")." AS c ON c.uid = u.uid
					WHERE c.roomid = ".$row['roomid']." 
					ORDER BY u.uname;");
				
				$usersArray = array();
				
				while ($user = $db->fetch_array($usersResults)) {
					
					if ($user['uid'] == $uid) {
						continue 2;
					}
					
					$usersArray[] = $user['uname'];
					
				}
				
				$usersList = implode(", ", $usersArray);
				
				$roomOutput .= '<div id="room'.$row['roomid'].'UsersList" class="usersList">'.$usersList.'</div>';
				
			}
			
			$roomOutput .= '<div class="roomTopic">'.$row['topic'].'</div></li>';
			echo($roomOutput);
			
		}
		
	}
	
	echo('</ul>');
	
}

/** insert a message in all avaible rooms
  * @param int user id
  * @param string message
  * @param string type of message (userEnter or userExit)
  */
function insertInAllRooms($uid, $message, $type) {
	global $db;
	
	// Select all rooms
	$roomsQuery = $db->query("SELECT roomid FROM ".$db->prefix("lchat_rooms").";");
	$numRooms = $db->num_rows($roomsQuery);
	$lastMsgId = 0;
	
	while ($room = $db->fetch_array($roomsQuery)) {
		$query = $db->query("INSERT INTO ".$db->prefix("lchat_messages")." (roomid, roomtype, uid, message, style, mtime, sysmsg) VALUES (".$room['roomid'].", 'room', $uid, '$message', '$type', ".time().", 1);");
		$lastMsgId = $db->insert_id();
	}
	
	$query = $db->query("UPDATE ".$db->prefix("lchat_users")." SET last_msg_id = ".($lastMsgId - $numRooms)." WHERE uid = $uid;");
	
}

/** display last X archives for current users
  * @param int number of archives (0 means "display all")
  * @return string archives list
  */
 function displayArchives($num, $displayAllInfo = false) {
	global $db, $xoopsUser;
	
	$userGroups = $xoopsUser->groups();
	
	$results = $db->query("SELECT * FROM ".$db->prefix("lchat_archives")." ORDER BY arktime DESC;");
	
	if($db->num_rows($results) > 0) {
		
		$i = 0;
		
		while($ark = $db->fetch_array($results)) {
			
			$arkGroups = explode('|', $ark['usergroups']);
			$canView = false;
			
			foreach ($userGroups as $group) {
				
				if (in_array($group, $arkGroups)) {
					
					$canView = true;
					break;
					
				}
				
			}
			
			if($canView) {
				
				$code .= '<img src="'.XOOPS_URL.'/images/icon-archive.png" /> ';
				$code .= '<a href="'.XOOPS_URL.'/modules/dragonflychat/view_archive.php?id='.$ark['arkid'].'">';
				$code .= $ark['arkname'].'</a>';
				
				if ($displayAllInfo) {
					$code .= ' <em>('._LCHAT_AVAIBLEFROM.': ' . date(_SHORTDATESTRING." - H:i:s", $ark['arktime']).')</em><br />';
					$code .= $ark['arkdesc'] . '<br />';
				}
				
				$code .= '<br />';
				
				$i++;
				
			}
			
			if ($i >= $num && $num != 0)
			break;
			
		}
		
	} else {
		
		$code = _MB_LCHAT_NOARCHIVES;
		
	}
	
	return $code;
	
 }
 
 /** msgReplace()
   * replace message content for show it
   * @param string the message
   * @param boolean system message or not
   * @param string user nick
   * @return string the new message
   */
 function msgReplace($message, $sysmsg, $nick) {
	global $myts;
	
	/* rewrite system message in the user language
	system message can be one of the following:
	ENTER-<roomName>		User XXX has entered in the XXX room
	LOGOUT				User XXX has left the chat
	EXITROOM-<roomName>	User XXX has left XXX room
	EXITPRIVATE			User XXX has left conversation
	KICK-<reason>
	BAN-<reason>*/
	if ($sysmsg) {
		
		$content = explode('-', $message, 2);
		
		if ($content[0] == 'ENTER')
			$message = sprintf(_LCHAT_USER_ENTER, "[b]".$nick."[/b]", "[b]".$content[1]."[/b]");
		else if ($content[0] == 'LOGOUT')
			$message = sprintf(_LCHAT_USER_LOGOUT, "[b]".$nick."[/b]");
		else if ($content[0] == 'EXITROOM')
			$message = sprintf(_LCHAT_USER_EXIT, "[b]".$nick."[/b]", "[b]".$content[1]."[/b]");
		else if ($content[0] == 'EXITPRIVATE')
			$message = sprintf(_LCHAT_USER_EXIT_PRIVATE, "[b]".$nick."[/b]");
		else if ($content[0] == 'KICK')
			$message = sprintf(_LCHAT_USERKICKED, '[b]'.$nick.'[/b]', '[b]'.$content[1].'[/b]');
		else if ($content[0] == 'BAN')
			$message = sprintf(_LCHAT_USERBANNED, '[b]'.$nick.'[/b]', '[b]'.$content[1].'[/b]');
		
	}
		
	$message = $myts->makeTareaData4Show($message, 0, 1, 1);
	
	return $message;
	
 }
 
function createColorsOptions($selectedColor) {
	
	$colorarray = array("00", "33", "66", "99", "CC", "FF");
	
	foreach ($colorarray as $color1) {
		foreach ($colorarray as $color2) {
			foreach ($colorarray as $color3) {
				$color = $color1.$color2.$color3;
				$stream .= "\t\t\t\t\t\t\t\t<option value='".$color."' style='background-color:#".$color.";color:#".$color.";'";
				if ($color == $selectedColor) {
					$stream .= " selected='selected'";
				}
				$stream .= ">#".$color."</option>\n";
			}
		}
	}
	
	return $stream;

 }
 
 function findTextColor($bgColor) {
	
	$colorR = hexdec(substr($bgColor, 0, 2));
	$colorG = hexdec(substr($bgColor, 2, 2));
	$colorB = hexdec(substr($bgColor, 4, 2));
	
	$lum = ( ( $colorR * 299 ) + ( $colorG * 587 ) + ( $colorB * 114) ) / 1000;
	
	$diffW = 255 - $lum;
	
	return ($diffW > $lum) ? "FFFFFF" : "000000";
	
 }

?>