// Simple Ajax Class -- www.tetrix.it

function Ajax(method, page, async) {
	
	// Private attributes
	var __self = this;
	var interval;
	
	// Public attributes
	this.httpObj = null;
	this.onparsing = false;
	
	// Constructor
	var __constructor = function() {
		userAgent = navigator.userAgent;
		
		if(window.XMLHttpRequest)
			__self.httpObj = new XMLHttpRequest();
		else if(!(/MSIE 4/i.test(userAgent))) {
			if(/MSIE 5/i.test(userAgent))
				__self.httpObj = new ActiveXObject("Microsoft.XMLHTTP");
			else
				__self.httpObj = new ActiveXObject("Msxml2.XMLHTTP");
		}
		
	}
	
	/** public send()
	  * send data with XMLHttpRequest
	  * @param string data
	  */
	this.send = function(data) {
		
		if(!__self.onparsing) {
			
			__self.onparsing = true;
			__self.httpObj.onreadystatechange = __self.onreadystatechange;
			
			if (method == "post" || method == "POST") {
				__self.httpObj.open(method, page, async);
				__self.httpObj.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
				__self.httpObj.setRequestHeader('Content-length', data.length);
				__self.httpObj.setRequestHeader('Connection', 'close');
				__self.httpObj.send(data);
			} else {
				data = (data == null) ? "" : "?"+data;
				__self.httpObj.open(method, page + data, async);
				__self.httpObj.send(null);
			}
			
		} else {
			
			interval = setTimeout(function() { __self.send(data); }, 50);
			
		}
		
	}
	
	/** public load()
	  * send no data -- alias of send(null)
	  */
	this.load = function() {
		
		__self.send(null);
		
	}
	
	/** httpObj onreadystatechange
	  * call onloading and oncomplete method
	  */
	this.onreadystatechange = function() {
		
		var httpObj = __self.httpObj;
		
		if (httpObj.readyState == 1)
			__self.onloading();
		
		if (httpObj.readyState == 4) {
			
			if (httpObj.status == 200 || httpObj.status == 304) {
				
				var response = (typeof httpObj.responseText == "string") ? httpObj.responseText : '';
				__self.oncomplete(response);
				
			}
				
			__self.onparsing = false;
			
		}
		
	}
	
	/** public abstract function onloading
	  * activated when httpObj.readyState == 1
	  */
	this.onloading = function() { }
	
	/** public abstract function oncomplete
	  * activated when httpObj.readyState == 4 and httpObj.status == 200
	  * @param string responseText
	  */
	this.oncomplete = function(response) {  }
	
	__constructor();
	 
}

/** AjaxForm class
  * Create a form which sends data with Ajax
  * @param string - form id
  */
 function AjaxForm(id) {
 	
 	// Public attributes
 	this.form = document.getElementById(id);
 	this.Ajax = null;
 	
 	// Private attrubutes
 	var __self = this;
 	var method = this.form.method;
 	var action = this.form.action;
 	
 	/** public send()
 	  * activated on form.onsubmit, send form data with Ajax
 	  */
 	this.send = function() {
 		
 		var data = "";
		var elements = __self.form.elements;
		
		for (var i=0; i < elements.length; i++) {
			
			if (elements[i].type == "text" || elements[i].type == "select-one" || elements[i].type == "hidden") {
				
				if (i != 0) { data += "&"; }
				
				data += elements[i].name +"="+ encodeURIComponent(elements[i].value);
				
			}
			
			if (elements[i].type == "checkbox") {
			
				if (elements[i].checked) {
					
					if (i != 0) { data += "&"; }
					
					data += elements[i].name + "=" + encodeURIComponent(elements[i].value);
					
				}
				
			}
			
		}
		
		__self.Ajax = new Ajax(method, action, true);
		__self.Ajax.onloading = __self.onloading;
		__self.Ajax.oncomplete = __self.oncomplete;
		__self.Ajax.send(data);
		
	}
	
	/** public abstract function onloading
	  * linked to Ajax.onloading method
	  */
	this.onloading = function() { }
	
	/** public abstract function oncomplete
	  * linked to Ajax.oncomloete method
	  */
	this.oncomplete = function(response) { }
	
	// Link form onsubmit method with this.send method
	this.form.onsubmit = function() { __self.send(); return false; }
	
}