function Room(type, id) {
	
	// Private atributes
	var __self = this;
	//var id = id;
	//var type = type;
	var name;
	var topic;
	var tabsUl;
	var htmlTab;
	var RoomsDiv;
	var htmlRoomDiv;
	var MessagesDiv;
	var htmlToggleUserPanel;
	var htmlRoomName;
	var htmlRoomTopic;
	var htmlUsersDiv;
	var htmlUsersTitle;
	var htmlUsersList;
	var htmlAvatarDiv;
	var userAvatar;
	var userPanelWidth = 0;
	var inputMessage = "";
	var flashStatus = 0;
	var flashTimer;
	
	// PUBLIC VARIABLES
	this.loaded = false;
	this.MessageContainer = null;
	this.roomName;
	
	/** private start()
	  * Adds HTML elements needed for room, with DOM;
	  * Loads room informations
	  */
	var start = function() {
		
		// Add Room Tab to Tabs
		tabsUl = document.getElementById("tabs_ul");
		
		htmlTab = document.createElement("li");
		
		var link = document.createElement("a");
		link.setAttribute("href", "javascript:void(0)");
		
		htmlRoomName = document.createTextNode(_LCHAT_LOADING)
		link.appendChild(htmlRoomName);
		
		var closeLink = document.createElement("span");
		closeLink.appendChild(document.createTextNode("X"));
		
		// Hack for IE6 :hover
		closeLink.onmouseover = function() { this.className = "hover"; }
		closeLink.onmouseout = function() { this.className = ""; }
		
		eval('closeLink.onclick = function() { ' + type + 's[' + id + '].close(0); }');
		
		link.appendChild(closeLink);
		
		eval('link.onclick = function() { ' + type + 's[' + id + '].display(); }');
		
		link.onfocus = function() { this.blur(); }
		
		htmlTab.appendChild(link);
		
		tabsUl.appendChild(htmlTab);
		
		// Create div for Messages
		RoomsDiv = document.getElementById("rooms");
		
		htmlRoomDiv = document.createElement("div");
		htmlRoomDiv.className = "room";
		htmlRoomDiv.style.display = "none";
		
		MessagesDiv = document.createElement("div");
		MessagesDiv.className = "messages";
		
		var RoomH1 = document.createElement("h1");
		htmlRoomTopic = document.createTextNode("");
		RoomH1.appendChild(htmlRoomTopic);
		
		var MessageContainer = document.createElement("div");
		MessageContainer.className = "msgcont";
		
		htmlToggleUserPanel = document.createElement("span");
		htmlToggleUserPanel.className = "displayUserPanel";
		htmlToggleUserPanel.innerHTML = "";
		eval('htmlToggleUserPanel.onclick = function() { ' + type + 's[' + id + '].toggleUserPanel(); }');
		
		MessagesDiv.appendChild(RoomH1);
		MessagesDiv.appendChild(MessageContainer);
		
		htmlRoomDiv.appendChild(MessagesDiv);
		htmlRoomDiv.appendChild(htmlToggleUserPanel);
		
		RoomsDiv.appendChild(htmlRoomDiv);
		
		__self.MessageContainer = MessageContainer;
		
		if (type == "room") {
			
			// Create div for room users
			htmlUsersDiv = document.createElement("div");
			htmlUsersDiv.className = "users";
			
			UsersH1 = document.createElement("h1");
			htmlUsersTitle = document.createTextNode(_LCHAT_USERS + " (0)");
			UsersH1.appendChild(htmlUsersTitle);
			
			htmlUsersList = document.createElement("ul");
			htmlUsersList.className = "usrcont";
			
			htmlUsersDiv.appendChild(UsersH1);
			htmlUsersDiv.appendChild(htmlUsersList);
			
			htmlRoomDiv.appendChild(htmlUsersDiv);
			
			// Loads Room Information
			httpRoomInfo.load();
			
		} else if(type == "private") {
			
			htmlAvatarDiv = document.createElement("div");
			htmlAvatarDiv.className = "avatar";
			
			var avatarH1 = document.createElement("h1");
			avatarH1.appendChild(document.createTextNode("Avatar"));
			
			userAvatar = document.createElement("img");
			
			htmlAvatarDiv.appendChild(avatarH1);
			htmlAvatarDiv.appendChild(userAvatar);
			
			htmlRoomDiv.appendChild(htmlAvatarDiv);
			
			httpPrivateInfo.load();
			
		}
		
		// Loads users list
		// httpRoomUsers.load();
		
		// Load Messages
		getMessages();
		
	}
	
	/** private parseRoomInfo()
	  * parse Room Information
	  */
	var parseRoomInfo = function(response) {
		
		eval("var Room = " + response);
		
		if (typeof error != "undefined") {
			
			myAlert(error);
			__self.close(false);
			
		}
		
		name = Room.name;
		topic = Room.topic;
		
	}
	
	/** private parseRoomUsers()
	  * parse Users List
	  */
	var parseRoomUsers = function(response) {
		
		eval("var Users = " + response);
		htmlUsersList.innerHTML = "";
		
		for (var i=0; i < Users.length; i++) {
			
			var uLi = document.createElement("li");
			
			var uLink = document.createElement("a");
			uLink.setAttribute("href", "javascript:void(0)");
			
			var uImg = document.createElement("img");
			uImg.setAttribute("src", "images/user.png");
			uImg.style.backgroundColor = Users[i].bgColor;
            
            if (Users[i].uid == uid)
                uImg.onclick = function() { toggleWindow("color") };
                
			uLink.appendChild(uImg);
			
			var uSpan = document.createElement("span");
			uSpan.appendChild(document.createTextNode(Users[i].nick));
			uLink.appendChild(uSpan);
			
			if(Users[i].is_admin) { 
				
				uLink.className = 'admin';
				
			}
			
			eval('uLink.ondblclick = function() { newPrivate(' + Users[i].uid + ', "' + Users[i].nick + '"); }');
			eval('uLink.oncontextmenu = function(e) { conMenuId = ' + Users[i].uid + '; conMenuNick = "' + Users[i].nick + '"; openContextMenu(e); return false; }');
			
			uLink.onfocus = function() { this.blur(); }
			
			uLi.appendChild(uLink);
			
			htmlUsersList.appendChild(uLi);
			
		}
		
		htmlUsersTitle.nodeValue = _LCHAT_USERS + " (" + Users.length + ")";
		
		if(!__self.loaded) {
			
			// Write room information
			htmlRoomTopic.nodeValue = topic;
			htmlRoomName.nodeValue = name;
			__self.roomName = name;
			
			// Set loaded flag to true
			__self.loaded = true;
			__self.onload();
			
			// Display current room
			__self.display();
			
		}
		
		if (/MSIE/.test(navigator.userAgent) || /KHTML/.test(navigator.userAgent))
			httpRoomUsers.httpObj.abort();
		
	}
	
	/** private parsePrivateInfo()
	  * parse information for private conversations
	  */
	var parsePrivateInfo = function(response) {
		
		// { nick, avatarUrl, avatarWidth, avatarHeight, fromFlag }
		eval("var Info = " + response + ";");
		
		userAvatar.setAttribute("src", Info.avatarUrl);
		
		if (Info.avatarWidth > 1) {
			
			htmlAvatarDiv.style.width = Info.avatarWidth + "px";
			MessagesDiv.style.marginRight = Info.avatarWidth + "px";
			
		} else {
			
			htmlAvatarDiv.style.display = "none";
			htmlToggleUserPanel.style.display = "none";
			MessagesDiv.style.marginRight = "0";
			
		}
		
		htmlRoomTopic.nodeValue = _LCHAT_PRIVATE_TITLE + Info.nick;
		htmlRoomName.nodeValue = Info.nick;
		__self.roomName = Info.nick;
		
		// Set loaded flag to true
		__self.loaded = true;
		__self.onload();
			
		if (Info.fromFlag) {
			
			// Display current room
			__self.display();
			
		}
		
	}
	
	/** public addMesage()
	  * Add new message to message DIV
	  * @param object message
	  */
	this.addMessage = function(sysmsg, time, nick, text, style, blockStyle) {
		
		var MessageContainer = __self.MessageContainer;
		var div = document.createElement("div");
		
		if(sysmsg) {
			
			if (text != "COLOR") {
				div.innerHTML = "<span class=\"time\">"+time+"</span>" +
				"<span class=\"msg\">"+text+"</span>";
				div.className = "sysmsg";
			}
			
			if (type == 'room')
				httpRoomUsers.load();
			
		} else {
			
			div.innerHTML = "<span class=\"time\" style=\""+blockStyle+"\">"+time+"</span>";
			div.innerHTML += "<span class=\"nick\" style=\""+blockStyle+"\" onclick=\"sayTo('"+nick+"')\">["+nick+"]</span>";
			
			if (style == '') {
				
				div.innerHTML += "<span class=\"msg\">"+text+"</span>";
				
			} else {
				
				div.innerHTML += "<span class=\"msg\" style=\""+style+"\">"+text+"</span>";
				
			}
			
			if (nick == uname)
				div.className = "mymsg";
			
		}
		
		MessageContainer.appendChild(div);
		
		if (soundsActive) {
		
			if (sysmsg)
				soundManager.play(style);
			else
				soundManager.play("newMessage");
			
		}
		
		// Scroll div to bottom
		MessageContainer.scrollTop = MessageContainer.scrollHeight - MessageContainer.clientHeight;
		
		// Flash this tab
		if ( (type != actRoomType || id != actRoomId) && (!sysmsg || text != "COLOR") ) {
			
			__self.flash();
			
		}
		
		// window.focus();
		
	}
	
	/** public toggleUserPanel()
	  * display (or hide) user (or avatar) panel
	  */
	this.toggleUserPanel = function() {
	
		var element = (type == "room") ? htmlUsersDiv : htmlAvatarDiv;
	
		if (htmlToggleUserPanel.innerHTML == "") {
			
			// Hide user/avatar panel
			userPanelWidth = element.offsetWidth;
			element.style.display = "none";
			htmlToggleUserPanel.innerHTML = "";
			htmlToggleUserPanel.className = "hideUserPanel";
			MessagesDiv.style.marginRight = "0";
			
		} else {
		
			// Display user/avatar panel
			element.style.display = "block";
			element.style.width = userPanelWidth + "px";
			htmlToggleUserPanel.innerHTML = "";
			htmlToggleUserPanel.className = "displayUserPanel";
			MessagesDiv.style.marginRight = userPanelWidth + "px";
		
		}
		
	}		
			
	
	/** public display()
	  * Display room tab and hidden opened tab
	  */
	this.display = function() {
	
		try {
			
			var array = (actRoomType == "room") ? rooms : privates;
			
			if (actRoomId != id || actRoomType != type) {
				
				array[actRoomId].hide();
				prevRoomId = actRoomId;
				prevRoomType = actRoomType;
				
			}
			
		} catch(e) {
			
		}
		
		MessageForm.form.message.value = inputMessage;
		htmlRoomDiv.style.display = "block";
		htmlTab.className = "active";
		actRoomId = id;
		actRoomType = type;
		MessageForm.form.roomid.value = id;
		MessageForm.form.roomtype.value = type;
		
		clearTimeout(flashTimer);
		
		resizer();
		
	}
	
	/** public hidden()
	  * Hide current tab
	  */
	this.hide = function() {
		
		inputMessage = MessageForm.form.message.value;
		htmlRoomDiv.style.display = "none";
		htmlTab.className = null;
		
	}
	
	/** public flash()
	  * Flash current tab
	  */
	this.flash = function() {
		
		if (flashStatus) {
			
			htmlTab.className = null;
			
		} else {
			
			htmlTab.className = "flash";
			
		}
		
		flashStatus = !flashStatus;
		
		clearTimeout(flashTimer);
		flashTimer = setTimeout(type+"s["+id+"].flash()", 500);
		
	}
	
	/** public close()
	  * close current tab
	  */
	this.close = function(kick) {
		
		tabsUl.removeChild(htmlTab);
		RoomsDiv.removeChild(htmlRoomDiv);
		
		if (__self.loaded) {
			
			if (type == "room") {
				
				getMessages();
				var httpCloseRoom = new Ajax("GET", "close_room.php?id="+id+"&kick="+kick, true);
				httpCloseRoom.load();
				
			} else {
				
				var httpClosePrivate = new Ajax("GET", "close_private.php?id="+id, true);
				httpClosePrivate.load();
				
			}
			
		}
		
		MessageForm.form.roomid.value = "null";
		MessageForm.form.roomtype.value = "null";
		
		try {
			eval(prevRoomType + "s[" + prevRoomId + "].display();");
		} catch(e) {}
		
		setTimeout("delete " + type + "s[" + id + "]", 10);
		
	}
	
	this.onload = function() { }
	
	// -----------
	
	if (type == "room") {
		var httpRoomInfo = new Ajax("GET", "get_room_info.php?id="+id, true);
		httpRoomInfo.oncomplete = parseRoomInfo;
		var httpRoomUsers = new Ajax("GET", "get_room_users.php?id="+id, true);
		httpRoomUsers.oncomplete = parseRoomUsers;
	} else if (type == "private") {
		var httpPrivateInfo = new Ajax("GET", "get_private_info.php?id="+id, true);
		httpPrivateInfo.oncomplete = parsePrivateInfo;
	}
	
	start();
	
}