// GLOBAL VARIABLES

// HTTP object for message parsing
var httpMsgObj = new Ajax("GET", "get_messages.php", true);

// Counter for message reloading
var msgCounter = null;

// Variable for rooms
var rooms = new Array();

// Variable for private conversations
var privates = new Array();

// actual room id
var actRoomId;

// actual room type
var actRoomType;

// previous room id
var prevRoomId;

// previous room type
var prevRoomType;

// Other variables
var MessageForm;

var soundsActive = false;

var fontPanelOver = false;
var optionPanelOver = false;

// Anti-Flood Variables
var TypeCount = 0;
var TypeCountTimer;

// UserID selected for the contextMenu
var conMenuId = null;
var conMenuNick = null;

// ---------------------

// START HERE!

window.onload = function() {
	
	MessageForm = new AjaxForm("sendform");
	MessageForm.form.setAttribute("autocomplete", "off");
	
	// Delete message after send
	MessageForm.form.onsubmit = function() {
		
		if (TypeCount < 3) {
			
			MessageForm.send();
			MessageForm.form.message.value = "";
			MessageForm.form.message.focus();
			
			TypeCount++;
			clearTimeout(TypeCountTimer);
			TypeCountTimer = setTimeout('TypeCount = 0; clearTimeout(TypeCountTimer);', antiFloodTime);
			
		}
		
		return false;
		
	}
	
	// Check send successful
	MessageForm.oncomplete = checkSend;
	
	rooms[startRoomId] = new Room("room", startRoomId);
	rooms[startRoomId].onload = function() { document.getElementById("loading").style.display = "none"; }
	
	var fontPanel = document.getElementById("fontPanel");
	fontPanel.onmouseover = function() { fontPanelOver = true; }
	fontPanel.onmouseout = function() { fontPanelOver = false; }
	
	var optionPanel = document.getElementById("optionPanel");
	optionPanel.onmouseover = function() { optionPanelOver = true; }
	optionPanel.onmouseout = function() { optionPanelOver = false; }

	
	MessageForm.form.color.onchange = function() {
		
		 MessageForm.form.message.style.color = MessageForm.form.color.options[MessageForm.form.color.selectedIndex].text;
		
	}
	
	MessageForm.form.bold.onclick = function() {
		
		MessageForm.form.bold.checked ? MessageForm.form.message.style.fontWeight = "bold" : MessageForm.form.message.style.fontWeight = "normal";
		
	}
	
	MessageForm.form.italic.onclick = function() {
		
		MessageForm.form.italic.checked ? MessageForm.form.message.style.fontStyle = "italic" : MessageForm.form.message.style.fontStyle = "normal";
		
	}
	
	MessageForm.form.underline.onclick = function() {
		
		MessageForm.form.underline.checked ? MessageForm.form.message.style.textDecoration = "underline" : MessageForm.form.message.style.textDecoration = "none";
		
	}
	
	document.getElementById("activeSound").onclick = function() { soundsActive = !soundsActive; }
	
	// Initialize Sound Manager
	soundManagerInit();
	
}

// ---------------------

/** sayTo ()
  * send a message to a user
  * @param string user nick
  */
 function sayTo(nick) {
 
 	MessageForm.form.message.value += " > " + nick + ": ";
 	MessageForm.form.message.focus();
 		
 }

/** newPrivate()
  * create a new private conversation from user id
  * @param int user id
  * @param string user nick
  */
function newPrivate(toUid, toNick) {
	
	var privateExist = false;
	
	for (id in privates) {
		
		if (privates[id].roomName == toNick) {
			
			privateExist = true;
			privates[id].display();
			break;
			
		}
		
	}
	
	if (!privateExist && toUid != uid) {
		
		// HTTP object for private conversations id
		var httpPrivateId = new Ajax("GET", "get_private_id.php?toUid="+toUid, true);
		
		httpPrivateId.oncomplete = function(response) {
			
			eval("var privateId = "+response+";");
			
			if (typeof error != 'undefined')
				myAlert(error);
			else
				privates[privateId] = new Room("private", privateId);
			
		}
		
		httpPrivateId.load();
		
	}
	
}

// ---------------------

/** getMessages()
  * Load new messages
  */
function getMessages() {
	
	// isParsingMessages = true;
	httpMsgObj.load();
	
}

/** parseMessages()
  * parse new messages
  */
function parseMessages(response) {
	
	if(response.length > 5) {
		
		eval("var Messages = " + response);
		
		for(var i = 0; i < Messages.length; i++) {
			
			// call room addMessage method
			// rooms[Messages[i].roomid].addMessage(Messages[i]);
			var m = Messages[i];
			
			var blockStyle = "background-color: " + m.bgColor + "; color: " + m.textColor + ";";
			
			try {
				
				var object = (m.roomtype == "room") ? rooms[m.roomid] : privates[m.roomid];
				object.addMessage(m.sysmsg, m.time, m.nick, m.text, m.style, blockStyle);
				
			} catch(e) {
				
				if (!m.sysmsg) {
					
					var object = m.roomtype+"s["+m.roomid+"]";
					eval(object + "= new Room('" + m.roomtype + "', " + m.roomid + ")");
					eval(object + ".addMessage(" + m.sysmsg + ", '" + m.time + "', '" + m.nick + "', '" + m.text + "', '" + m.style + "', '" + blockStyle + "')");
					
				}
				
			}
			
		}
		
		
		if (typeof error != "undefined")			
			myAlert(error);
		if (typeof action != "undefined")
			eval(action);
		
	}
	
	if (/MSIE/.test(navigator.userAgent) || /KHTML/.test(navigator.userAgent))
		httpMsgObj.httpObj.abort();
	
	// isParsingMessages = false;
	clearTimeout(msgCounter);
	msgCounter = setTimeout("getMessages()", __interval);
	
}

httpMsgObj.oncomplete = parseMessages;

/*function reloadMessages() {
	
	if (!isParsingMessages) {
		
		// Stop message counter
		clearTimeout(msgCounter);
		
		// Display new messages
		msgCounter = setTimeout("getMessages()", 20);
		
	} else {
		
		setTimeout("reloadMessages()", 20);
		
	}
	
}*/

/** checkSend()
  * check if message have been sent
  */
function checkSend(response) {
	
	eval("var error = " + response);
	
	if (error[0]) {
		
		myAlert(error[1]);
		
	} else {
		
		getMessages();
		
	}
	
}

/** insertSmile()
  * when user click on a smile, insert it into message box
  * @param string - smile code
  */
function insertSmile(code) {
	
	MessageForm.form.message.value += " " + code + " ";
	MessageForm.form.message.focus();
	
}

/** togglePanel()
  * open (or close) the panel passed as argument
  * @param string panel name
  */
function togglePanel(panel) {
	
	var div = document.getElementById(panel + "Panel");
	div.style.display = (div.style.display == "block") ? "none" : "block";
	
}

/** toggleWindow()
  * open (or close) a window
  * @param STRING window name
  */
function toggleWindow(name) {
	
	var windowDiv = document.getElementById(name+"Window");
	var returned = null;
	
	if (windowDiv.style.display == "block") {
		
		windowDiv.style.display = "none";
		
		if (name == "alert") {
			
			document.getElementById("cover").style.display = "none";
			
		}
		
	} else {
		
		// Find close button and link this method to its onclick event
		var closeButton = windowDiv.getElementsByTagName("h1")[0].getElementsByTagName("span")[0];
		closeButton.onclick = function() { toggleWindow(name); }
		
		if (name == "rooms") {
			
			// Find list container
			var listContainer = windowDiv.getElementsByTagName("div")[0];
			listContainer.innerHTML = "";
			
			// HTTP object for rooms list
			var httpRoomsList = new Ajax("GET", "get_rooms_list.php", true);
			
			httpRoomsList.oncomplete = function(response) {
				listContainer.innerHTML = response;
			}
			
			httpRoomsList.load();
			
		} else if (name == "kick") {
			
			var KickForm = new AjaxForm("kickForm");
			KickForm.form.uid.value = conMenuId;
			KickForm.form.roomid.value = actRoomId;
			KickForm.form.getElementsByTagName("label")[0].innerHTML = _LCHAT_KICKUSER_REASON.replace('%s', '<strong>' + conMenuNick + '</strong>');
			document.getElementById("cancelKick").onclick = function() { toggleWindow(name); }
			
			KickForm.oncomplete = function(response) {
				
				eval("var error = " + response + ";");
				
				if(error[0])
					myAlert(error[1]);
				
				toggleWindow('kick');
				KickForm.form.reason.value = "";
				
			}
			
		} else if (name == "ban") {
			
			var BanForm = new AjaxForm("banForm");
			BanForm.form.uid.value = conMenuId;
			BanForm.form.roomid.value = actRoomId;
			BanForm.form.getElementsByTagName("label")[0].innerHTML = _LCHAT_BANUSER_REASON.replace('%s', '<strong>' + conMenuNick + '</strong>');
			
			var now = new Date();
			BanForm.form.day.options[now.getDate()-1].selected = true;
			BanForm.form.month.options[now.getMonth()].selected = true;
			BanForm.form.hours.options[now.getHours()].selected = true;
			BanForm.form.minutes.options[now.getMinutes()].selected = true;
			
			document.getElementById("cancelBan").onclick = function() { toggleWindow(name); }
				
			BanForm.oncomplete = function(response) {
				
				eval("var error = " + response + ";");
				
				if(error[0])
					myAlert(error[1]);
				
				toggleWindow('ban');
				BanForm.form.reason.value = "";
				
			}
			
		} else if (name == "ignores") {
			
			// Find list container
			var listContainer = windowDiv.getElementsByTagName("div")[0];
			
			var httpIgnoreList = new Ajax("GET", "get_ignore_list.php", true);
			httpIgnoreList.oncomplete = function(response) {
				
				eval(response);
				
				// console.log(ignoreList.length);
				if (ignoreList.length == 0)
					listContainer.innerHTML = _LCHAT_NOIGNOREPRESENT;
				else {
					
					var output = '<ul>';
					for (el in ignoreList) {
						output += '<li>';
						output += '<strong>' + ignoreList[el].uname + '</strong> ';
						output += '[ <a href="javascript:cancelIgnore('+ignoreList[el].uid+')">'+_CANCEL+'</a> ]';
						output += '</li>';
					}
					
					output += '</ul>';
					listContainer.innerHTML = output;
					
				}
				
			}
			httpIgnoreList.load();
			
		} else if (name == "alert") {
			
			document.getElementById("cover").style.display = "block";
			var winContent = windowDiv.getElementsByTagName("div")[0];
			winContent.getElementsByTagName("input")[0].onclick = function() { toggleWindow(name); }
			returned = [ windowDiv, winContent ];
			
		} else if (name == "invites") {
			
			var httpUsersList = new Ajax("GET", "get_users_list.php", true);
			httpUsersList.oncomplete = function(response) {
				
				var InviteForm = new AjaxForm("inviteForm");
				InviteForm.oncomplete = function(response) {
					toggleWindow("invites");
				}
				
				eval(response);
				
				var select = InviteForm.form.uid;
				// Delete select content
				select.innerHTML = "";
				
				if (users.length > 0) {
					
					for (el in users) {
						
						var u = users[el];
						var opt = new Option(u.uname, u.uid);
						select.options[select.length] = opt;
						
					}
					
				}
				
			}
			
			httpUsersList.load();
			
		} else if (name == "color") {
			
			var ColorForm = new AjaxForm("colorForm");
			ColorForm.oncomplete = function(response) {
				toggleWindow("color");
				getMessages();
			}
			
		}
		
		windowDiv.style.display = "block";
		return returned;
		
	}
	
}

/**
  * adds a user to the ignore list
  * @param int the id of the user to ignore
  */
function ignore(id) {
	
	var httpIgnore = new Ajax("GET", "ignore_user.php?id="+id, true);
	httpIgnore.oncomplete = function(response) {
		
		eval(response);
		
		myAlert(message);
		
	}
	httpIgnore.load();
	
}

/**
  * delete an user from the ignore list
  * @param int the id of the user to cancel
  */
function cancelIgnore(id) {
	
	var httpCancelIgnore = new Ajax("GET", "cancel_ignore.php?id="+id, true);
	httpCancelIgnore.oncomplete = function(response) {
		
		// Close ignores window
		toggleWindow("ignores");
		
		// Re-open ignores window
		toggleWindow("ignores");
		
	}
	httpCancelIgnore.load();
	
}

/** myAlert
  * display a custom alert message (beacuse the javascript core alert function blocks script execution)
  * @param STRING message to display
  */
function myAlert(message) {
	
	var winInfo = toggleWindow("alert");
	var msgCont = winInfo[1].getElementsByTagName("div")[0]
	msgCont.innerHTML = message;
	winInfo[0].style.height = (msgCont.offsetHeight + 46) + "px";
	winInfo[0].style.marginTop = - ( (msgCont.offsetHeight + 46) / 2) + "px";
	
}

/** openContextMenu()
  * open (or close) user context menu
  */
function openContextMenu(e) {
	
	var menu = document.getElementById("contextMenu");
	
	document.getElementById("viewProfile").onclick = function() { viewProfile(conMenuId); }
	document.getElementById("openPrivate").onclick = function() { newPrivate(conMenuId, conMenuNick); }
	document.getElementById("sayToUser").onclick = function() { sayTo(conMenuNick); }
	document.getElementById("ignoreUser").onclick = function() { ignore(conMenuId); }
	if (is_admin) {
		document.getElementById("kickUser").onclick = function() { toggleWindow("kick"); }
		document.getElementById("banUser").onclick = function() { toggleWindow("ban"); }
	}
	
	var x = 0;
	var y = 0;
	if (!e) e = window.event;
	
	x = (e.pageX) ? e.pageX : e.clientX;
	y = (e.pageY) ? e.pageY : e.clientY;
	
	menu.style.display = "block";
	menu.style.top = y + "px";
	menu.style.left = (x - menu.offsetWidth) + "px";
	
}

/** viewProfile()
  * open a window with the user profile
  */
function viewProfile(id) {
	
	window.open(XOOPS_URL+"/userinfo.php?uid="+id);
	
}

/** saveConversation()
  * Save actual conversation on an HTML file.
  */
function saveConversation() {
	
	var win = window.open('', '',"toolbar=0,menubar=1,location=0,scrollbars=1,status=1,resizable=1,width=800,height=600,left=10,top=10");
	
	var array = actRoomType == "room" ? rooms : privates;
	
	var code = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">\n';
    code += '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="it">\n\n';
	code += '	<head>\n\n';
	code += '		<title>'+_LCHAT_SAVEC_TITLE+'</title>\n';
	code += '		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />\n';
	code += '		<link href="'+XOOPS_URL+'/modules/dragonflychat/style/style.css" rel="stylesheet" type="text/css" />\n\n';
	code += '		<link href="'+XOOPS_URL+'/themes/'+XOOPS_THEME+'/style/style.css" rel="stylesheet" type="text/css" />\n\n';
	code += '	</head>\n\n';
	code += '	<body>\n\n';
	code += '		<div class="msgcont" style=\"margin: 15px;\">\n\n';
	code += array[actRoomId].MessageContainer.innerHTML;
	code += '		</div>\n\n';
	code += '	</body>\n\n';
	code += '</html>';
	
	win.document.open("text/html");
	win.document.write(code);
	win.document.close();
	
}

/** closeAllPanels()
  * close all opened panels
  */
function closeAllPanels() {
	
	document.getElementById("smiliesPanel").style.display = "none";
	
	if (!fontPanelOver) { document.getElementById("fontPanel").style.display = "none"; }
	
	if (!optionPanelOver) { document.getElementById("optionPanel").style.display = "none"; }
	
	document.getElementById("contextMenu").style.display = "none";
	
}

window.onclick = closeAllPanels;
document.onclick = closeAllPanels;

// ---------------------

// END HERE!
window.onunload = function() {
	
	var color = MessageForm.form.color.value;
	MessageForm.form.bold.checked ? bold = 1 : bold = 0;
	MessageForm.form.italic.checked ? italic = 1 : italic = 0;
	MessageForm.form.underline.checked ? underline = 1 : underline = 0;
	
	var page = "logout.php?color="+color+"&bold="+bold+"&italic="+italic+"&underline="+underline;
	
	var httpLogoutObj = new Ajax("GET", page, false);
	httpLogoutObj.oncomplete = function(response) {
		
		eval("var error = "+response);
		
		if (error[0]) {
			
			myAlert(error[1]);
			
		}
		
	}
	
	httpLogoutObj.load();
	
}