/** getElementsByClassName
  * get all elements of the page that have the specified class name
  * @param string tag of the elements that have the speciefied class name
  * @param string class name
  */
function getElementsByClassName(tag, className) {
	
	var tagElements = document.getElementsByTagName(tag);
	
	var returned = new Array();
	
	for (el in tagElements) {
		
		if (tagElements[el].className == className) {
			
			returned[returned.length] = tagElements[el];
			
		}
		
	}
	
	return returned;
	
}

var tabMaxScroll = 0;

/** resizer()
  * Resizes some block of the script
  */
function resizer() {
	
	var body = document.getElementsByTagName("body")[0];
	var bodyWidth = body.offsetWidth;
	var bodyHeight = body.offsetHeight;
	
	// IE 6 Hack for body Height
	if(/MSIE 6/i.test(navigator.userAgent)) {
		bodyWidth = document.documentElement.clientWidth;
		bodyHeight = document.documentElement.clientHeight;
	}
	
	var tabsDiv = document.getElementById("tabs");
	var bottomDiv = document.getElementById("bottom");
	
	// Changes #rooms width
	document.getElementById("rooms").style.width = (bodyWidth - 40) + "px";
	
	// Change #rooms height
	var roomsHeight = bodyHeight - tabsDiv.offsetHeight - bottomDiv.offsetHeight - 20;
	document.getElementById("rooms").style.height = roomsHeight + "px";
	
	// Change #rooms top
	document.getElementById("rooms").style.top = (tabsDiv.offsetHeight + 20) + "px";
	
	// Changes all .room height
	var roomDivs = getElementsByClassName("div", "room");
	
	var roomH1;
	
	for (el in roomDivs) {
		roomDivs[el].style.height = roomsHeight + "px";
		if (roomDivs[el].style.display == "block" || roomDivs[el].style.display == "")
			roomH1 = roomDivs[el].getElementsByTagName("h1")[0];
	}
	
	// Changes all .msgcont height
	var msgcontDivs = getElementsByClassName("div", "msgcont");
	
	for (el in msgcontDivs) {
		msgcontDivs[el].style.height = (roomsHeight - roomH1.offsetHeight - 20) + "px";
	}
	
	// Changes all .usrcont height
	var usrcontDivs = getElementsByClassName("ul", "usrcont");
	
	for (el in usrcontDivs) {
		usrcontDivs[el].style.height = (roomsHeight - roomH1.offsetHeight) + "px";
	}
	
	// Change #message width
	document.getElementById("message").style.width = (bodyWidth - 220) + "px";
	
	// Check if tab scroll
	// checkTabScroller();
	var tabsLis = document.getElementById("tabs_ul").getElementsByTagName("li");
	
	var LisWidth = 0;
	for (var i=0; i < tabsLis.length; i++)
		LisWidth += tabsLis[i].offsetWidth;
	
	var tabScroller = document.getElementById("tabScroller");
	
	if ( (LisWidth > tabsDiv.offsetWidth) && tabScroller.style.display != "block" ) {
		tabScroller.style.display = "block";
		tabsDiv.style.marginRight = "55px";
		tabMaxScroll = LisWidth - tabsDiv.offsetWidth + 70;
	} 
	
	if ( (LisWidth < tabsDiv.offsetWidth) && tabScroller.style.display == "block" ) {
		tabScroller.style.display = "none";
		tabsDiv.style.marginRight = "0px";
		tabsDiv.scrollLeft = 0;
	}
	
}

window.onresize = resizer;

function tabScrollLeft() {
	var tabsDiv = document.getElementById("tabs");
	var newScroll = tabsDiv.scrollLeft - 100;
	tabsDiv.scrollLeft = (newScroll < 0) ? 0 : newScroll;
}

function tabScrollRight() {
	var tabsDiv = document.getElementById("tabs");
	var newScroll = tabsDiv.scrollLeft + 100;
	tabsDiv.scrollLeft = (newScroll > tabMaxScroll) ? tabMaxScroll : newScroll;
}
