CREATE TABLE lchat_connected (
  uid mediumint(8) NOT NULL default '0',
  roomid mediumint(3) NOT NULL default '0'
);

CREATE TABLE lchat_rooms (
  roomid int(3) NOT NULL auto_increment,
  name varchar(20) NOT NULL default '',
  topic text NOT NULL,
  type enum('normal', 'reserved') NOT NULL,
  usergroups varchar(255) default NULL,
  PRIMARY KEY (roomid)
);

INSERT INTO lchat_rooms (roomid, name, topic, type) VALUES (1, 'Default Room', 'Default room for general conversations', 'normal');

CREATE TABLE lchat_messages (
  id int(5) NOT NULL auto_increment,
  roomid int(3) NOT NULL default '0',
  roomtype enum('room', 'private') NOT NULL,
  uid mediumint(8) NOT NULL default '0',
  message text NOT NULL,
  style varchar(255),
  mtime int(10) NOT NULL default '0',
  sysmsg tinyint(1) NOT NULL default '0',
  PRIMARY KEY (id)
);

CREATE TABLE lchat_users (
  uid mediumint(8) NOT NULL default '0',
  last_msg_id int(5) default '0',
  last_action int(10) NOT NULL default '0',
  is_admin tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (uid)
);

CREATE TABLE lchat_privates (
  pid int(3) NOT NULL auto_increment,
  fromUid mediumint(8) NOT NULL,
  toUid mediumint(8) NOT NULL,
  PRIMARY KEY  (pid)
);

CREATE TABLE lchat_preferences (
  uid mediumint(8) NOT NULL,
  message_color varchar(6) NOT NULL default 'auto',
  background_color varchar(6) NOT NULL,
  text_color varchar(6) NOT NULL,
  bold tinyint(1) NOT NULL,
  italic tinyint(1) NOT NULL,
  underline tinyint(1) NOT NULL,
  PRIMARY KEY (uid)
);

CREATE TABLE lchat_banned (
  bid int(3) NOT NULL auto_increment,
  uid int(5) NOT NULL,
  roomid int(3) NOT NULL,
  until int(10) NOT NULL,
  type enum('kick','ban') NOT NULL,
  displayed tinyint(1) NOT NULL default '0',
  reason varchar(255) default NULL,
  PRIMARY KEY (bid)
);

CREATE TABLE lchat_archives (
  arkid int(3) NOT NULL auto_increment,
  arkname varchar(50) NOT NULL,
  arkdesc text NOT NULL,
  arktime int(10) NOT NULL,
  usergroups text NOT NULL,
  PRIMARY KEY (arkid)
);

CREATE TABLE lchat_invites (
fromUid MEDIUMINT(8) NOT NULL,
toUid MEDIUMINT(8) NOT NULL,
time INT(10) NOT NULL
);

CREATE TABLE lchat_ignores (
  uid mediumint(8) NOT NULL,
  who mediumint(8) NOT NULL
);

CREATE TABLE lchat_config (
  msg_interval int(5) unsigned NOT NULL,
  logout_time int(5) unsigned NOT NULL,
  flood_time int(5) unsigned NOT NULL,
  delete_msg_after int(7) unsigned NOT NULL
);

INSERT INTO lchat_config (msg_interval, logout_time, flood_time, delete_msg_after) VALUES (5000, 20, 3000, 0);