<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+

include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/Tools.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/Category.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/QueriesCategory.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/RenderCategory.php");

function category_list()
{
    
    $render = new RenderCategory();
		$render->adminManageCategoryTitle();
		
		if ( Tools::userIsWebmaster() )
    {    
			$categories = QueriesCategory::loadAllCategories();
		}
		else 
		{
    	$categories = QueriesCategory::loadAllCategoriesByAccessGroups(Tools::getUserGroups());
    }
    
    echo $render->adminListByDbResource ($categories);
}

function category_create()
{

	  $render = new RenderCategory();
  
    if ( ! Tools::userIsWebmaster() )
    {
    	$render->adminCannotManageCategoryError();
    }

    $render->inputForm();
}

function category_validate()
{
    global $_POST, $xoopsModule,$_FILES;
    $render = new RenderCategory ();
    
    if ( ! Tools::userIsWebmaster() )
    {
    	$render->adminCannotManageCategoryError();
    	exit();
    }
	
		// Convert groups array in string
		$_POST['access_groups']=Tools::groupsArrayToString($_POST['access_groups']);
		
	  $category = new Category($_POST);
	  $render->setCategory($category);
	  
	  // Validate form
    $errors = $category->validate();
    if ( $errors === false )
    {		
        // Upload the image
	if ( !empty($_FILES['imageURL_image']['name']) ) 
	{
	   include_once(XOOPS_ROOT_PATH."/class/fileupload.php");
	   $upload = new fileupload();
	   $upload->set_upload_dir(XOOPS_ROOT_PATH . "/modules/".$xoopsModule->dirname()."/cache/images/", 'imageURL_image');
	   $upload->set_accepted("gif|jpg|png", 'image');
	   $upload->set_overwrite(1, 'image');
	   $result = $upload->upload();
	   if ($result['imageURL_image']['filename']) 
	   {
	       $category->setVar('imageURL', $result['imageURL_image']['filename']);
	   } 
	   else 
	   {
                $render->adminCategoryUploadError($upload->errors());
	   }
	}

        
        // Save the data in db
        if ( $category->save() )
        {        
            // All done!
            $render->categoryStoreDone();
        }
        else
        {
            $render->categoryStoreError();
        }
    }
    else
    {
        // Show errors
        $render->categoryValidateErrors( $errors );
        // Show form again
        $render->inputForm();
        
    }

}

function category_edit()
{
		global $_GET;
		
		$render = new RenderCategory();
		
		if ( ! Tools::userIsWebmaster() )
    {
    	$render->adminCannotManageCategoryError();
    }
    
		if (!empty($_GET['cid'])) 
		{
			$cid = intval($_GET['cid']);
		} 
		else
		{
			$render->adminCategoryNoCidError();
		}
		
		$category = new Category ($cid);
		
		if ( $category->isEmpty() )
		{
			$render->adminCategoryCidError();
		}
		
		$render->setCategory($category);
    $render->inputForm();
    
}

function category_confirmdelete()
{
		global $_GET;
		
		$render = new RenderCategory();
		
		if ( ! Tools::userIsWebmaster() )
    {
    	$render->adminCannotManageCategoryError();
    }
    
		if (!empty($_GET['cid'])) 
		{
			$cid = intval($_GET['cid']);
		} 
		else
		{
			$render->adminCategoryNoCidError();
		}
		
		$category = new Category ($cid);
		
		if ( $category->isEmpty() )
		{
			$render->adminCategoryCidError();
		}
		$render->setCategory($category);
		$render->adminCategoryDeleteConfirm();
		   
}

function category_delete()
{
		global $_POST;
		
		$render = new RenderCategory();
		
		if ( ! Tools::userIsWebmaster() )
    {
    	$render->adminCannotManageCategoryError();
    }
    
		if (!empty($_POST['cid'])) 
		{
			$cid = intval($_POST['cid']);
		} 
		else
		{
			
			$render->adminCategoryNoCidError();
		}
		
		$category = new Category ($cid);
		
		if ( $category->isEmpty() )
		{
			$render->adminCategoryCidError();
		}
		

    if ( $category->drop(true) )
    {
    	$render->adminCategoryDeleted();
    }
    else
    {
    	$render->adminCategoryDeleteError();
    }
}
    

?>