<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/Tools.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/Forum.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/QueriesForum.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/RenderForum.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/RenderCategory.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/Category.php");

include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/cache/config.php");

function forum_list()
{
    global $_GET,$_POST;
    $render_category = new RenderCategory();
	
    if (!empty($_GET['cid'])) 
    {
	$cid = intval($_GET['cid']);
    }  
    elseif (!empty($_POST['cid'])) 
    {
    $cid = intval($_POST['cid']);
    }  
    else
    {
	$render_category->adminCategoryNoCidError();
    }
	
    if ( Tools::userIsWebmaster() )
    {
        $forums = QueriesForum::loadAllForumsByCategory($cid);
    }
    else 
    {
        $forums = QueriesForum::loadForumsByCategoryAndAccessGroupsAndModeratorGroups($cid, Tools::getUserGroups() );
    }
    
    
    $category = new Category ($cid);	
		
    if ( $category->isEmpty() )
    {
	   $render_category->adminCategoryCidError();
    }
    
    $render_forum = new RenderForum();
    echo $render_forum->adminManageForumTitle($category->getVar("title"));	
    echo $render_forum->adminListByDbResource ($forums, $cid);
}


function forum_create()
{

    global $_GET;
    $render = new RenderCategory();
	
	
    if (!empty($_GET['cid'])) 
    {
	$cid = intval($_GET['cid']);
    } 
    else
    {
	$render->adminCategoryNoCidError();
    }
  
    $category = new Category ($cid);	
		
    if ( $category->isEmpty() )
    {
    	$render->adminCategoryCidError();
    }

    if ( ! Tools::userIsWebmaster() )
    {
    	$render->adminCannotManageCategoryError();
    }

    $forum = new Forum();
    $forum->setVar("cid",$cid);
    
    $render_forum = new RenderForum();
    $render_forum->setForum($forum);
    
    $render_forum->inputForm();
}


function forum_validate()
{
    global $_POST, $xoopsModule,$_FILES;
    $render = new RenderForum ();
    
    if ( ! Tools::userIsWebmaster() )
    {
    	$render->adminCannotManageForumError();
    	exit();
    }
	
    // Convert groups array in string
    $_POST['access_groups']=Tools::groupsArrayToString($_POST['access_groups']);
    $_POST['moderator_groups']=Tools::groupsArrayToString($_POST['moderator_groups']);
    
    $forum = new Forum($_POST);
    $render->setForum($forum);
	  
	  // Validate form
    $errors = $forum->validate();
    if ( $errors === false )
    {		
        // Upload the image
				if ( !empty($_FILES['imageURL_image']['name']) ) {
				include_once(XOOPS_ROOT_PATH."/class/fileupload.php");
				$upload = new fileupload();
				$upload->set_upload_dir(XOOPS_ROOT_PATH . "/modules/".$xoopsModule->dirname()."/cache/images/", 'imageURL_image');
				$upload->set_accepted("gif|jpg|png", 'image');
				$upload->set_overwrite(1, 'image');
				$result = $upload->upload();
				if ($result['imageURL_image']['filename']) {
					$forum->setVar('imageURL', $result['imageURL_image']['filename']);
				} else {
					$render->adminForumUploadError($upload->errors());
				}
		}

        // Save the data in db
        if ( $forum->save() )
        {        
            // All done!
            $render->forumStoreDone();
        }
        else
        {
            $render->forumStoreError();
        }
    }
    else
    {
        // Show errors
        $render->forumValidateErrors( $errors );
        // Show form again
        $render->inputForm();
        
    }

}

function forum_edit()
{
		global $_GET;
		
		$render = new RenderForum();
		
		
		if ( ! Tools::userIsWebmaster() )
    {
    	$render->adminCannotManageForumError();
    }
    
		if (!empty($_GET['fid'])) 
		{
			$fid = intval($_GET['fid']);
		} 
		else
		{
			$render->adminForumNoFidError();
		}
		
		$forum = new Forum ($fid);
		
		if ( $forum->isEmpty() )
		{
			$render->adminForumCidError();
		}
		
		$render->setForum($forum);
    	$render->inputForm();
    
}


function forum_confirmdelete()
{
		global $_GET;
		
		$render = new RenderForum();
		
		if ( ! Tools::userIsWebmaster() )
    	{
    	 $render->adminCannotManageForumError();
    	}
    
		if (!empty($_GET['fid'])) 
		{
			$fid = intval($_GET['fid']);
		} 
		else
		{
			$render->adminForumNoFidError();
		}
		
		$forum = new Forum ($fid);
		
		if ( $forum->isEmpty() )
		{
			$render->adminForumFidError();
		}
		$render->setForum($forum);
		$render->adminForumDeleteConfirm();
		   
}

function forum_delete()
{
		global $_POST;
		$render = new RenderForum();
		
		if ( ! Tools::userIsWebmaster() )
    {
    	$render->adminCannotManageForumError();
    }
    
		if (!empty($_POST['fid'])) 
		{
			$fid = intval($_POST['fid']);
		} 
		else
		{
			
			$render->adminForumNoCidError();
		}
		
		$forum = new Forum ($fid);
		$render->setForum($forum);
		
		if ( $forum->isEmpty() )
		{
			$render->adminForumFidError();
		}
		
    if ( $forum->drop() )
    {
    	$render->adminForumDeleted();
    }
    else
    {
    	$render->adminForumDeleteError();
    }
}

function forum_config($head="", $title="", $txt="")
{
global $forumConfig;
	
//	OpenTable();
    $form = new XoopsThemeForm($head, $title, $txt);

	$CfgElement['thread_hide_contents'] = new XoopsFormRadioYN(_MD_THREAD_HIDE_CONTENTS,
															'thread_hide_contents',
															$forumConfig['thread_hide_contents']);
	$form->addElement($CfgElement['thread_hide_contents']);

	$CfgElement['tree_hide_contents'] = new XoopsFormRadioYN(_MD_TREE_HIDE_CONTENTS,
															'tree_hide_contents',
															$forumConfig['tree_hide_contents']);
	$form->addElement($CfgElement['tree_hide_contents']);

	$CfgElement['allow_html'] = new XoopsFormRadioYN(_MD_ALLOW_HTML,
															'allow_html',
															$forumConfig['allow_html']);
	$form->addElement($CfgElement['allow_html']);

	$CfgElement['allow_smileys'] = new XoopsFormRadioYN(_MD_ALLOW_SMILEYS,
															'allow_smileys',
															$forumConfig['allow_smileys']);
	$form->addElement($CfgElement['allow_smileys']);

	$CfgElement['allow_bbcode'] = new XoopsFormRadioYN(_MD_ALLOW_BBCODE,
															'allow_bbcode',
															$forumConfig['allow_bbcode']);
	$form->addElement($CfgElement['allow_bbcode']);

	$CfgElement['show_avatar_post'] = new XoopsFormRadioYN(_MD_SHOW_AVATAR_POST,
															'show_avatar_post',
															$forumConfig['show_avatar_post']);
	$form->addElement($CfgElement['show_avatar_post']);

	$CfgElement['auto_quote'] = new XoopsFormRadioYN(_MD_AUTO_QUOTE,
															'auto_quote',
															$forumConfig['auto_quote']);
	$form->addElement($CfgElement['auto_quote']);

	$CfgElement['re_re'] = new XoopsFormRadioYN(_MD_RE_RE,
															're_re',
															$forumConfig['re_re']);
	$form->addElement($CfgElement['re_re']);

	$CfgElement['tree_view'] = new XoopsFormRadioYN(_MD_TREE_VIEW,
															'tree_view',
															$forumConfig['tree_view']);
	$form->addElement($CfgElement['tree_view']);

	$CfgElement['thread_perpage'] = new XoopsFormText(_MD_THREAD_PERPAGE,
															'thread_perpage',
															11,
															11,
															$forumConfig['thread_perpage']);
	$form->addElement($CfgElement['thread_perpage']);

	$CfgElement['replay_perpage'] = new XoopsFormText(_MD_REPLAY_PERPAGE,
															'replay_perpage',
															11,
															11,
															$forumConfig['replay_perpage']);
	$form->addElement($CfgElement['replay_perpage']);

	$CfgElement['replay_order_desc'] = new XoopsFormRadioYN(_MD_REPLAY_ORDER_DESC,
															'replay_order_desc',
															$forumConfig['replay_order_desc']);
	$form->addElement($CfgElement['replay_order_desc']);

	$CfgElement['track_visits'] = new XoopsFormRadioYN(_MD_TRACK_VISITS,
															'track_visits',
															$forumConfig['track_visits']);
	$form->addElement($CfgElement['track_visits']);

	$CfgElement['popup_visit_width'] = new XoopsFormText(_MD_POPUP_VISIT_WIDTH,
															'popup_visit_width',
															11,
															11,
															$forumConfig['popup_visit_width']);
	$form->addElement($CfgElement['popup_visit_width']);

	$CfgElement['popup_visit_height'] = new XoopsFormText(_MD_POPUP_VISIT_HEIGHT,
															'popup_visit_height',
															11,
															11,
															$forumConfig['popup_visit_height']);
	$form->addElement($CfgElement['popup_visit_height']);

	$CfgElement['print_smileys'] = new XoopsFormRadioYN(_MD_PRINT_SMILEYS,
															'print_smileys',
															$forumConfig['print_smileys']);
	$form->addElement($CfgElement['print_smileys']);

	$CfgElement['print_html'] = new XoopsFormRadioYN(_MD_PRINT_HTML,
															'print_html',
															$forumConfig['print_html']);
	$form->addElement($CfgElement['print_html']);

	$CfgElement['print_avatar'] = new XoopsFormRadioYN(_MD_PRINT_AVATAR,
															'print_avatar',
															$forumConfig['print_avatar']);
	$form->addElement($CfgElement['print_avatar']);

	$CfgElement['print_bbcode'] = new XoopsFormRadioYN(_MD_PRINT_BBCODE,
															'print_bbcode',
															$forumConfig['print_bbcode']);
	$form->addElement($CfgElement['print_bbcode']);

	$CfgElement['max_fileattach_size'] = new XoopsFormText(_MD_FILEATTACH_SIZE,
															'max_fileattach_size',
															11,
															11,
															$forumConfig['max_fileattach_size']);
	$form->addElement($CfgElement['max_fileattach_size']);

	$CfgElement['fileattach_ext'] = new XoopsFormText(_MD_FILEATTACH_EXT,
															'fileattach_ext',
															50,
															100,
															$forumConfig['fileattach_ext']);
	$form->addElement($CfgElement['fileattach_ext']);

	$CfgElement['rss_enable'] = new XoopsFormRadioYN(_MD_RSS_ENABLE,
															'rss_enable',
															$forumConfig['rss_enable']);
	$form->addElement($CfgElement['rss_enable']);

	$CfgElement['rss_maxitems'] = new XoopsFormText(_MD_RSS_MAXITEMS,
															'rss_maxitems',
															11,
															11,
															$forumConfig['rss_maxitems']);
	$form->addElement($CfgElement['rss_maxitems']);

	$CfgElement['rss_maxdescription'] = new XoopsFormText(_MD_RSS_MAXDESCRIPTION,
															'rss_maxdescription',
															11,
															11,
															$forumConfig['rss_maxdescription']);
	$form->addElement($CfgElement['rss_maxdescription']);

	$CfgElement['rss_allowattach'] = new XoopsFormRadioYN(_MD_RSS_ALLOWATTACH,
															'rss_allowattach',
															$forumConfig['rss_allowattach']);
	$form->addElement($CfgElement['rss_allowattach']);


    $hidden1         = new XoopsFormHidden("op", "save");
    $submit_button   = new XoopsFormButton("", "submit", $title, "submit");

    $form->addElement($hidden1);
    $form->addElement($submit_button);

	echo RenderForum::navMenu();
    $form->display();
//	CloseTable();
}

function forum_config_save()
{
$fp = fopen(XOOPS_ROOT_PATH."/modules/forum/cache/config.php", "w");

if ($fp){
	fwrite($fp,"<?php\r\n");
	fwrite($fp,"\$forumConfig['thread_hide_contents'] = ".$_POST['thread_hide_contents'].";\r\n");
	fwrite($fp,"\$forumConfig['tree_hide_contents']   = ".$_POST['tree_hide_contents'].";\r\n");
	fwrite($fp,"\$forumConfig['allow_html']           = ".$_POST['allow_html'].";\r\n");
	fwrite($fp,"\$forumConfig['allow_smileys']        = ".$_POST['allow_smileys'].";\r\n");
	fwrite($fp,"\$forumConfig['allow_bbcode']         = ".$_POST['allow_bbcode'].";\r\n");
	fwrite($fp,"\$forumConfig['show_avatar_post']     = ".$_POST['show_avatar_post'].";\r\n");
	fwrite($fp,"\$forumConfig['auto_quote']           = ".$_POST['auto_quote'].";\r\n");
	fwrite($fp,"\$forumConfig['re_re']                = ".$_POST['re_re'].";\r\n");
	fwrite($fp,"\$forumConfig['tree_view']            = ".$_POST['tree_view'].";\r\n");
	fwrite($fp,"\$forumConfig['thread_perpage']       = ".$_POST['thread_perpage'].";\r\n");
	fwrite($fp,"\$forumConfig['replay_perpage']       = ".$_POST['replay_perpage'].";\r\n");
	fwrite($fp,"\$forumConfig['replay_order_desc']    = ".$_POST['replay_order_desc'].";\r\n");
	fwrite($fp,"\$forumConfig['track_visits']         = ".$_POST['track_visits'].";\r\n");
	fwrite($fp,"\$forumConfig['popup_visit_width']    = ".$_POST['popup_visit_width'].";\r\n");
	fwrite($fp,"\$forumConfig['popup_visit_height']   = ".$_POST['popup_visit_height'].";\r\n");
	fwrite($fp,"\$forumConfig['print_smileys']        = ".$_POST['print_smileys'].";\r\n");
	fwrite($fp,"\$forumConfig['print_avatar']         = ".$_POST['print_avatar'].";\r\n");
	fwrite($fp,"\$forumConfig['print_html']           = ".$_POST['print_html'].";\r\n");
	fwrite($fp,"\$forumConfig['print_bbcode']         = ".$_POST['print_bbcode'].";\r\n");
	fwrite($fp,"\$forumConfig['max_fileattach_size']  = ".$_POST['max_fileattach_size'].";\r\n");
	fwrite($fp,"\$forumConfig['fileattach_ext']       = '".$_POST['fileattach_ext']."';\r\n");
	fwrite($fp,"\$forumConfig['rss_enable']           = ".$_POST['rss_enable'].";\r\n");
	fwrite($fp,"\$forumConfig['rss_maxitems']         = ".$_POST['rss_maxitems'].";\r\n");
	fwrite($fp,"\$forumConfig['rss_maxdescription']   = ".$_POST['rss_maxdescription'].";\r\n");
	fwrite($fp,"\$forumConfig['rss_allowattach']      = ".$_POST['rss_allowattach'].";\r\n");
	fwrite($fp,"?>\r\n");
	fclose($fp);
	redirect_header('index.php', 3, _MD_FORUMADMIN_CONFIG_STORED);
	}
else
	redirect_header('index.php', 3, _MD_FORUMADMIN_CONFIG_NOTSTORED);

}

?>