<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+

/** 
 * Interface to HTML rendable objects
 *
 * Inherit from this class to define the public functions
 * that render in HTML format your class attributes. <p>Remember:
 * this is an "interface" only. You must redifine all functions input  
 * in your children!</p>
 * @package Categories
 */
 
include_once(XOOPS_ROOT_PATH."/class/xoopsobject.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/QueriesCategory.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/class/QueriesForum.php");
include_once(XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/cache/config.php");

class Category extends XoopsObject
{

    /**#@+
     * @access public
     */
   	var $empty_status;
    
    function Category ( $parameter = NULL )
    {
     global $forumConfig;
     
        $this->XoopsObject();
        $this->initVar("cid", "int", 0, true);
        $this->initVar("title", "textbox", NULL, true, 255, true);
        $this->initVar("category_color","textbox",NULL,true,8,false);
        $this->initVar("category_color_bg","textbox",NULL,true,8,false);
        $this->initVar("category_description", "textare", NULL, false, 25, true);
        $this->initVar("imageURL", "textbox", NULL, false, 255, false);
        $this->initVar("category_order", "int", 0, false);
        $this->initVar("access_groups", "text", "1", true, 255, false);
     
        // HTML configuration
        $this->initVar('allow_html',"int",$forumConfig['allow_html']);
		$this->initVar('allow_smileys',"int",$forumConfig['allow_smileys']);
		$this->initVar('allow_bbcode',"int",$forumConfig['allow_bbcode']);
        
        $this->setEmpty(true);
        
        // If the costructor have a parameter
        // load data form database or set object
        if ( !empty($parameter) ) {
            if ( is_array($parameter) ) {
                $this->set($parameter);
            } else {
                $this->load(intval($parameter));
	   }
	}

    }
    
    function setEmpty( $value )    
    {
    	$this->empty_status=$value;
    }
    
    function isEmpty ()
    {
    	return $this->empty_status;
    }
    
    // Database functions
    function load($cid)
    {

        $result = QueriesCategory::loadCategoryByCid(intval($cid));
        
        if (!$result)
        {
        	$this->setEmpty(true);
        	return false;
				}

	    $this->set($result);
        $this->setEmpty(false);
        return true;
    }
    
    function save ()
    {
        global $db,$myts;
        
        if ( !$this->isCleaned ) 
        {
            if (!$this->cleanVars())
                return false;
        }

        $query_param=array();
        $query_param['cid']=intval($this->getVar('cid'),"N");
        $query_param['title']=$myts->makeTboxData4Save($this->getVar('title',"N"));
        $query_param['category_color']=$myts->makeTboxData4Save($this->getVar('category_color'),"N");
        $query_param['category_color_bg']=$myts->makeTboxData4Save($this->getVar('category_color_bg'),"N");
        $query_param['category_description']=$myts->makeTboxData4Save($this->getVar('category_description',"N"));
        $query_param['imageURL']=$myts->makeTboxData4Save($this->getVar('imageURL',"N"));
        $query_param['category_order']=$this->getVar('category_order',"N");
        $query_param['access_groups']=$this->getVar('access_groups',"N");
				
				if ( $this->getVar('cid') == 0 )
				{
        	$result = QueriesCategory::insertNewCategory($query_param);
        }
        else
        {
					$result = QueriesCategory::updateCategory($query_param);
				}
				
        if ( $db->error($result) != 0 ) return false;
        
        return true;

    }
    
    function drop ( $recursive=true )
    {
    	global $db;
    	
    	if ($recursive)
    	{
    	   //Drop all forum in category
    	   $forums = QueriesForum::loadAllForumsByCategory($this->getVar('cid'));
    	   $forum = new Forum();
    	   
    	   while ( $item = $db->fetch_array($forums) )
    	   {
    	   		 $forum->set($item);
    	   		 $forum->drop(true);
    	   }
    	   
    	}
    	$result = QueriesCategory::dropCategory($this->getVar('cid'));
							
        if ( $db->error($result) != 0 ) return false;
        
        $this->setEmpty(true);
        
        return true;
    }
    
    
    function validate()
    {
        $title = $this->getVar('title');
        $access_groups = $this->getVar('access_groups');
        $cid = intval($this->getVar('cid'));
        
        $errors = array();
        
        
        if ( empty($title) )
        {
            array_push($errors,_MD_FORUMADMIN_CATEGORY_ERROR_TITLE); 
        }
        
        if ( empty($access_groups) )
        {
            array_push($errors,_MD_FORUMADMIN_CATEGORY_ERROR_ACCESSGROUPS);
        }
        
        
        if ( !isset($cid ) )
        {
            array_push($errors,_MD_FORUMADMIN_CATEGORY_ERROR_CID);
        }
        
        if ( empty($errors) )
        {
            $errors = false;;
        }

        return $errors;
    }


    function hasAccess ($groups)
    {
        global $db;
        
       if (Tools::userIsWebmaster()) return true;
       
       $result = QueriesCategory::loadCategoriesByCidAndAccessGroups($this->getVar('cid'), $groups);

       if ( $db->num_rows ( $result ) > 0 ) {
           return true;
        } else {
            return false;
        }

    }

    /**#@-*/
}
?>