<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+

/** 
 * Interface to HTML rendable objects
 *
 * Inherit from this class to define the public functions
 * that render in HTML format your class attributes. <p>Remember:
 * this is an "interface" only. You must redifine all functions input  
 * in your children!</p>
 * @package Categories
 */
 
include_once(XOOPS_ROOT_PATH."/class/xoopsobject.php");
include_once(XOOPS_ROOT_PATH."/modules/forum/class/QueriesForum.php");
include_once(XOOPS_ROOT_PATH."/modules/forum/class/QueriesPost.php");
include_once(XOOPS_ROOT_PATH."/modules/forum/cache/config.php");

class Forum extends XoopsObject
{


   	var $empty_status;


    /**#@+
     * @access public
     */
   
    
    function Forum ( $parameter = NULL )
    { global $forumConfig;
    
        $this->XoopsObject();
        $this->initVar("fid", "int", 0, true); // Forum id
        $this->initVar("cid", "int", NULL, true); // Category id
        $this->initVar("title", "textbox", NULL, true, 255, true);
        $this->initVar("forum_description", "textarea", NULL, false, 25, true);
        $this->initVar("forum_order", "int", 0, false); 
        $this->initVar("access_groups", "text", "1", true, 255, false);
        $this->initVar("moderator_groups", "text", "1", true, 255, false);
        $this->initVar("imageURL", "textbox", NULL, false, 255, false);
        $this->initVar("anon_posting","bool",false,true);

        // HTML configuration
        $this->initVar('allow_html',"int",$forumConfig['allow_html']);
		$this->initVar('allow_smileys',"int",$forumConfig['allow_smileys']);
		$this->initVar('allow_bbcode',"int",$forumConfig['allow_bbcode']);
        
        
        // If the costructor have a parameter
        // load data form database or set object
        if ( !empty($parameter) ) {
            if ( is_array($parameter) ) {
                $this->set($parameter);
			} else {
				$this->load(intval($parameter));
			}
		}

    }


    function setEmpty( $value )    
    {
    	$this->empty_status=$value;
    }
    
    function isEmpty ()
    {
    	return $this->empty_status;
    }

    
    // Database functions
    function load($fid)
    {
        $result = QueriesForum::loadForumByFid($fid);
        
        $this->set($result);
        $this->setEmpty(false);
        return true;
    }


    function validate()
    {
        $title = $this->getVar('title');
        $access_groups = $this->getVar('access_groups');
        $moderator_groups = $this->getVar('moderator_groups');
        $cid = intval($this->getVar('cid'));
        $fid = intval($this->getVar('fid'));
        
        $errors = array();
        
        
        if ( empty($title) )
        {
            array_push($errors,_MD_FORUMADMIN_FORUM_ERROR_TITLE); 
        }
        
        if ( empty($access_groups) )
        {
            array_push($errors,_MD_FORUMADMIN_FORUM_ERROR_ACCESSGROUPS);
        }
        
        if ( empty($access_groups) )
        {
            array_push($errors,_MD_FORUMADMIN_FORUM_ERROR_MODERATORGROUPS);
        }
        
        
        if ( !isset($cid ) )
        {
            array_push($errors,_MD_FORUMADMIN_CATEGORY_ERROR_CID);
        }
        
        if ( !isset($fid ) )
        {
            array_push($errors,_MD_FORUMADMIN_FORUM_ERROR_FID);
        }
        
        if ( empty($errors) )
        {
            $errors = false;;
        }

        return $errors;
    }



   function save ()
    {
        global $db,$myts;
        
        if ( !$this->isCleaned ) 
        {
            if (!$this->cleanVars())
                return false;
        }

        $query_param=array();
        $query_param['fid']=intval($this->getVar('fid'),"N");
        $query_param['cid']=intval($this->getVar('cid'),"N");
        $query_param['title']=$myts->makeTboxData4Save($this->getVar('title',"N"));
        $query_param['forum_description']=$myts->makeTareaData4Save($this->getVar('forum_description',"N"));
        $query_param['imageURL']=$myts->makeTboxData4Save($this->getVar('imageURL',"N"));
        $query_param['forum_order']=intval($this->getVar('forum_order',"N"));
        $query_param['access_groups']=$this->getVar('access_groups',"N");
        $query_param['moderator_groups']=$this->getVar('moderator_groups',"N");
        $query_param['anon_posting']=intval($this->getVar('anon_posting',"N"));
        
			
        
	if ( $this->getVar('fid') == 0 )
	{
        	$result = QueriesForum::insertNewForum($query_param);
        }
        else
        {
		$result = QueriesForum::updateForum($query_param);
	}
				
        if ( $db->error($result) != 0 ) return false;
        
        return true;

    }

 
 	function drop ( $recursive = true )
    {
    	global $db;
    	
		if ($recursive)
    	{
    	   //Drop all forum in category
    	   /*$posts = QueriesPost::loadAllPostByForum($this->getVar('forum_id'));
    	   $post = new Post();
    	   
    	   while ( $item = $db->fetch_array($posts) )
    	   {
    	   		 $post->set($item);
    	   		 $post->drop();
    	   } */
    	   QueriesPost::dropAllPostByForum($this->getVar('fid'));
    	}   
    	
			
    	$result = QueriesForum::dropForum($this->getVar('fid'));
										
        if ( $db->error($result) != 0 ) return false;
        
        $this->setEmpty(true);
        
        return true;
    }
    
    function hasAccess ($groups)
    {
       global $db;
       
       if (Tools::userIsWebmaster()) return true;
       
       $category = new Category ($this->getVar("cid"));
       
       if (!$category->hasAccess($groups)) return false;
       
       $result = QueriesForum::loadForumsByFidAndAccessGroups($this->getVar('fid'), $groups);
	   
       if ( $db->num_rows ( $result ) > 0 ) {
           return true;
        } else {
            return false;
        }

    }

    function isModerator ($groups)
    {
       global $db;
       
       if (Tools::userIsWebmaster()) return true;
       
       $result = QueriesForum::loadForumsByFidAndModeratorGroups($this->getVar('fid'), $groups);
	   
       if ( $db->num_rows ( $result ) > 0 ) {
           return true;
        } else {
            return false;
        }

    }

    /**#@-*/
}
?>