<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+


/** 
 * Interface to HTML rendable objects
 *
 * Inherit from this class to define the public functions
 * that render in HTML format your class attributes. <p>Remember:
 * this is an "interface" only. You must redifine all functions input  
 * in your children!</p>
 * @package Categories
 */
 
include_once(XOOPS_ROOT_PATH."/class/xoopsobject.php");
include_once(XOOPS_ROOT_PATH."/modules/forum/class/QueriesPost.php");
include_once(XOOPS_ROOT_PATH."/modules/forum/cache/config.php");

class Post extends XoopsObject
{


   	var $empty_status,$imagefilename;


    /**#@+
     * @access public
     */
   
    
    function Post ( $parameter = NULL , $imagefilename=NULL)
    {
     global $forumConfig;
     
        $this->XoopsObject();
        // initVar($key, $type, $value=NULL, $required=false, $maxlength=NULL, $filter=false)

        $this->initVar("post_id", "int", 0, true);
        $this->initVar("forum_id", "int", NULL, true);
        $this->initVar("parent_id", "int", NULL, true);
        $this->initVar("root_id", "int", NULL, true);
        $this->initVar("subject", "textbox", NULL, true, 255, true);
        $this->initVar("post_icon","textbox","dummy_post.png",true,255,false);
        $this->initVar("contents", "textarea", NULL, false, 25, true);
        $this->initVar("quoted_text", "textarea", NULL, false, 25, true);
        $this->initVar("imagefilename", "textbox", NULL, true, 255, true);
        $this->initVar("post_time", "int", 0, false); 
        $this->initVar("user_id", "int", NULL, true);
        
        // HTML configuration
        $this->initVar('allow_html',"int",$forumConfig['allow_html']);
		$this->initVar('allow_smileys',"int",$forumConfig['allow_smileys']);
		$this->initVar('allow_bbcode',"int",$forumConfig['allow_bbcode']);
        
        // If the costructor have a parameter
        // load data form database or set object
        if ( !empty($parameter) ) {
            if ( is_array($parameter) ) {
                $this->set($parameter);
			} else {
				$this->load(intval($parameter));
			}
		}
		
		if ($imagefilename!="")
			$this->imagefilename=$imagefilename;

    }


    function setEmpty( $value )    
    {
    	$this->empty_status=$value;
    }
    
    function isEmpty ()
    {
    	return $this->empty_status;
    }

    
    // Database functions
    function load($id)
    {
        $result = QueriesPost::loadPostByPostId($id);
        $this->set($result);
        $this->setEmpty(false);
        return true;
    }


 
 	function drop ()
    {
    	global $db;
    	
		
			
    	$result = QueriesPost::dropPost($this->getVar('post_id'));
										
        if ( $db->error($result) != 0 ) return false;
        
        $this->setEmpty(true);
        
        return true;
    }
    
     function save ()
    {
        global $db,$myts,$forumConfig;
        
        if ( !$this->isCleaned ) 
        {
            if (!$this->cleanVars())
                return false;
        }

        $query_param=array();
		if ( $this->getVar('post_id') != 0 )
	        $query_param['post_id']=intval($this->getVar('post_id',"N"));
        $query_param['forum_id']=intval($this->getVar('forum_id',"N"));
        $query_param['parent_id']=intval($this->getVar('parent_id',"N"));
        $query_param['root_id']=intval($this->getVar('root_id',"N"));
        $query_param['subject']=$myts->makeTboxData4Save($this->getVar('subject',"N"));
    	$query_param['post_icon']=$myts->makeTboxData4Save($this->getVar('post_icon'),"N");
        $query_param['contents']=$myts->makeTboxData4Save($this->getVar('contents',"N"));
        $query_param['user_id']=intval($this->getVar('user_id',"N"));

    	$file_name=$myts->makeTboxData4Save($this->getVar('file_name'),"N");
        
	   if ( $this->getVar('post_id') == 0 )
	   {
	        $query_param['post_time']=intval($this->getVar('post_time',"N"));
	        $query_param['imagefilename']=$this->imagefilename;
        	$result = QueriesPost::insertNewPost($query_param,$file_name);
			// Saved new post - sending mails to interested users
			$post= new Post(QueriesPost::getLastPostIdByForumId ($query_param['forum_id']));
			$post->email_notify($post->getVar('root_id'),$post->getVar('post_id'));    
        }
        else
        {
		if ($this->imagefilename!="")
        	$query_param['imagefilename']=$this->imagefilename;
		$result = QueriesPost::updatePost($query_param);
	}
				
        if ( $db->error($result) != 0 ) return false;
        
		// Update rss feed
		$this->build_rss($query_param['forum_id']);
        return true;

    }
    
    function isUnread ()
    {
     global $xoopsUser;
     
     // If user is anonymous, all posts are red
     if (!$xoopsUser) return false;
    
     $uid = $xoopsUser->uid();
     $this->getVar("root_id") ? $pid = $this->getVar("root_id") : $pid = $this->getVar("post_id");
     $lastread = QueriesPost::lastVisit($pid,$uid);
     
     if ($lastread > $this->getVar('post_time')) return false;
     else return true;
     
    }
    /**#@-*/

	function email_notify($root_id,$post_id){
		global $xoopsMailer,$xoopsConfig,$meta, $db;

		$post=new Post($post_id);
		$root=new Post($post->getVar('root_id'));
		$forum= new Forum($post->getVar('forum_id'));
		
		$sql="SELECT user_id FROM ".$db->prefix('forum_topics_mail')." WHERE topic_id=$root_id;";
		$result=$db->query($sql);

		$cc=0;
		//$emailTo = new array();

		while ( $myrow = $db->fetch_array($result) ){
			$uid = new XoopsUser($myrow['user_id']);
			$emailTo[$cc]=$uid->email();	
			$cc++;
			}

		$user = $post->getVar("user_id");
		if ( $user != 0 ){
		    $user = new XoopsUser ($user);
			}

		$subject=$post->getVar("subject","S");
		$title = $forum->getVar("title","S");
		$topic = $root->getVar("subject","S");
		$poster= $user ? $user->uname() : _MD_FORUM_POST_USER_ANONYMOUS;
		$post_date = formatTimestamp($post->getVar ('post_time'),"m");
		$link = XOOPS_URL."/modules/forum/post.php?post_id=$post_id#post_item_$post_id\n";

		$msg= sprintf(_MD_FORUM_NOTIFY_NEW_POST,$title,$topic,$subject,$poster,$post_date,$link);

    	$xoopsMailer =& getMailer();
		$xoopsMailer->useMail();
		$xoopsMailer->setToEmails($emailTo);
		$xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
		$xoopsMailer->setFromName($meta['brieftitle']);
		$xoopsMailer->setSubject(_MD_FORUM_POST_NEWPOST." - Forum : $title");
		$xoopsMailer->setBody($msg);
		$xoopsMailer->send();

	}

	function build_rss($forum_id='') {
	global $db, $forumConfig;

	if ($forumConfig['rss_enable'] == 1) {

	$SQL = "SELECT user_id, subject, post_id, contents, post_time, root_id, imagefilename FROM ".$db->prefix("forum_posts");
	if ($forum_id)
	$SQL .=" WHERE forum_id=".$forum_id;
	$SQL .=" ORDER BY post_time DESC";

	$query = $db->query($SQL, $forumConfig['rss_maxitems']);

	$forum = new Forum($forum_id);
	$find    = "/[^A-Za-z0-9_-]/";
	$replace = "_";
	$text=$forum->getVar('title');
	$forumName=	preg_replace($find, $replace, $text);
	

	if ($query) {
		include_once(XOOPS_ROOT_PATH . "/class/xml-rss.php");
		$rss = new xml_rss(XOOPS_ROOT_PATH.'/modules/forum/cache/forum_'.$forumName.'.xml');
		$rss->channel_title .= " :: "._MD_FORUM_PRINTTHREAD_FORUM.$forum->getVar('title');
		$rss->image_title   .= " :: "._MD_FORUM_PRINTTHREAD_FORUM;
		$rss->max_items            = $forumConfig['rss_maxitems'];
		$rss->max_item_description = $forumConfig['rss_maxdescription'];

		while ( list($user_id, $subject, $post_id, $contents, $post_time, $root_id, $file_attach) = $db->fetch_row($query) ) {
			$root = new Post($root_id);
			$forum = new Forum($root->getVar('forum_id'));
			$category = new Category($forum->getVar('cid'));
			$uid = new XoopsUser($user_id);
			$uDesc = ($uid->user_viewemail() ? $uid->email():'')." (".$uid->name().")";
			$cDesc = $category->getVar('title');

			if ($root_id !=0 )
				$subject = $root->getVar('subject')." :: ".$subject;
			else
				$subject = "TOPIC -- ".$subject;

			$path= '/modules/forum/cache/attach/';
			
			if (!$forumConfig['rss_allowattach']){
				$path='';
				$file_attach='';
			}			
			$link = XOOPS_URL . '/modules/forum/post.php?post_id=' . $post_id.'#post_item_'.$post_id;
	 		$post_time = strftime ("%a, %d %b %Y %H:%M:%S +0000", $post_time);
			$rss->build($subject, $link, $contents, $post_time,$file_attach,$path,$uDesc,$cDesc);
			}
		$rss->save();
		}

	}

}


}

?>