<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+

/** 
 * Contents alla used SQL queries
 *
 * This class is used to collect all used quesries 
 * of module. You get the SQL string using available methods;
 * @package Queries
 */
 

class Queries
{
    
    /**
     * SQL query: select a Category form db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function loadCategoryByCid ( $cid )
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_categories")."` ";
        $query .= " WHERE `cid`=".$cid;
        
        $result  = $db->query($query);
        $numrows = $db->num_rows($result);

        if ( $numrows > 1 ) {
            die("Duplicate User Entries!");
        } else {
			$myrow = $db->fetch_array($result);
		}
        
        return $myrow;
    }

    /**
     * SQL query: select all Categories form db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllCategoriesByGroups ( $groups )
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_categories")."` WHERE ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "groups like '%$group%'";
        }
        $query.= " or groups = 'all' ORDER BY category_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    /**
     * SQL query: select all Categories form db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllCategories ()
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_categories")."` WHERE 1";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    
    /**
     * SQL query: select a Category by cis and group access
     * @param int category id
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadCategoriesByCidAndGroups ( $cid, $groups )
    {
        global $db;
        
        $query  = "SELECT cid FROM `".$db->prefix("forum_categories")."` WHERE cid='".$cid."' AND ( ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "groups like '%$group%'";
        }
        $query.= " or groups = 'all' ) ORDER BY category_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    

    /**
     * SQL query: select all Categories form db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllForumsByCategory ( $cid )
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_forums")."` WHERE `cat_id`=".$cid;
        $result  = $db->query($query);
        
        return $result;
    }
    
    /**
     * SQL query: select a Forum form db by fid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function loadForumByFid ( $fid )
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_forums")."` ";
        $query .= " WHERE `fid`=".$fid;
        
        $result  = $db->query($query);
        $numrows = $db->num_rows($result);

        if ( $numrows > 1 ) {
            die("Duplicate User Entries!");
        } else {
			$myrow = $db->fetch_array($result);
		}
        
        return $myrow;
    }


    /**
     * SQL query: insert a new Category form db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function insertNewCategory ( $params )
    {
        global $db;
        
        $query  = "INSERT INTO `".$db->prefix("forum_categories")."` ";
        $start_flag=true;
        
        foreach ( $params as $key => $value )
        {
            if ($start_flag)
            {
                $query .= "SET `".$key."`='".$value."' ";
                $start_flag = false;
            }
            else
            {
                $query .= ", `".$key."`='".$value."' ";
            }
       }
       $query .=";";
        

        $result  = $db->query($query);
        
    }


}

?>