<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+

/** 
 * Contents alla used SQL queries
 *
 * This class is used to collect all used quesries 
 * of module. You get the SQL string using available methods;
 * @package Queries
 */
 

class QueriesCategory
{
    
    /**
     * SQL query: select a Category form db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function loadCategoryByCid ( $cid )
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_categories")."` ";
        $query .= " WHERE `cid`='".$cid."';";
        
        $result  = $db->query($query);
        $numrows = $db->num_rows($result);

        if ( $numrows > 1 ) {
            die("Duplicate User Entries!");
        } else {
			$myrow = $db->fetch_array($result);
		}
        
        return $myrow;
    }

    /**
     * SQL query: select all Categories form db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllCategoriesByAccessGroups ( $groups )
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_categories")."` WHERE ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "access_groups  like '%$group%'";
        }
        $query.= " or access_groups  = 'all' ORDER BY category_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    /**
     * SQL query: select all titles of Categories form db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllCategoryTitlesByAccessGroups ( $groups )
    {
        global $db;
        
        $query  = "SELECT cid, title FROM `".$db->prefix("forum_categories")."` WHERE ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "access_groups  like '%$group%'";
        }
        $query.= " or access_groups  = 'all' ORDER BY title ASC";
        
        $result  = $db->query($query);
        
        $ret = array();
        
        while ( $item = $db->fetch_array($result) )
        {
            $ret[$item['cid']] = $item['title'];
        }
        
        return $ret;
    }
    
    /**
     * SQL query: select all Categories form db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllCategories ()
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_categories")."` ORDER BY category_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    /**
     * SQL query: select all Titles of categories form db that is avaible a group
     * @param string list of all needed groups
     * @return array array[cid]=title;
     */

    function loadAllCategoryTitles ()
    {
        global $db;
        
        $query  = "SELECT cid, title FROM `".$db->prefix("forum_categories")."` ORDER BY title ASC;";
        
        $result  = $db->query($query);
        
        $ret = array();
        
        while ( $item = $db->fetch_array($result) )
        {
            $ret[$item['cid']] = $item['title'];
        }
        
        return $ret;
    }
    
    
    /**
     * SQL query: select a Category by cis and group access
     * @param int category id
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadCategoriesByCidAndAccessGroups ( $cid, $groups )
    {
        global $db;
        
        $query  = "SELECT cid FROM `".$db->prefix("forum_categories")."` WHERE cid='".$cid."' AND ( ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "access_groups  like '%$group%'";
        }
        $query.= " or access_groups  = 'all' ) ORDER BY category_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    

    

    /**
     * SQL query: insert a new Category form db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function insertNewCategory ( $params )
    {
        global $db;
        
        $query  = "INSERT INTO `".$db->prefix("forum_categories")."` ";
        $start_flag=true;
        
        foreach ( $params as $key => $value )
        {
            if ($start_flag)
            {
                $query .= "SET `".$key."`='".$value."' ";
                $start_flag = false;
            }
            else
            {
                $query .= ", `".$key."`='".$value."' ";
            }
       }
       $query .=";";
        
        $result  = $db->query($query);
        return $result;
    }

 		/**
     * SQL query: update a Category in db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function updateCategory ( $params )
    {
        global $db;
        
        $query  = "UPDATE `".$db->prefix("forum_categories")."` ";
        $start_flag=true;
        
        foreach ( $params as $key => $value )
        {
            if ($start_flag)
            {
                $query .= "SET `".$key."`='".$value."' ";
                $start_flag = false;
            }
            else
            {
                $query .= ", `".$key."`='".$value."' ";
            }
       }
       $query .=" WHERE `cid`='".$params['cid']."';";
        
        $result  = $db->query($query);
        return $result;
    }


		/**
     * SQL query: drope a Category in db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function dropCategory ( $cid )
    {
    	global $db;
        
        $query  = "DELETE FROM `".$db->prefix("forum_categories")."` ";
        $query .= "WHERE `cid`='".$cid."';";
        
        $result  = $db->query($query);
        
        return $result;
    }


	/**
     * SQL query: count number of Forum in a category;
     * @param array the category id
     * @return int number of forums
     */

    function countChildrenForum ($cid)
    {
        global $db;
        
        $query  = "SELECT COUNT(*) FROM `".$db->prefix("forum_forums")."` ";
        $query .= "WHERE `cid`='".$cid."';";
        
        $result  = $db->query($query);
        $ret = $db->fetch_array($result);
        
        return $ret[0];

	
    }
    
}

?>