<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+

/** 
 * Contents alla used SQL queries
 *
 * This class is used to collect all used quesries 
 * of module. You get the SQL string using available methods;
 * @package Queries
 */
 

class QueriesForum
{
    
    /**
     * SQL query: select a Forum form db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function loadForumByFid ( $fid )
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_forums")."` ";
        $query .= " WHERE `fid`='".$fid."';";
        
        $result  = $db->query($query);
        $numrows = $db->num_rows($result);

        if ( $numrows > 1 ) {
            die("Duplicate User Entries!");
        } else {
			$myrow = $db->fetch_array($result);
		}
        
        return $myrow;
    }

    /**
     * SQL query: select all Forumsform db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllForumsByAccessGroups ( $groups )
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_forums")."` WHERE ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "access_groups  like '%$group%'";
        }
        $query.= " or access_groups  = 'all' ORDER BY forum_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    /**
     * SQL query: select all Forumsform db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllForumsByModeratorGroups ( $groups )
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_forums")."` WHERE ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "moderator_groups  like '%$group%'";
        }
        $query.= " or moderator_groups  = 'all' ORDER BY forum_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    /**
     * SQL query: select all Froum form db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllForumsByCategory ($cid)
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_forums")."` WHERE `cid`='".$cid."' ORDER BY forum_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    
    /**
     * SQL query: select a Forum by cis and group access
     * @param int Forum id
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadForumsByFidAndAccessGroups ( $fid, $groups )
    {
        global $db;
        
        $query  = "SELECT fid FROM `".$db->prefix("forum_forums")."` WHERE fid='".$fid."' AND ( ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "access_groups  like '%$group%'";
        }
        $query.= " or access_groups  = 'all' ) ORDER BY forum_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    /**
     * SQL query: select a Forum by cis and group access
     * @param int Forum id
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadForumsByFidAndModeratorGroups ( $fid, $groups )
    {
        global $db;
        
        $query  = "SELECT fid FROM `".$db->prefix("forum_forums")."` WHERE fid='".$fid."' AND ( ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "moderator_groups  like '%$group%'";
        }
        $query.= " or moderator_groups  = 'all' ) ORDER BY forum_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    /**
     * SQL query: select a Forum by cis and group access
     * @param int Forum id
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadForumsByCategoryAndAccessGroups ( $cid, $groups )
    {
        global $db;
        
        $query  = "SELECT fid FROM `".$db->prefix("forum_forums")."` WHERE cid='".$cid."' AND ( ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "access_groups  like '%$group%'";
        }
        $query.= " or access_groups  = 'all' ) ORDER BY Forum_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }

	function loadForumsByCategoryAndAccessGroupsAndModeratorGroups ( $cid, $groups )
    {
        global $db;
        
        $query  = "SELECT fid FROM `".$db->prefix("forum_forums")."` WHERE cid='".$cid."' AND ( ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "access_groups  like '%$group%'";
        }
        
        $query .=") AND ( ";
        
        $first = true;
        foreach ( $groups as $group ) {
            if (!$first) {
                $query.= " or ";
            }
            if ( $first == true ) { 
                $first = false; 
            }
            $query.= "moderator_groups  like '%$group%'";
        }
        $query.= " or moderator_groups  = 'all' ) ORDER BY Forum_order ASC";
        
        $result  = $db->query($query);
        
        return $result;
    }

    /**
     * SQL query: insert a new Forum form db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function insertNewForum ( $params )
    {
        global $db;
        
        $query  = "INSERT INTO `".$db->prefix("forum_forums")."` ";
        $start_flag=true;
        
        foreach ( $params as $key => $value )
        {
            if ($start_flag)
            {
                $query .= "SET `".$key."`='".$value."' ";
                $start_flag = false;
            }
            else
            {
                $query .= ", `".$key."`='".$value."' ";
            }
       }
       $query .=";";
    
        $result  = $db->query($query);
        return $result;
    }

 		/**
     * SQL query: update a Forum in db by fid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function updateForum ( $params )
    {
        global $db;
        
        $query  = "UPDATE `".$db->prefix("forum_forums")."` ";
        $start_flag=true;
        
        foreach ( $params as $key => $value )
        {
            if ($start_flag)
            {
                $query .= "SET `".$key."`='".$value."' ";
                $start_flag = false;
            }
            else
            {
                $query .= ", `".$key."`='".$value."' ";
            }
       }
       $query .=" WHERE `fid`='".$params['fid']."';";
        
        $result  = $db->query($query);
        
        return $result;
    }


    /**
     * SQL query: drope a Forum in db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function dropForum ( $fid )
    {
    		global $db;
        
        $query  = "DELETE FROM `".$db->prefix("forum_forums")."` ";
        $query .= "WHERE `fid`='".$fid."';";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    
    /**
     * SQL query: count number of posts in a forum;
     * @param the forumid
     * @return int number of posts
     */

    function countChildrenPost ($fid)
    {
        global $db;
        
        $query  = "SELECT COUNT(*) FROM `".$db->prefix("forum_posts")."` ";
        $query .= "WHERE `fid`='".$fid."';";
        
        $result  = $db->query($query);
        $ret = $db->fetch_array($result);
        
        return $ret[0];

	
    }
    
}

?>