<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+

/** 
 * Contents alla used SQL queries
 *
 * This class is used to collect all used quesries 
 * of module. You get the SQL string using available methods;
 * @package Queries
 */
 

class QueriesPost
{


 	 /**
     * SQL query: select a Forum form db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function loadPostByPostId ( $id )
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_posts")."` ";
        $query .= " WHERE `post_id`='".$id."';";
        
        $result  = $db->query($query);
        $numrows = $db->num_rows($result);

        if ( $numrows > 1 ) {
            die("Duplicate User Entries!");
        } else {
			$myrow = $db->fetch_array($result);
		}
        
        return $myrow;
    }

    /**
     * SQL query: select all Froum form db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllPostByForum ($id)
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_posts")."` WHERE `forum_id`='".$id."' ORDER BY post_time DESC";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    /**
     * SQL query: select all Froum form db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function loadAllPostByForumNoChildren ($id,$current_start=0,$items_perpage=0)
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_posts")."` WHERE `parent_id`='0' AND `forum_id`='".$id;
		
		if ($items_perpage > 0)
		{
		 $query .= "' ORDER BY post_time DESC LIMIT ".$current_start.",".$items_perpage.";";
		}
		else
        {
		 $query .= "' ORDER BY post_time DESC;";
		}
				
        $result  = $db->query($query);
        
        return $result;
    }
    
    
    /**
     * SQL query: select all Froum form db that is avaible a group
     * @param string list of all needed groups
     * @return mysql resource
     */

    function getLastPostIdByForumId ($id)
    {
        global $db;
        
        $query  = "SELECT post_id FROM `".$db->prefix("forum_posts")."` WHERE `forum_id`='".$id."' ORDER BY post_time DESC LIMIT 0,1;";
        
        $result  = $db->query($query);
        $pid = $db->fetch_array($result);
        return $pid['post_id'];
    }
    
    
    
   
    
    /**
     * SQL query: drop a Post in db by post_id;
     * @param id is the post_id
     * @return mysql resouce
     */

    function dropPost ( $id )
    {
    	global $db;
        $tree = new XoopsTree ($db->prefix("forum_posts"),"post_id","parent_id");
        $arr = $tree->getChildTreeArray($id, 'post_time');
        $query = "DELETE FROM `".$db->prefix("forum_posts")."` ";
        $query .= "WHERE `post_id`='".$id."'; ";
        $result  = $db->query($query);
        if (!$result) return $result;
        
        foreach ($arr as $item) 
		{
		
        $query = "DELETE FROM `".$db->prefix("forum_posts")."` ";
        $query .= "WHERE `post_id`='".$item['post_id']."'; ";
        $result  = $db->query($query);
        if (!$result) return $result;
        }
        
        return $result;
    }
 
 	
    /**
     * SQL query: drop a Post in db by post_id;
     * @param id is the post_id
     * @return mysql resouce
     */

    function dropAllPostByForum ( $id )
    {
    	global $db;
        
        $query  = "DELETE FROM `".$db->prefix("forum_posts")."` ";
        $query .= "WHERE `forum_id`='".$id."';";
        
        $result  = $db->query($query);
        
        return $result;
    }
    /**
     * SQL query: count number of Forum in a category;
     * @param array the category id
     * @return int number of forums
     */

    function countForumPosts ($id)
    {
        global $db;
        
        $query  = "SELECT COUNT(*) FROM `".$db->prefix("forum_posts")."` ";
        $query .= "WHERE `parent_id`='0' AND `forum_id`='".$id."';";
        
        $result  = $db->query($query);
        $ret = $db->fetch_array($result);
        
        return $ret[0];
    }
    
    function countCategoryPosts ($id)
    {
        global $db;
        
        $query  = "SELECT COUNT(*)";
		$query .= " FROM `".$db->prefix("forum_posts")."`, `".$db->prefix("forum_forums")."` ";
        $query .= "WHERE `forum_id`=`fid` AND `cid`='".$id."';";
        
        $result  = $db->query($query);
        $ret = $db->fetch_array($result);
        
        return $ret[0];
	}
	 
     /**
     * SQL query: insert a new Forum form db by Cid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function insertNewPost ( $params )
    {
        global $db;
        $query  = "INSERT INTO `".$db->prefix("forum_posts")."` ";
        $start_flag=true;
        
        foreach ( $params as $key => $value )
        {
            if ($start_flag)
            {
                $query .= "SET `".$key."`='".$value."' ";
                $start_flag = false;
            }
            else
            {
                $query .= ", `".$key."`='".$value."' ";
            }
       }
       $query .=";";

        $result  = $db->query($query);
        return $result;
    }

 		/**
     * SQL query: update a Forum in db by fid;
     * @param array the array content 'cid' elementM
     * @return array the selected row
     */

    function updatePost ( $params )
    {
        global $db;
        
        $query  = "UPDATE `".$db->prefix("forum_posts")."` ";
        $start_flag=true;
        
        foreach ( $params as $key => $value )
        {
            if ($start_flag)
            {
                $query .= "SET `".$key."`='".$value."' ";
                $start_flag = false;
            }
            else
            {
                $query .= ", `".$key."`='".$value."' ";
            }
       }
       $query .=" WHERE `post_id`='".$params['post_id']."';";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    
    function numOfPostsByForumId ($id)
    {
        global $db;
        
        $query  = "SELECT COUNT(*) FROM `".$db->prefix("forum_posts")."` ";
        $query .= "WHERE `forum_id`='".$id."';";
        
        $result  = $db->query($query);
        $ret = $db->fetch_array($result);
        
        return $ret[0];
    }
    
    
    function listPostsByRootId ($id,$desc=true)
    {
        global $db;
        
        $query  = "SELECT post_id FROM `".$db->prefix("forum_posts")."` ";
        $query .= " WHERE `root_id`='".$id."' ";
		$query .= " ORDER BY post_time ";
		if ($desc)
		{
		 $query .= " DESC";
		}
		else
		{
		 $query .= " ASC";
		}
		
		$query .=";";
        
        $result  = $db->query($query);

        return $result;
    }
    
    
    
    function numOfPostsByRootId ($id)
    {
        global $db;
        
        $query  = "SELECT COUNT(*) FROM `".$db->prefix("forum_posts")."` ";
        $query .= "WHERE `root_id`='".$id."';";
        
        $result  = $db->query($query);
        $ret = $db->fetch_array($result);
        
        return $ret[0];
    }
    
    function lastPostTimeByRootId ($id)
    {
        global $db;
        
        $query  = "SELECT post_time FROM `".$db->prefix("forum_posts")."` ";
        $query .= "WHERE `root_id`='".$id."' ORDER BY post_time DESC;";
        
        $result  = $db->query($query);
        $ret = $db->fetch_array($result);
        
        return $ret[0];
    }
    
    function lastPostsId ($maxnum)
    {
        global $db;
        
        $query  = "SELECT post_id FROM `".$db->prefix("forum_posts")."` ";
        $query .= "ORDER BY post_time GROUP BY root_id DESC LIMIT 0,".$maxnum.";";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    function uniqueLastPostsId ($maxnum,$gid)
    {
        global $db,$xoopsUser;

		if ($xoopsUser) {
		$groups = $xoopsUser->groups();
		} else {
			$groups = XoopsGroup::getByType("Anonymous");
		}

        
        $query  = "SELECT post_id,root_id FROM ".$db->prefix("forum_posts");
		$query .= " JOIN ".$db->prefix("forum_forums")." ON fid=forum_id ";
		$query .= " WHERE ";

$first = true;
foreach ( $groups as $group ) {
	if (!$first) {
		$query .= " or ";
	}
	if ( $first == true ) { $first = false; }
	$query .= "access_groups like '%$group%'";
}

        $query .= " ORDER BY post_time DESC;";
        $result  = $db->query($query);
        
        if (!$result)
        	return 0;
        	
        $ret = array();
		$root_id=array();
		
		$i=0;
        while ($i<$maxnum){
			$item = $db->fetch_array($result);		

			if (!$item)
				return $ret;

			if(($item[root_id]==0)&&(!(in_array($item[post_id],$root_id)))){
				array_push($ret,$item);
				array_push($root_id,$item[root_id]);
				$i++;
			}
			else{
			 	$test=$item[root_id];
			 	if (count($ret)==0){
			 		array_push($ret,$item);
					array_push($root_id,$item[root_id]);
					$i++;
			 		}
				else if((!(in_array($item[root_id],$root_id)))&&(!(in_array($item[post_id],$root_id)))){
					array_push($ret,$item);
					array_push($root_id,$item[root_id]);
					$i++;
					}
				}

		}
        return $ret;
    }

    
    function lastPostByRootId ($id)
    {
        global $db;
        
        $query  = "SELECT post_id FROM `".$db->prefix("forum_posts")."` ";
        $query .= "WHERE `root_id`='".$id."' ORDER BY post_time DESC;";
        
        $result  = $db->query($query);
        $ret = $db->fetch_array($result);
        
        return $ret[0];
    }
    
    function getAllChildren ($id)
    {
        global $db;
        
        $query  = "SELECT post_id FROM `".$db->prefix("forum_posts")."` ";
        $query .= "WHERE `parent_id`='".$id."' ORDER BY post_time DESC;";
        
        $result  = $db->query($query);
        
        // create return array
        $ret = array();
        while ($item = $db->fetch_row($result))
        {
            array_push( $ret, $item[0] );
        }
        
        
        
        return $ret;
    }
    
	function isVisited ($post_id,$user_id,$read_cookies=true)
	{
	 global $db;
	 global $_COOKIE;

 	 if ((isset($_COOKIE['post_read'])) and ($read_cookies))
		{
			$arrPostRead = split(',',$_COOKIE['post_read']);
			$PostRead = (in_array($post_id, $arrPostRead)) ? true : false;
		}
	 $query = "SELECT * FROM ".$db->prefix("forum_post_visits")." ";
     $query .= "WHERE post_id=".$post_id." ";
     $query .= " AND user_id=".$user_id.";";

     $result  = $db->query($query);

	 if (!($PostRead))
	 	$PostRead=$db->num_rows($result);
     return ($PostRead);
	}
    
    function addVisitToPost ($post_id,$user_id)
    {
     global $db;

	 $result=false;
	 
	 $post=new QueriesPost();
	 $post->loadPostByPostId ( $post_id );
	 // insert a new read line only if not yet read
	 if ((!$post->isVisited($post_id,$user_id,false))&&($user_id!=0)){     
     	$query  = "INSERT INTO `".$db->prefix("forum_post_visits")."` ";
	    $query .= "SET `post_id`='".$post_id."', ";
    	$query .= "`user_id`='".$user_id."', ";
     	$query .= "`visit_time`='".time()."';";    
  	 	$result  = $db->query($query);
  	 }
     return $result;
    }	

    function getAllVisitsAtPost ($post_id)
    {
        global $db;
        
        $query  = "SELECT * FROM `".$db->prefix("forum_post_visits")."` ";
        $query .= "WHERE `post_id`='".$post_id."' ORDER BY visit_time DESC;";

        $result  = $db->query($query);
        
        return $result;
    }
    
    
    function numOfVisitsByRootId ($id)
    {
        global $db;
        
        $query  = "SELECT COUNT(*) FROM `".$db->prefix("forum_post_visits")."` ";
        $query .= "WHERE `post_id`='".$id."';";
        
        $result  = $db->query($query);
        $ret = $db->fetch_array($result);
        
        return $ret[0];
    }
    
    function numOfUnreadPosts ($uid,$cat_forum="forum",$id,$post_id="")
    {
        global $db;
        
        switch ($cat_forum){
			case 'category':
					$msg_read='SELECT count(*) 
						FROM ('.$db->prefix("forum_post_visits").
						' LEFT JOIN '.$db->prefix("forum_posts").' ON '.
						$db->prefix("forum_post_visits").'.post_id = '.$db->prefix("forum_posts").'.post_id)
						INNER JOIN '.$db->prefix("forum_forums").' ON '.
						$db->prefix("forum_posts").'.forum_id = '.$db->prefix("forum_forums").'.fid 
						WHERE '.$db->prefix("forum_forums").'.cid="'.$id.
						'" AND '.$db->prefix("forum_post_visits").'.user_id="'.$uid.'";';
					$msg_tot='SELECT count(*) 
						FROM '.$db->prefix("forum_posts").' INNER JOIN '.$db->prefix("forum_forums").' ON '.
						$db->prefix("forum_posts").'.forum_id = '.$db->prefix("forum_forums").'.fid 
						WHERE '.$db->prefix("forum_forums").'.cid="'.$id.'";';
					break;
					
			case 'forum':
					$msg_read='SELECT count(*) 
						FROM '.$db->prefix("forum_post_visits").
						' LEFT JOIN '.$db->prefix("forum_posts").' ON '.
						$db->prefix("forum_post_visits").'.post_id = '.$db->prefix("forum_posts").'.post_id
						WHERE (('.$db->prefix("forum_posts").'.forum_id="'.$id.
						'") AND ('.$db->prefix("forum_post_visits").'.user_id="'.$uid.'"));';
					$msg_tot='SELECT count(*) 
						FROM '.$db->prefix("forum_posts").' 
						WHERE '.$db->prefix("forum_posts").'.forum_id="'.$id.'";';
					break;
			case 'topic':
					if ($id==0){
					$msg_read='SELECT count(*) 
						FROM '.$db->prefix("forum_post_visits").
						' LEFT JOIN '.$db->prefix("forum_posts").' ON '.
						$db->prefix("forum_post_visits").'.post_id = '.$db->prefix("forum_posts").'.post_id
						WHERE ((('.$db->prefix("forum_posts").'.post_id="'.$post_id.
						'") OR ('.$db->prefix("forum_posts").'.root_id="'.$post_id.
						'")) 
						AND ('.$db->prefix("forum_post_visits").'.user_id="'.$uid.'"));';
					$msg_tot='SELECT count(*) 
						FROM '.$db->prefix("forum_posts").' 
						WHERE (('.$db->prefix("forum_posts").'.root_id="'.$post_id.'"
						) OR ('.$db->prefix("forum_posts").'.post_id="'.$post_id.'
						"));';
						}
					else {
					$msg_read='SELECT count(*) 
						FROM '.$db->prefix("forum_post_visits").
						' LEFT JOIN '.$db->prefix("forum_posts").' ON '.
						$db->prefix("forum_post_visits").'.post_id = '.$db->prefix("forum_posts").'.post_id
						WHERE ((('.$db->prefix("forum_posts").'.root_id="'.$id.
						'") OR ('.$db->prefix("forum_posts").'.post_id="'.$id.
						'")) AND ('.$db->prefix("forum_post_visits").'.user_id="'.$uid.'"));';
					$msg_tot='SELECT count(*) 
						FROM '.$db->prefix("forum_posts").' 
						WHERE (('.$db->prefix("forum_posts").'.root_id="'.$id.'"
						) OR ('.$db->prefix("forum_posts").'.post_id="'.$id.'
						"));';
						}
					break;
			default:
					break;
		}

		$result  = $db->query($msg_read);
if(!$result)
	die($msg_read);
		$rows = $db->fetch_array($result);
		$ret['msg_read'] = $rows[0];

		$result  = $db->query($msg_tot);
if(!$result)
	die($msg_tot);
		$rows = $db->fetch_array($result);
		$ret['msg_tot'] = $rows[0];

		$ret['msg_unread'] = $ret['msg_tot']-$ret['msg_read'];        
		if ($ret['msg_unread']<0)
			$ret['msg_unread']=0;		
        return $ret;

    }


    function dropAllVisitsByRootId ( $id )
    {
    	global $db;
        
        $query  = "DELETE FROM `".$db->prefix("forum_post_visits")."` ";
        $query .= "WHERE `post_id`='".$id."';";
        
        $result  = $db->query($query);
        
        return $result;
    }
    
    function lastVisit ($pid, $uid)
    {
     	global $db;
     	$query  = "SELECT visit_time FROM `".$db->prefix("forum_post_visits")."` ";
        $query .= "WHERE `post_id`='".$pid."' AND `user_id`='".$uid."' ORDER BY `visit_time` DESC;";
        
        $result  = $db->query($query);
        $ret = $db->fetch_array($result);
        
        if ($ret[0]) return $ret[0];
        else return 0;
    }
}

?>