<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+

/** category_list_description - category_list_messages
 * Interface to HTML rendable objects
 *
 * Inherit from this class to define the public functions
 * that render in HTML format your class attributes. <p>Remember:
 * this is an "interface" only. You must redifine all functions input  
 * in your children!</p>
 * @package interfaces
 */
 
 include_once(XOOPS_ROOT_PATH."/modules/forum/include/functions.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/Category.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/RenderForum.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/Tools.php");
 include_once(XOOPS_ROOT_PATH."/class/xoopsformloader.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/QueriesCategory.php");


class RenderCategory
{

    var $category;
    var $accessibility = false;

    /**#@+
     * @access public
     */
     
     
    function RenderCategory ( $cat = null )
    {
        global $R_URI;
        if ( empty ($cat))
        {
            $this->setCategory (new Category() );
        }
        else
        {
            $this->setCategory($cat);
        }
        
        if (ereg("accessibile",$R_URI)!= 0 ) $this->setAccessibility(true);
    }
    
    
    function setAccessibility( $on_off )
    {
     	$this->accessibility = $on_off;
    }
    
    function setCategory ( $cat )
    {
        $this->category = $cat;
    }
    
    function getVar ( $varname, $format='S' )
    {
        return $this->category->getVar ($varname, $format);
    }



// -----------------------   User render functions


    function categoryListTitle()
    {
   
   		$ret = '<h1 class="category_list_title">'._MD_FORUM_CATEGORY_LISTTITLE.'</h1>'."\n";
   		return $ret;
	}
	
	
    function categoryItem( $showforum = true )
    {	global $xoopsModule;
		global $_COOKIE;
		
 	$ret  = '<div class="category_item">'."\n";
	 	
	 	// Category image
	 	$imageUrl = $this->getVar('imageURL');
        if ( !empty($imageUrl) )  
		{
        
            $ret .= '<img class="category_item_image" src="'. Tools::makeImageURL($this->getVar('imageURL')).'" ';
            $ret .= ' longdesc="'. _MD_FORUM_CATEGORY_LOGO.' '. $this->getVar('title'). '" alt="'.
									_MD_FORUM_CATEGORY_LOGO.' '. $this->getVar('title'). '" />'."\n";
        }
        else
        {
            $ret .= '<img class="category_item_image" src="'.XOOPS_URL.'/modules/'.$xoopsModule->dirname().
					'/images/dummy_cat.gif" ';
            $ret .= ' longdesc="'. _MD_FORUM_CATEGORY_LOGO.' '. $this->getVar('title'). '" alt="'.
					_MD_FORUM_CATEGORY_LOGO.' '.$this->getVar('title').'"/>'."\n";
        }
      	$ret .=	"<h2>". $this->getVar('title')."</h2>";

		// Category Hide/Show management
		$cid=$this->getVar('cid');
		$CategoryShow = true;

		// Read cookies to find Collapsed Category
		if (isset($_COOKIE['forum_collapse']))
		{
			$arrCollapse = split(',',$_COOKIE['forum_collapse']);
			$cat_cid="cat_".$cid;
			$CategoryShow = (in_array($cat_cid, $arrCollapse)) ? false : true;

		}
		// Set Category display attribute and correct open/close icon
		$show = ($CategoryShow) ? 'block;' : 'none;';
		$img  = ($CategoryShow) ? 'close.png' : 'open.png';


		$ret .= '<img src="'.XOOPS_URL.'/themes/'.XOOPS_THEME.'/images/'.$img.'" onclick="toggle_block(\'cat_'.$cid.'\', this); ToggleSideBar(\'icon'.$cid.'\'); " 
								   onmouseover="javascript:RollOverBlockIcon(\'icon'.$cid.'\');" 
					               onmouseout ="javascript:RollOutBlockIcon (\'icon'.$cid.'\');" 
				class="category_item_toggle" 
				id="icon'.$cid.'"\>';        
		// aggiunta classe category_list_description
        $ret .= '<div class="category_list_description">'. $this->getVar('category_description')."</div>";
        // Show all forums in category
    	
		$ret .= '<div style="padding-top:10px;"></div><div id=\'cat_'.$cid.'\' style="display: '.$show.';">';
    	if ( $showforum )
    	{
    	 if ( Tools::userIsWebmaster() )
		 {
 		  $result = QueriesForum::loadAllForumsByCategory($this->getVar('cid'));
		 }
		 else
		 {
 		  $result = QueriesForum::loadForumsByCategoryAndAccessGroups( $this->getVar('cid'),Tools::getUserGroups() );
		 }
        
		 $render = new RenderForum();
		 $ret .= $render->forumListByDbResource ($result,false);
		 }
        
        // Show the number of posts in a category
    	$ret .= "</div>";
        $ret .= '<div class="category_list_messages">'._MD_FORUM_CATEGORY_TOTALPOSTS." ";
		$ret .=	QueriesPost::countCategoryPosts($this->getVar('cid'))."</div>";
    	
        $ret .= "</div>";
    	return $ret;
    }

    function categoryListByDbResource( $mysqlresource, $showforum = true )
    {
        global $db;
		global $xoopsModule;
		 
        $ret = '<div class="category_list">';

		$count_post=0;        
        // Check if database is empty
		if ( $db->num_rows($mysqlresource) < 1 ) 
		{
            $ret .= '<h2>'. _MD_FORUM_NOCATEGORY.'</h2>'."\n";
        } 
        else 
        {
	   		 //$ret .= '<ul>'."\n";
	   		 while ( $category_data = $db->fetch_array($mysqlresource) ) 
	   		 {
                $cat = new Category ( $category_data );
                $this->setCategory( $cat );
		        $category_color_bg=$this->getVar('category_color_bg');
        		$category_color=$this->getVar('category_color');

                $ret .= '<div class="category_item" style="background-color:'.$category_color_bg.';color:'.$category_color.';">'.$this->categoryItem($showforum).'</div>'."\n";

				$count_post +=	QueriesPost::countCategoryPosts($this->getVar('cid'));

           	 }
           	 //$ret .= '</ul>'."\n";
    	} 
        $ret .= '<h3 class="category_list_title">'._MD_FORUM_FORUM_TOTALPOSTS." ";
	    
		$sql_totpost = "SELECT COUNT(*) FROM ".$db->prefix('forum_posts')." WHERE root_id<>0";
	    $result_totpost=$db->query($sql_totpost);
	    $totPost=$db->fetch_array($result_totpost);

		$ret .=	$totPost[0]."</h3></div>";
        $ret .= '</div>'."\n";
        
        return $ret;
    
    }


    
    
// -----------------------   Admin render functions
    function adminListByDbResource ( $mysqlresource )
    {
        global $db;
        
        $ret =  '<div class="admin_category_list">';
        
        // Check if database is empty
	if ( $db->num_rows($mysqlresource) < 1 ) 
	{
            $ret .=  '<h2>'. _MD_FORUMADMIN_NOCATEGORY.'<br />';
            $ret .=  '<a href="index.php?op=catcreate"';
            $ret .=  '   title="'. _MD_FORUMADMIN_CREATECATEGORY.'">';
            $ret .=  _MD_FORUMADMIN_CREATECATEGORY;
            $ret .=  '</a> </h2>'."\n";
        } 
        else 
        {
	   if ( Tools::userIsWebmaster() )
    	   {
    	       $ret .=  '<p class="admin_category_menu_create">';
    	       $ret .=  '<a href="index.php?op=catcreate" ';
    	       $ret .=  '   title="'. _MD_FORUMADMIN_CREATECATEGORY.'">';
    	       $ret .=  _MD_FORUMADMIN_CREATECATEGORY;
    	       $ret .=  '</a> </p>';
            }
	   
	   $ret .=  '<ul>'."\n";
	   while ( $category_data = $db->fetch_array($mysqlresource) ) 
	   {
                $cat = new Category ( $category_data );
                $this->setCategory( $cat );
                $ret .=  '<li class="admin_category_item" style="border-left-style:single; border-left-width=18px; border-color:'.$this->getVar('category_color_bg').';">'.$this->adminItem().'</li>'."\n";
           }
        $ret .=  '</ul>'."\n";
        } 

        $ret .=  '</div>'."\n";
        
        return $ret;
    
    }


    function adminItem()
    { 
        global $xoopsModule;
 		$ret ="";
		        
        // Display Image
        $imageUrl = $this->getVar('imageURL');
        if ( !empty($imageUrl) )  
		{
        
            $ret .= '<img class="admin_category_item_image " src="'. Tools::makeImageURL($this->getVar('imageURL')).'" ';
            $ret .= ' longdesc="'. _MD_FORUMADMIN_CATEGORY_LOGO.' '. $this->getVar('title'). '" alt="'. _MD_FORUMADMIN_CATEGORY_LOGO.' '. $this->getVar('title'). '" />'."\n";
        }
        else
        {
            $ret .= '<img class="admin_category_item_image" src="'.XOOPS_URL.'/modules/'.$xoopsModule->dirname().'/images/dummy_cat.gif" ';
            $ret .= ' longdesc="'. _MD_FORUMADMIN_CATEGORY_LOGO.' '. $this->getVar('title'). '" alt="'._MD_FORUMADMIN_CATEGORY_LOGO.' '.$this->getVar('title').'">'."\n";
        }
        
        // Display category_order
        $ret .= '<div class="admin_category_item_order" > <strong>'._MD_FORUMADMIN_CATEGORY_ORDER_LABEL. '</strong>  '.$this->getVar("category_order")."</div>\n";
        // Display number of avaibles forum
        $ret .= '<div class="admin_category_item_forums"> <strong>'._MD_FORUMADMIN_CATEGORY_FORUMS_LABEL. '</strong>  '.QueriesCategory::countChildrenForum($this->getVar('cid'))."</div>\n";
        
        // Display category title
        $ret .= '<div class="admin_category_item_title"> <strong>'._MD_FORUMADMIN_CATEGORY_TITLE_LABEL. '</strong> '.$this->getVar('title').'</div>'."\n"; 
        // Display category description
        $ret .= '<p class="admin_category_item_description" >  <strong>'._MD_FORUMADMIN_CATEGORY_DESCRIPTION_LABEL. '</strong> <br />'.$this->getVar('category_description').'</p>'."\n";
        

        // Display action menu
        $ret .= '<p class="admin_category_item_menu">[ <a href="index.php?op=forum&amp;cid='.$this->getVar('cid');
        $ret .= '" title="'. _MD_FORUMADMIN_CATEGORY_A_TITLE_VISIT .' '. $this->getVar('title').'">'."\n";
        $ret .= _MD_FORUMADMIN_CATEGORY_VISIT . "</a>\n"; 
        
        if ( Tools::userIsWebmaster() )
    	{
    	   $ret .= ' | <a href="index.php?op=catedit&amp;cid='.$this->getVar('cid').'"';
    	   $ret .= '  title="'. _MD_FORUMADMIN_CATEGORY_A_TITLE.' '.$this->getVar('title').'">';
    	   $ret .= _MD_FORUMADMIN_CATEGORY_EDIT ."</a>";
    	   $ret .= ' | <a href="index.php?op=catconfirmdelete&amp;cid='. $this->getVar('cid').'"';
    	   $ret .= ' title="'._MD_FORUMADMIN_CATEGORY_A_TITLE_DELETE.' '.$this->getVar('title').'">';
    	   $ret .= _MD_FORUMADMIN_CATEGORY_DELETE.'</a>'."\n";
        }
    	$ret .= ' ]</p>'."\n";
    	
    	return $ret;
    }


    function inputForm ()
    {
        global $xoopsModule;
        
        $cid_hidden = new XoopsFormHidden("cid", $this->getVar('cid'));
        $title_text = new XoopsFormText(_MD_FORUMADMIN_CATEGORY_FORM_TITLE, "title", 26, 255,
										$this->getVar('title','F')  );
		$category_color = new XoopsFormSelectColor(_MD_FORUMADMIN_CATEGORY_FORM_COLOR,"category_color",8,8,$this->getVar('category_color','F'));
        $category_color_bg = new XoopsFormSelectColor(_MD_FORUMADMIN_CATEGORY_FORM_BGCOLOR,"category_color_bg",8,8,$this->getVar('category_color_bg','F'));
		$description_text = new XoopsFormTextArea(_MD_FORUMADMIN_CATEGORY_FORM_DESCRIPTION, 'category_description',
																											 $this->getVar('category_description','F'));
        $category_order_text 	= new XoopsFormText(_MD_FORUMADMIN_CATEGORY_FORM_ORDER, "category_order", 5, 5, 
																									$this->getVar('category_order','F'));
        $access_groups_text 	= new XoopsFormSelectGroup(_MD_FORUMADMIN_CATEGORY_FORM_ACCESSGROUPS, "access_groups", true, 
																												 Tools::groupsStringToArray($this->getVar('access_groups')), 5, true);
        
        $imageURL_text = new XoopsFormImageURL(_MD_FORUMADMIN_CATEGORY_FORM_URLIMG, "imageURL", 26, 255, XOOPS_URL."/modules/".$xoopsModule->dirname()."/cache/images/", XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/cache/images/",$this->getVar('imageURL','E'));
        

        $op_hidden     = new XoopsFormHidden("op", "catvalidate");
        $submit_button = new XoopsFormButton("", "submit", _SUBMIT, "submit");
        
        $required = array ("title","access_groups");
        
        $reg_form = new XoopsThemeForm(_MD_FORUMADMIN_CATEGORY_FORM, "forum_category", "index.php");
        $reg_form->setExtra('enctype="multipart/form-data"');
	    $reg_form->addElement($title_text);
        $reg_form->addElement($imageURL_text);
	    $reg_form->addElement($category_color);
	    $reg_form->addElement($category_color_bg);
        $reg_form->addElement($description_text);
        $reg_form->addElement($access_groups_text);
        $reg_form->addElement($category_order_text);
        $reg_form->addElement($cid_hidden);
        $reg_form->addElement($op_hidden);
        $reg_form->addElement($submit_button);
        
        $reg_form->setRequired($required);
        
        $this->navMenu();
        $reg_form->display();
    
    
    } 
    /**#@-*/


    function categoryStoreDone()
    {
        $this->accessibility ? redirect_header_acc('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_STORED) : redirect_header('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_STORED);
        exit();

    }
    
    function categoryStoreError()
    {
        $this->accessibility ? redirect_header_acc('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_STORE_ERROR) : redirect_header('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_STORE_ERROR);
        exit();
    }
    
    function categoryValidateErrors ($errors )
    {
        ?> <div class="admin_category_errors">
           <h2> <?php echo _MD_FORUMADMIN_CATEGORY_ERRORS ; ?> </h2>
            <ul>
                <?php foreach ( $errors as $error ) 
                { ?>
                      <li><?php echo $error ?></li>
                      
          <?php } ?>
          
            </ul>
            </div> <?php
    }

		function adminManageCategoryTitle()
		{
		?>
    	<h1>
    		<?php echo _MD_FORUM_MENU_ADMIN_MANAGECATEGORY; ?>
    	</h1>
		<?php    
		}
		
		function adminCannotManageCategoryError()
		{
			$this->accessibility ? redirect_header_acc('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_CANNOTMANAGECATEGORYERROR) : redirect_header('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_CANNOTMANAGECATEGORYERROR);
			exit();
		}
		
		function adminCategoryNoCidError()
		{
			$this->accessibility ? redirect_header_acc('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_NOCIDERROR) : redirect_header('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_NOCIDERROR);
			exit();
		}
		
		function adminCategoryCidError()
		{
			$this->accessibility ? redirect_header_acc('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_NOCIDERROR) : redirect_header('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_NOCIDERROR);
			exit();
		}
		
		function adminCategoryUploadError( $errs )
		{
			$this->accessibility ? redirect_header_acc("./index.php?op=cat", 3, $errs) : redirect_header("./index.php?op=cat", 3, $errs);
			exit();
		}
		function adminCategoryDeleted()
		{
			$this->accessibility ? redirect_header_acc("./index.php?op=cat", 3, _MD_FORUMADMIN_CATEGORY_DELETED) : redirect_header("./index.php?op=cat", 3, _MD_FORUMADMIN_CATEGORY_DELETED);
			exit();
		}
		
		function adminCategoryDeleteError()
		{
			$this->accessibility ? redirect_header_acc("./index.php?op=cat", 3, _MD_FORUMADMIN_CATEGORY_DELETEERROR) : redirect_header("./index.php?op=cat", 3, _MD_FORUMADMIN_CATEGORY_DELETEERROR);
			exit();
		}
		
		
		function adminCategoryDeleteConfirm ()
		{
    		?><h1> <?php echo _MD_FORUMADMIN_CATEGORY_CONFRIMDELETE. " '" .$this->getVar('title')."'" ; ?></h1><?php
				   
				$name_label 		= new XoopsFormLabel (_MD_FORUMADMIN_CATEGORY_CONFRIMDELETE_LABELYES);
				$cid_hidden    = new XoopsFormHidden("cid", $this->getVar('cid'));
        $op_hidden     = new XoopsFormHidden("op", "catdelete");
        $submit_button = new XoopsFormButton("", "submit", _YES  , "submit");
        
        $reg_form = new XoopsSimpleForm("", "forum_category_deleteconfirm", "index.php");
        $reg_form->addElement($name_label);
        $reg_form->addElement($cid_hidden);
        $reg_form->addElement($op_hidden);
        $reg_form->addElement($submit_button);
        $reg_form->display();
    
    		$name_label 	= new XoopsFormLabel (_MD_FORUMADMIN_CATEGORY_CONFRIMDELETE_LABELNO);
        $op_hidden     = new XoopsFormHidden("op", "cat");
        $submit_button = new XoopsFormButton("", "submit", _NO , "submit");
        
        $reg_form = new XoopsSimpleForm("", "forum_category_deletecancel", "index.php");
        $reg_form->addElement($name_label);
        $reg_form->addElement($op_hidden);
        $reg_form->addElement($submit_button);
        $reg_form->display();
	}
	
	
	function navMenu()
	{
	   echo '<div class="admin_category_navmenu">';
	   echo '<a href="index.php?op=" title="'._MD_FORUMADMIN_CATEGORY_BACKMENU.'">';
	   echo _MD_FORUMADMIN_CATEGORY_BACKMENU;
	   echo '</a> | ';
	   echo '<a href="index.php?op=cat" title="'._MD_FORUMADMIN_CATEGORY_BACKLIST.'">';
	   echo _MD_FORUMADMIN_CATEGORY_BACKLIST;
	   echo '</a> </div>'."\n";
	}
}
?>