<?php
// FORUM MODULE FOR E-XOOPPORT                     
// +----------------------------------------------------------------------+
// | E-XOOPPORT 3.0 (Samsara)                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2007 The E-Xoopport Project                            |
// +----------------------------------------------------------------------+
// | Authors: analisifunzionale <analisifunzionale@e-xoopport.it>         |
// |          soulmiki          <soulmiki@e-xoopport.it>                  |
// |          DIba              <diba@e-xoopport.it>                      |
// +----------------------------------------------------------------------+
// | This module is useful for publishing web pages into your web site    |
// | without having the necessity to create your HTML file with your      |
// | editor and put them in FTP into another directory...                 |
// | Moreover, pages you will create with this module will completely fit |
// | with the theme of your site!                                         |
// +----------------------------------------------------------------------+
// |Author Website : http://www.e-xoopport.it/                            |
// |License Type   : GPL: See /manual/LICENSES/GPL.txt                    |
// -----------------------------------------------------------------------+

/** 
 * Interface to HTML rendable objects
 *
 * Inherit from this class to define the public functions
 * that render in HTML format your class attributes. <p>Remember:
 * this is an "interface" only. You must redifine all functions input  
 * in your children!</p>
 * @package interfaces
 */
 
 include_once(XOOPS_ROOT_PATH."/modules/forum/include/functions.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/Category.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/Forum.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/Post.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/Tools.php");
 include_once(XOOPS_ROOT_PATH."/class/xoopsformloader.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/QueriesForum.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/QueriesCategory.php");
 include_once(XOOPS_ROOT_PATH."/modules/forum/class/QueriesPost.php");


class RenderForum
{

    var $forum;
    var $accessibility = false;

    /**#@+
     * @access public
     */
     
     
    function RenderForum ( $fid = null )
    {
        global $R_URI;
        
        if ( empty ($fid))
        {
            $this->setForum ( new Forum() );
        }
        else
        {
            $this->setForum($fid);
        }
        
        if (ereg("accessibile",$R_URI)!= 0 ) $this->setAccessibility(true);
    }
    
    function setAccessibility( $on_off )
    {
     	$this->accessibility = $on_off;
    }
    
    
    function setForum ( $cat )
    {
        $this->forum = $cat;
    }
    
    function getVar ( $varname, $format='S' )
    {
        return $this->forum->getVar($varname, $format);
    }

	function forumListTitle()
    {
     global $xoopsModule;
     	$ret  = '<h1 class="post_list_title">';
   	 	// Category image
	 	$imageUrl = $this->getVar('imageURL');
        if ( !empty($imageUrl) )  
		{
        
            $ret .= '<img class="forum_item_image" src="'. Tools::makeImageURL($this->getVar('imageURL')).'" ';
            $ret .= ' longdesc="'._MD_FORUM_CATEGORY_LOGO.'  '. $this->getVar('title'). '" alt="'. _MD_FORUM_CATEGORY_LOGO.' '. $this->getVar('title'). '" />'."\n";
        }
        else
        {
            $ret .= '<img class="forum_item_image" src="'.XOOPS_URL.'/modules/'.$xoopsModule->dirname().'/images/dummy_forum.gif" ';
            $ret .= ' longdesc="'._MD_FORUM_CATEGORY_LOGO.'  '. $this->getVar('title'). '" alt="'._MD_FORUM_CATEGORY_LOGO.' '.$this->getVar('title').'"/>'."\n";
        }
        
   		
		$ret .= _MD_FORUM_POST_LISTTITLE;
		$ret .= " ".$this->getVar('title').'</h1>';
		return $ret;
	}
	
	function forumListByDbResource( $mysqlresource, $showpost = true)
    {
        global $db;
        
//        $ret = '<div class="forum_list" style="background-color:#'.$category_color.'">';
        $ret = '<div class="forum_list" >';
        
        // Check if database is empty
		if ( $db->num_rows($mysqlresource) < 1 ) 
		{
            $ret .= '<em>'. _MD_FORUM_NOFORUM.'</em>'."\n";
        } 
        else 
        {
	   		 while ( $forum_data = $db->fetch_array($mysqlresource) ) 
	   		 {
                $forum = new Forum ( $forum_data['fid'] );
                $this->setForum ($forum);
                $ret .= '<div class="forum_item" >'.$this->forumItem().'</div>'."\n";
           	 }
    	} 

        $ret .= '</div>'."\n";
        
        return $ret;
    
    }
    
    function forumItem( $showforum = true )
    {
     global $xoopsModule,$xoopsUser,$forumConfig;
     
	$uid = $xoopsUser ? $xoopsUser->uid() : 0;

        $ret ="";
        // Display image
        $imageUrl = $this->getVar('imageURL');
		$ret .= '<div class="forum_item_userblock">';
	
		$ret .= '<a href="forum.php?fid='.$this->getVar('fid').'"';
		$ret .= '	title="'._MD_FORUM_FORUM_VISIT." '".$this->getVar('title')."'".'">';
		if ( !empty($imageUrl) )  
		{
        
            $ret .= '<img class="forum_list_image" src="'. Tools::makeImageURL($this->getVar('imageURL')).'" ';
            $ret .= ' longdesc="'. _MD_FORUM_FORUM_LOGO.' '. $this->getVar('title'). '" alt="'. _MD_FORUM_FORUM_LOGO.' '. $this->getVar('title'). '" />'."\n";
        }
        else
        {
            $ret .= '<img class="forum_list_image" src="'.XOOPS_URL.'/modules/'.$xoopsModule->dirname().'/images/dummy_forum.gif" ';
            $ret .= ' longdesc="'. _MD_FORUM_FORUM_LOGO.' '. $this->getVar('title'). '" alt="'._MD_FORUM_FORUM_LOGO.' '.$this->getVar('title').'"/>'."\n";
        }
		$ret .= "</a>\n";
		$ret .= "</div>\n";
		
		
		$ret .= '<div class="forum_item_textblock">';
		
        // Display forum title
        $ret .= '<div class="forum_item_title"> <strong>'._MD_FORUM_FORUM_TITLE_LABEL. '</strong> ';
		$ret .= '<a href="forum.php?fid='.$this->getVar('fid').'"';
		$ret .= '	title="'._MD_FORUM_FORUM_VISIT." '".$this->getVar('title')."'".'">';
		$ret .= $this->getVar('title');
		$ret .= "</a>";
		$ret .= '</div>'."\n";
		
		if ($forumConfig['rss_enable']==1){
	        $ret .= '<div class="forum_item_rss">';

			$find    = "/[^A-Za-z0-9_-]/";
			$replace = "_";
			$text=$this->getVar('title');
			$forumName=	preg_replace($find, $replace, $text);
			$xmlName=XOOPS_ROOT_PATH.'/modules/forum/cache/forum_'.$forumName.'.xml';
			if (file_exists($xmlName)){

				$ret .= '<a href="'.XOOPS_URL.'/modules/forum/cache/forum_'.$forumName.'.xml"';
				$ret .= ' type="application/atom+xml" title="'._MD_FORUM_RSS_SUBSCRIBE." '".$this->getVar('title')."'".'">';
				$ret .= '<img src="images/feed.png">';
				$ret .= "</a>";
			}
			$ret .= '</div>'."\n";
		} 
        
        // Display forum description
        $ret .= '<p class="forum_item_description">  <strong>'._MD_FORUM_FORUM_DESCRIPTION_LABEL. '</strong>'.$this->getVar('forum_description').'</p>'."\n";

        // Display number of avaibles posts
        $numchildren = QueriesPost::countForumPosts($this->getVar('fid')); 
        $ret .= '<div class="forum_item_posts"> <strong>'._MD_FORUM_FORUM_POSTS_LABEL. '</strong>  '.$numchildren;


		$msg_forum=QueriesPost::numOfUnreadPosts ($uid,"forum",$this->getVar("fid"));
		if($msg_forum['msg_unread']>0){

             $ret .= '<span class="forum_item_last_post_new"> (';
			 $ret .= _MD_FORUM_FORUM_NEW_MSG.' '.$msg_forum['msg_unread'];
			 $ret .= ')</span>';

		}

		$ret .= "</div>\n";        
		
        // Display last posts
        if ($numchildren > 0)
        {
            $pid = QueriesPost::getLastPostIdByForumId($this->getVar('fid'));
            
            if (!empty($pid))
		  { 
            $post = new Post ($pid);
            
            $ret .= '<div class="forum_item_last_post">';
                         
		      $ret .= '<strong>'._MD_FORUM_FORUM_LAST_POSTS_LABEL. '</strong> ';
		      $ret .= '<a href="post.php?post_id='.$pid.'#post_item_'.$pid.'"';
		      $ret .= '	title="'._MD_FORUM_POST_VISIT." '".$post->getVar('subject')."'".'">';
		      $ret .= $post->getVar('subject')."</a>";
		      $ret .= ' ('.formatTimestamp($post->getVar("post_time"),"m").')';
		      $ret .= "</div>\n";
		  }
		}
		        
        $ret .= "</div>\n";
        
        return $ret;
    }

	function forumNoFidError()
    {
        $this->accessibility ? redirect_header_acc('index.php', 3, _MD_FORUMADMIN_FORUM_NOFIDERROR) : redirect_header('index.php', 3, _MD_FORUMADMIN_FORUM_NOFIDERROR);	
        exit();
    }
    
    function forumFidError()
	{
		$this->accessibility ? redirect_header_acc('index.php', 3, _MD_FORUMADMIN_FORUM_NOFIDERROR) : redirect_header('index.php', 3, _MD_FORUMADMIN_FORUM_NOFIDERROR);
		exit();
	}
	
	
	function groupAccessError()
	{
		$this->accessibility ? redirect_header_acc('index.php', 3, _MD_FORUM_FORUM_NOACCESS) : redirect_header('index.php', 3, _MD_FORUM_FORUM_NOACCESS);
		exit();
	}
	

// -----------------------   Admin render functions

	function adminManageForumTitle($cat_title)
	{
	 return "<h1>"._MD_FORUM_MENU_ADMIN_MANAGEFORUM." '".$cat_title."'</h1>";
	}
		


    function adminListByDbResource ( $mysqlresource, $cid )
    {
        global $db;
        $ret =	'<div class="admin_forum_list" >'."\n";
        $ret .=	$this->navMenu();
        
        // Check if database is empty
        if ( $db->num_rows($mysqlresource) < 1 ) 
		{
           $ret .=	 '<h2> '._MD_FORUMADMIN_NOFORUM .'<br />'."\n";
           $ret .=	 '    <a href="index.php?op=forumcreate&cid='.$cid.'" ';
	   	   $ret .=	 '	        title="'. _MD_FORUMADMIN_CREATEFORUM.'">';
	   	   $ret .=	 _MD_FORUMADMIN_CREATEFORUM;
	   	   $ret .=	 "</a> \n";
	   	   $ret .=	 "</h2>\n";
		
		} 
		else 
		{  
	   	   if ( Tools::userIsWebmaster() )
    	   {
    	       $ret .=	'<p class="admin_forum_menu_create">';
    	       $ret .=	'<a href="index.php?op=forumcreate&cid='.$cid.'"';
    	       $ret .=	'   title="'._MD_FORUMADMIN_CREATEFORUM.'">';
               $ret .=	_MD_FORUMADMIN_CREATEFORUM;
	       	   $ret .=	 '</a></p>'."\n";
	       }
           $ret .=	"<ul>\n";

           while ( $forum_data = $db->fetch_array($mysqlresource) ) 
           {
           		 $frm = new Forum ( $forum_data );
            	 $this->setForum( $frm );  
				 $cat=QueriesCategory::loadCategoryByCid($cid);
            	 $ret .=	'<li class="admin_category_item" style="border-color: '.$cat['category_color_bg'].';">'.$this->adminItem().'</li>'."\n";
           }
           $ret .=	'</ul>'."\n";
        
    	} 
    	
        $ret .=	'</div>'."\n";
        
        return $ret;
    }


    function adminItem()
    { 
        global $xoopsModule;
        $ret ="";
        // Display image
        $imageUrl = $this->getVar('imageURL');

		if ( !empty($imageUrl) )  
		{
        
            $ret .= '<img class="admin_forum_item_image" src="'. Tools::makeImageURL($this->getVar('imageURL')).'" ';
            $ret .= ' longdesc="'. _MD_FORUMADMIN_FORUM_LOGO.' '. $this->getVar('title'). '" alt="'. _MD_FORUMADMIN_FORUM_LOGO.' '. $this->getVar('title'). '" />'."\n";
        }
        else
        {
            $ret .= '<img class="admin_forum_item_image" src="'.XOOPS_URL.'/modules/'.$xoopsModule->dirname().'/images/dummy_forum.gif" ';
            $ret .= ' longdesc="'. _MD_FORUMADMIN_FORUM_LOGO.' '. $this->getVar('title'). '" alt="'._MD_FORUMADMIN_FORUM_LOGO.' '.$this->getVar('title').'"/>'."\n";
        }
        
        // Display forum_order
        $ret .= '<div class="admin_forum_item_order"> <strong>'._MD_FORUMADMIN_FORUM_ORDER_LABEL. '</strong>  '.$this->getVar("forum_order")."</div>\n";
        
        // Display number of avaibles posts
        $ret .= '<div class="admin_forum_item_posts"> <strong>'._MD_FORUMADMIN_FORUM_POSTS_LABEL. '</strong>  '.QueriesPost::countForumPosts($this->getVar('fid'))."</div>\n";
        
        // Display forum title
        $ret .= '<div class="admin_forum_item_title"> <strong>'._MD_FORUMADMIN_FORUM_TITLE_LABEL. '</strong> '.$this->getVar('title').'</div>'."\n"; 
        // Display forum description
        $ret .= '<p class="admin_forum_item_description">  <strong>'._MD_FORUMADMIN_FORUM_DESCRIPTION_LABEL. '</strong> <br />'.$this->getVar('forum_description').'</p>'."\n";
 
        // Display number of avaibles posts
        $ret .= '<div class="admin_forum_item_anonposting"> <strong>'._MD_FORUM_FORUM_ANONPOSTING_LABEL. '</strong> ';
        if ($this->getVar('anon_posting'))
        {
            $ret .= _YES;
        }
        else
        {
            $ret.=_NO;
        }
        $ret .= "</div>\n";
        
        // Display action menu
        
        if ( Tools::userIsWebmaster() )
    	{
    	   $ret .= '<p class="admin_forum_item_menu">[';
    	   $ret .= ' <a href="index.php?op=forumedit&amp;fid='.$this->getVar('fid').'"';
    	   $ret .= '  title="'. _MD_FORUMADMIN_FORUM_A_TITLE.' '.$this->getVar('title').'">';
    	   $ret .= _MD_FORUMADMIN_FORUM_EDIT ."</a>";
    	   $ret .= ' | <a href="index.php?op=forumconfirmdelete&amp;fid='. $this->getVar('fid').'"';
    	   $ret .= ' title="'._MD_FORUMADMIN_FORUM_A_TITLE_DELETE.' '.$this->getVar('title').'">';
    	   $ret .= _MD_FORUMADMIN_FORUM_DELETE.'</a>'."\n";
    	   $ret .= ' ]</p>'."\n";
        }
        
        return $ret;
    }



  function inputForm ()
    {
        global $xoopsModule, $db, $_GET, $_POST;
        
        $current_start=0;
        if (!empty($_GET['start'])) 
		{
   		 $current_start = intval($_GET['start']);
		}  
		elseif (!empty($_POST['start'])) 
		{
   		 $current_start = intval($_POST['start']);
		}  
        

        $fid_hidden     	= new XoopsFormHidden("fid", $this->getVar('fid'));
        $cid_select     	= new XoopsFormSelect(_MD_FORUMADMIN_FORUM_CATEGORY, "cid", $this->getVar('cid'));
        
        
        if ( Tools::userIsWebmaster() )
    	{    
	   $catarray = QueriesCategory::loadAllCategoryTitles();
	}
	else 
	{
     	  $catarray = QueriesCategory::loadAllCategoryTitlesByAccessGroups( Tools::getUserGroups() );
     	 
     	}
        

        $cid_select->addOptionArray( $catarray ) ;
        
        $title_text 	= new XoopsFormText(_MD_FORUMADMIN_FORUM_FORM_TITLE, "title", 26, 255,
						$this->getVar('title','F')  );
        $description_text = new XoopsFormTextArea(_MD_FORUMADMIN_FORUM_FORM_DESCRIPTION, 'forum_description',
                                                $this->getVar('forum_description','F'));
        $forum_order_text 	= new XoopsFormText(_MD_FORUMADMIN_FORUM_FORM_ORDER, "forum_order", 5, 5, 
						$this->getVar('forum_order','F'));
        $access_groups_text 	= new XoopsFormSelectGroup(_MD_FORUMADMIN_FORUM_FORM_ACCESSGROUPS, "access_groups",
		                                        true, Tools::groupsStringToArray($this->getVar('access_groups')), 5, true);
        $moderator_groups_text 	= new XoopsFormSelectGroup(_MD_FORUMADMIN_FORUM_FORM_MODERATORGROUPS, 
                            "moderator_groups", true, Tools::groupsStringToArray($this->getVar('moderator_groups')), 5, true);
        
        $imageURL_text = new XoopsFormImageURL(_MD_FORUMADMIN_FORUM_FORM_URLIMG, "imageURL", 26, 255,    
                                        XOOPS_URL."/modules/".$xoopsModule->dirname()."/cache/images/", 
                                        XOOPS_ROOT_PATH."/modules/".$xoopsModule->dirname()."/cache/images/",$this->getVar(
                                        'imageURL','E'));
        
        $anon_posting_check = new XoopsFormCheckBox (_MD_FORUMADMIN_FORUM_ANONPOSTING_LABEL,"anon_posting",                                        $this->getVar ('anon_posting'));
        $anon_posting_check->addOption(true,_YES);
        $op_hidden     = new XoopsFormHidden("op", "forumvalidate");
        $start_hidden     	= new XoopsFormHidden("start", $current_start);
        $submit_button = new XoopsFormButton("", "submit", _SUBMIT, "submit");
        
        $required = array ("title","cid","access_groups","moderator_groups");
        
        $reg_form = new XoopsThemeForm(_MD_FORUMADMIN_FORUM_FORM, "forum_category", "index.php");
        
        $reg_form->setExtra('enctype="multipart/form-data"');
        $reg_form->addElement($fid_hidden);
        $reg_form->addElement($cid_select);
        $reg_form->addElement($title_text);
        $reg_form->addElement($imageURL_text);
        $reg_form->addElement($description_text);
        $reg_form->addElement($access_groups_text);
        $reg_form->addElement($moderator_groups_text);
        $reg_form->addElement($anon_posting_check);
        $reg_form->addElement($forum_order_text);
        $reg_form->addElement($op_hidden);
        $reg_form->addElement($start_hidden);
        $reg_form->addElement($submit_button); 
        
        $reg_form->setRequired($required);
        
        echo $this->navMenuNewForum();
        $reg_form->display();
    
    
    } 

    function adminCannotManageCategoryError()
    {
        $this->accessibility ? redirect_header_acc('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_CANNOTMANAGEFORUMERROR) : redirect_header('index.php?op=cat', 3, _MD_FORUMADMIN_CATEGORY_CANNOTMANAGEFORUMERROR);
        exit();
    }
    
    function adminCannotManageForumError()
    {
        $this->accessibility ? redirect_header_acc('index.php?op=cat', 3, _MD_FORUMADMIN_FORUM_CANNOTMANAGEFORUMERROR) : redirect_header('index.php?op=cat', 3, _MD_FORUMADMIN_FORUM_CANNOTMANAGEFORUMERROR);
        exit();
    }
    
    
    function adminForumNoFidError()
    {
        $this->accessibility ? redirect_header_acc('index.php?op=cat', 3, _MD_FORUMADMIN_FORUM_NOFIDERROR) : redirect_header('index.php?op=cat', 3, _MD_FORUMADMIN_FORUM_NOFIDERROR);	
        exit();
    }
    
    function adminForumFidError()
	{
		$this->accessibility ? redirect_header_acc('index.php?op=cat', 3, _MD_FORUMADMIN_FORUM_NOFIDERROR) : redirect_header('index.php?op=cat', 3, _MD_FORUMADMIN_FORUM_NOFIDERROR);
		exit();
	}
    
    function forumStoreError()
    {
        global $_POST;
        
        $this->accessibility ? redirect_header_acc('index.php?op=forum&cid='.intval($_POST['cid']), 3, _MD_FORUMADMIN_FORUM_STORE_ERROR) : redirect_header('index.php?op=forum&cid='.intval($_POST['cid']), 3, _MD_FORUMADMIN_FORUM_STORE_ERROR);
        exit();
    }
    
    function forumValidateErrors ($errors )
    {
        ?> <div class="admin_forum_errors">
           <h2> <?php echo _MD_FORUMADMIN_FORUM_ERRORS ; ?> </h2>
            <ul>
                <?php foreach ( $errors as $error ) 
                { ?>
                      <li><?php echo $error ?></li>
                      
          <?php } ?>
          
            </ul>
            </div> <?php
    }

    
    function forumStoreDone()
    {
        global $_POST;
        $this->accessibility ? redirect_header_acc('index.php?op=forum&cid='.intval($_POST['cid']), 3, _MD_FORUMADMIN_FORUM_STORED) : redirect_header('index.php?op=forum&cid='.intval($_POST['cid']), 3, _MD_FORUMADMIN_FORUM_STORED);
        exit();

    }
    
    function adminForumUploadError( $errs )
    {
        global $_POST;
        $this->accessibility ? redirect_header_acc("./index.php?op=forum&cid=".intval($_POST['cid']), 3, $errs) : redirect_header("./index.php?op=forum&cid=".intval($_POST['cid']), 3, $errs);
		exit();
    }
    
    function navMenuNewForum()
    {
        global $_GET;
        if (!empty($_GET['cid'])) 
		{
   		 $cid = intval($_GET['cid']);
		}else {
		$cid = $this->getVar('cid');
		}
		
		
        $ret =	 '<div class="admin_forum_navmenu">';
        $ret .=	 '<a href="index.php?op=" title="'._MD_FORUMADMIN_FORUM_BACKMENU.'">';
        $ret .=	 _MD_FORUMADMIN_FORUM_BACKMENU;
        $ret .=	 '</a> | ';
        $ret .=	 '<a href="index.php?op=cat" title="'._MD_FORUMADMIN_FORUM_BACKCATEGORY.'">';
        $ret .=	 _MD_FORUMADMIN_FORUM_BACKCATEGORY;
        $ret .=	 '</a> | ';
        $ret .=	 '<a href="index.php?op=forum&cid='.$cid.'" title="'._MD_FORUMADMIN_FORUM_BACKLIST.'">';
        $ret .=	 _MD_FORUMADMIN_FORUM_BACKLIST;
        $ret .=	 '</a> </div>'."\n";
        
        return $ret;
    }
    
    function navMenu()
    {
        $ret =	 '<div class="admin_forum_navmenu">';
        $ret .=	 '<a href="index.php?op=" title="'._MD_FORUMADMIN_FORUM_BACKMENU.'">';
        $ret .=	 _MD_FORUMADMIN_FORUM_BACKMENU;
        $ret .=	 '</a> | ';
        $ret .=	 '<a href="index.php?op=cat" title="'._MD_FORUMADMIN_FORUM_BACKCATEGORY.'">';
        $ret .=	 _MD_FORUMADMIN_FORUM_BACKCATEGORY;
        $ret .=	 '</a> </div>'."\n";
        
        return $ret;
    }
    
    
    function adminForumDeleteConfirm ()
	{
     	echo '<h1>'._MD_FORUMADMIN_FORUM_CONFRIMDELETE. " '" .$this->getVar('title')."'</h1>\n";
		$name_label 		= new XoopsFormLabel (_MD_FORUMADMIN_FORUM_CONFRIMDELETE_LABELYES);
		$fid_hidden    = new XoopsFormHidden("fid", $this->getVar('fid'));
        $op_hidden     = new XoopsFormHidden("op", "forumdelete");
        $submit_button = new XoopsFormButton("", "submit", _YES  , "submit");
        
        $reg_form = new XoopsSimpleForm("", "forum_forum_deleteconfirm", "index.php");
        $reg_form->addElement($name_label);
        $reg_form->addElement($fid_hidden);
        $reg_form->addElement($op_hidden);
        $reg_form->addElement($submit_button);
        $reg_form->display();
    
    	$name_label 	= new XoopsFormLabel (_MD_FORUMADMIN_FORUM_CONFRIMDELETE_LABELNO);
        $op_hidden     = new XoopsFormHidden("op", "forum");
        $cid_hidden    = new XoopsFormHidden("cid", $this->getVar('cid'));
        $submit_button = new XoopsFormButton("", "submit", _NO , "submit");
        
        $reg_form = new XoopsSimpleForm("", "forum_forum_deletecancel", "index.php");
        $reg_form->addElement($name_label);
        $reg_form->addElement($op_hidden);
        $reg_form->addElement($cid_hidden);
        $reg_form->addElement($submit_button);
        $reg_form->display();
	}
	
	function adminForumDeleted()
	{
		$this->accessibility ? redirect_header_acc("./index.php?op=forum&cid=".$this->getVar('cid'), 3, _MD_FORUMADMIN_FORUM_DELETED) : redirect_header("./index.php?op=forum&cid=".$this->getVar('cid'), 3, _MD_FORUMADMIN_FORUM_DELETED);
		exit();
	}
		
	function adminForumDeleteError()
	{
		$this->accessibility ? redirect_header_acc("./index.php?op=forum&cid=".$this->getVar('cid'), 3, _MD_FORUMADMIN_FORUM_DELETEERROR) : redirect_header("./index.php?op=forum&cid=".$this->getVar('cid'), 3, _MD_FORUMADMIN_FORUM_DELETED);
		exit();
	}
		
	
}
?>