# Create forum_categories table

CREATE TABLE `forum_categories` (
  `cid` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `category_color` varchar(8) NOT NULL default '0000ff',
  `category_color_bg` varchar(8) NOT NULL default 'cecece',
  `category_description` text,
  `imageURL` varchar(255) default NULL,
  `access_groups` varchar(255) NOT NULL default 'all',
  `category_order` smallint(3) NOT NULL default '0',
  PRIMARY KEY  (`cid`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

CREATE TABLE `forum_forums` (
  `fid` mediumint(8) unsigned NOT NULL auto_increment,
  `cid` mediumint(8) unsigned NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `forum_description` text,
  `imageURL` varchar(255) default NULL,
  `forum_order` smallint(3) NOT NULL default '0',
  `access_groups` varchar(255) NOT NULL default 'all',
  `moderator_groups` varchar(255) NOT NULL default 'all',
  `anon_posting` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`fid`),
  KEY `idx` (`cid`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;


CREATE TABLE `forum_posts` (
  `post_id` mediumint(8) unsigned NOT NULL auto_increment,
  `forum_id` mediumint(8) unsigned NOT NULL default '0',
  `parent_id` mediumint(8) unsigned NOT NULL default '0',
  `root_id` mediumint(8) unsigned NOT NULL default '0',
  `subject` varchar(255) NOT NULL default '',
  `post_icon` varchar(255) NOT NULL default '',
  `contents` text,
  `post_time` int(10) default '0',
  `user_id` mediumint(8) unsigned NOT NULL default '0',
  `imagefilename` varchar(255) NULL default '',
  PRIMARY KEY  (`post_id`),
  KEY `idx` (`forum_id`)
) TYPE=MyISAM AUTO_INCREMENT=1;

CREATE TABLE `forum_post_visits` (
  `post_id` mediumint(8) NOT NULL default '0',
  `user_id` mediumint(8) NOT NULL default '0',
  `visit_time` int(10) NOT NULL,
  PRIMARY KEY  (`post_id`,`user_id`,`visit_time`)
) TYPE=MyISAM;


CREATE TABLE `forum_topics_mail` (
  `topic_id` mediumint(8) NOT NULL default '0',
  `user_id` mediumint(8) NOT NULL default '0',
  PRIMARY KEY  (`topic_id`,`user_id`)
) TYPE=MyISAM;


