<?php
//*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*//
//                                                                           //
//                         # The E-XOOPPORT Project #                        //
// Support: http://www.e-xoopport.it - Development: http://dev.e-xoopport.it //
// Original Author of this file: Pietro Lascari (Redpitt)                    //
// Created on Saturday, March 13 2004                                        //
//                                                                           //
//*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*//

include("header.php");
include("functions.php");
include_once(XOOPS_ROOT_PATH."/class/fileupload.php");
include_once(XOOPS_ROOT_PATH."/modules/messenger/class/pmuser.php");

if ( !$xoopsUser ) {
	redirect_header(XOOPS_URL,3,_NOPERM);
	exit();
}

$userid = intval($xoopsUser->getVar("uid"));
if ( UserPM::isSpecialUser($userid) ) {
	$is_special = 1;
	$pmuser = new UserPM($userid);
} else {
	$is_special = 0;
}

$page = "write.php";
if ( intval($_POST["is_reply"]) == 1 ) {
	$page = "index.php";
}

if ( !empty($_POST["sendpm"]) ) {
	if ( trim($_POST["subject"]) == "" || trim($_POST["pm_text"]) == "" ) {
		redirect_header(XOOPS_URL."/modules/messenger/".$page."",3,_PM_NOSUBORTEXT);
		exit();
	}
	
	include_once(XOOPS_ROOT_PATH."/modules/messenger/class/xoopspm.php");
	
	if ( !empty($_FILES["pmupload"]["name"]) ) {
		include_once(XOOPS_ROOT_PATH."/modules/messenger/cache/config.php");
		$uploadclass = new fileupload();
		$uploadclass->set_upload_dir(XOOPS_ROOT_PATH."/modules/messenger/cache/attachments/", "pmupload");
		if ( $is_special == 1 ) {
			$fexts = $pmuser->getVar("pmfilexts");
		} else {
			$fexts = $messengerConfig["fileExts"];
		}
		
		$uploadclass->set_encryption(1, "pmupload");
		$uploadclass->set_accepted($fexts);
		$result = $uploadclass->upload();
		if ( !$result["pmupload"] ) {
			redirect_header(XOOPS_URL."/modules/messenger/".$page."", 3, sprintf(_PM_FILEUPLERR, $uploadclass->errors()));
			exit();
		} else {
			$pmattach = "".$result["pmupload"]["filename"]."";
		}
	}

	$errors = array();
	$successes = array();

	$user = $_POST["user"];
	if ( @is_array($user) ) {
		foreach ( $user as $u => $uid ) {
			if ( UserPM::isSpecialUser(intval($uid)) ) {
				$specuser = new UserPM(intval($uid));
				$maxmsgs_number = intval($specuser->getVar("pmmaxmsgs"));
			} else {
				$maxmsgs_number = $messengerConfig["DefaultNumOfMessages"];
			}
			
			$msgcount = XoopsPM2::countPMS(array("pm_touser = ".intval($uid).""));
			if ( $msgcount < $maxmsgs_number ) {		
				if ( $_POST["sig"] == "on" ) {
					$sign = 1;
				} else {
					$sign = 0;
				}
			
				if ( $_POST["pmreadnotify"] == "on" ) {
					$readntfy = 1;
				} else {
					$readntfy = 0;
				}
			
				if ( $_POST["pmreplynotify"] == "on" ) {
					$replyntfy = 1;
				} else {
					$replyntfy = 0;
				}
			
				$addressee = XoopsUser::getUnameFromId(intval($uid));
				$subject = str_replace("{X_UNAME}", $addressee, $_POST["subject"]);
				$pm_text = str_replace("{X_UNAME}", $addressee, $_POST["pm_text"]);
			
				$savepm = new XoopsPM2();
				$savepm->setVar("pm_subject", $myts->makeTboxData4Save($subject));
				$savepm->setVar("pm_content", $myts->makeTboxData4Save($pm_text));
				$savepm->setVar("pm_fromuser", $xoopsUser->getVar("uid"));
				$savepm->setVar("pm_touser", intval($uid));
				$savepm->setVar("pm_attachsig", $sign);
				$savepm->setVar("pm_notifyread", $readntfy);
				$savepm->setVar("pm_notifyreply", $replyntfy);
				if ( !empty($pmattach) ) {
					$savepm->setVar("pm_attachment", $pmattach);
				}
						
				if ( !$savepm->store() ) {
					$errors[] = sprintf(_PM_SENDERR, $addressee);
				} else {
					$successes[] = sprintf(_PM_SENDOK, $addressee);
				}	
				// notify by email
				$inlist = in_list($uid); 
				if (($inlist == true) && (!$replyntfy) && (!$is_reply))        // check if notification is active
				{
					$sqlmail = "SELECT email, uname FROM ".$db->prefix("users")." WHERE uid = ".$uid.";";
					$resultmail = $db->query($sqlmail);
					$line = $db->fetch_array($resultmail);
					$emaildest = $line['email'];
					$usernamedest =$line['uname'];
					$notifysubject = sprintf(_PM_NOTIFY_SUBJECT, $meta['title']);
					$notifybody = sprintf(_PM_UARERECEIV3, $usernamedest, $meta['title']);
					$notifybody.= _IM_SENTBY.": ".$xoopsUser->getVar("uname")."\r\n";
					$notifybody.= _PM_SUBJECT.": ".$subject."\r\n";
					$notifybody.= _PM_SENTON.": ".date(_DATESTRING, time())."\r\n\r\n";
					$notifybody.= sprintf(_PM_REMEMBER2, XOOPS_URL."/modules/messenger/index.php");
					$xoopsMailer =& getMailer();
					$xoopsMailer->useMail();
					$xoopsMailer->setFromName($meta['brieftitle']);
					$xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
					$xoopsMailer->setSubject($notifysubject);
					$xoopsMailer->setBody($notifybody);
					$xoopsMailer->setToEmails($emaildest);
					@$xoopsMailer->send();
				}
				// end notify by mail
				if ( $is_reply == 1 && !empty($_POST["orig_id"]) ) {
					$orig_msg = new XoopsPM2(intval($_POST["orig_id"]));
					if ( intval($orig_msg->getVar("pm_notifyreply")) == 1 && intval($xoopsUser->getVar("uid")) != intval($orig_msg->getVar("pm_fromuser")) ) {
						$senderuname = XoopsUser::getUnameFromId($orig_msg->getVar("pm_fromuser"));
						$langtouse = XoopsUser::getLanguageFromId($orig_msg->getVar("pm_fromuser"));
						$old_lang = $xoopsConfig['language'];
						changeModuleLanguage($langtouse);
						
						$esubj = sprintf(_PM_MAILNOTIFYREPLY_SUBJECT, $xoopsUser->getVar("uname"), $meta["brieftitle"]);
						$emsg = sprintf(_PM_UARERECEIV2, $senderuname, $xoopsUser->getVar("uname")).sprintf(_PM_SUMMARY, $orig_msg->getVar("pm_subject"), date(_DATESTRING, $orig_msg->getVar("pm_date"))).sprintf(_PM_REMEMBER, XOOPS_URL."/modules/messenger/index.php");
						
						$usr = new XoopsUser(intval($orig_msg->getVar("pm_fromuser")));
						
						$xoopsMailer =& getMailer();
						$xoopsMailer->useMail();
						$xoopsMailer->setFromName($meta['brieftitle']);
						$xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
						$xoopsMailer->setSubject($esubj);
						$xoopsMailer->setBody($emsg);
						$xoopsMailer->setToEmails(array($usr->getVar("email","E")));
						
						changeModuleLanguage($old_lang);
						
						@$xoopsMailer->send();
	
						// Fai in modo che le prossime risposte al messaggio non causino pi successivi
						// invii...
						$db->query("UPDATE ".$db->prefix("messenger_messages")." SET pm_notifyreply = 0 WHERE pm_id = ".intval($orig_msg->getVar("pmid"))."");
					}
				}	
			} else {
				$errors[] = sprintf(_PM_SENDERRINBOXFULL, XoopsUser::getUnameFromId(intval($uid)));
				// Rimuove eventuali allegati...
				@unlink(XOOPS_ROOT_PATH."/modules/messenger/cache/attachments/".$pmattach);
			}
		}
		
		include_once(XOOPS_ROOT_PATH."/header.php");
		OpenTable();
		echo "<h3 align=\"left\"><b>"._PM_SENDOP."</b></h3>";
		
		if ( count($successes) > 0 ) {
			echo "<b>"._PM_MSGSUCC.":</b><br />";
			foreach ( $successes as $succ ) {
				echo $succ."<br />";
			}
			echo "<br /><br />";
		}
		
		if ( count($errors) > 0 ) {
			echo "<b>"._PM_MSGERR.":</b><br />";
			foreach ( $errors as $err ) {
				echo $err."<br />";
			}
			echo "<br /><br />";
		}
				
		echo "<center><a href=\"".XOOPS_URL."/modules/messenger/index.php\">"._IM_GOBACK."</a></center>";
		CloseTable();
		include_once(XOOPS_ROOT_PATH."/footer.php");
		exit();
	} else {
		redirect_header(XOOPS_URL."/modules/messenger/".$page."",3,_PM_NOUSERSEL);
		exit();
	}
}

include_once(XOOPS_ROOT_PATH."/header.php");

if ( !empty($_POST["previewpm"]) ) {
	OpenTable();
	echo "<b><i>"._IM_MSGPREVIEW."</i></b>:<br />----------------------------------<br /><br />";
	$msg = $_POST["pm_text"];
	if ( $_POST["sig"] == "on" ) {
		$signature = $xoopsUser->getVar("user_sig");
		if ( trim($signature) != "" ) {
			$msg.= "
			
			".$signature."";
		}
	}
	echo $myts->makeTareaData4Preview($msg,1,1,1);
	CloseTable();
}

OpenTable();
if ( intval($_POST["is_reply"]) == 1 ) {
	echo "<h3 align=\"left\"><b>"._IM_H3REPLY."</b></h3>";
} else {
	echo "<h3 align=\"left\"><b>"._IM_H3WRITE."</b></h3>";
}

include(XOOPS_ROOT_PATH."/modules/messenger/include/pmform.php");
CloseTable();

include_once(XOOPS_ROOT_PATH."/footer.php");

?>